/*----- PROTECTED REGION ID(Hipace.cpp) ENABLED START -----*/
static const char *RcsId = "$Id: Hipace.cpp,v 1.10 2020-02-18 17:20:49 alessio Exp $";
//=============================================================================
//
// file :        Hipace.cpp
//
// description : C++ source for the Hipace class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               Hipace are implemented in this file.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.10 $
// $Date: 2020-02-18 17:20:49 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <Hipace.h>
#include <HipaceClass.h>

#define MAX_DEVSTRING_LENGTH 255

/*----- PROTECTED REGION END -----*/	//	Hipace.cpp

/**
 *  Hipace class description:
 *    
 */

//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name  |  Method name
//================================================================
//  State         |  Inherited (no method)
//  Status        |  Inherited (no method)
//================================================================

//================================================================
//  Attributes managed are:
//================================================================
//  RemotePrio    |  Tango::DevBoolean	Scalar
//  SpdSwPtAtt    |  Tango::DevBoolean	Scalar
//  ErrorCode     |  Tango::DevString	Scalar
//  OvTempElec    |  Tango::DevBoolean	Scalar
//  OvTempPump    |  Tango::DevBoolean	Scalar
//  SetSpdAtt     |  Tango::DevBoolean	Scalar
//  PumpAccel     |  Tango::DevBoolean	Scalar
//  DrvCurrent    |  Tango::DevFloat	Scalar
//  OpHrsPump     |  Tango::DevULong	Scalar
//  FwVersion     |  Tango::DevString	Scalar
//  DrvVoltage    |  Tango::DevFloat	Scalar
//  OpHrsElec     |  Tango::DevULong	Scalar
//  DrvPower      |  Tango::DevULong	Scalar
//  PumpCycles    |  Tango::DevULong	Scalar
//  ElecName      |  Tango::DevString	Scalar
//  SetRotSpdHz   |  Tango::DevULong	Scalar
//  ActualSpdHz   |  Tango::DevULong	Scalar
//  NominalSpdHz  |  Tango::DevULong	Scalar
//  RUTimeSVal    |  Tango::DevULong	Scalar
//  SpdSwPt1      |  Tango::DevULong	Scalar
//  SpdSVal       |  Tango::DevFloat	Scalar
//  PwrSVal       |  Tango::DevUShort	Scalar
//  SwoffBKP      |  Tango::DevULong	Scalar
//  SwonBKP       |  Tango::DevULong	Scalar
//  StdbyVal      |  Tango::DevFloat	Scalar
//  SpdSwPt2      |  Tango::DevULong	Scalar
//  VentSpd       |  Tango::DevUShort	Scalar
//  VentTime      |  Tango::DevULong	Scalar
//  Heating       |  Tango::DevBoolean	Scalar
//  Standby       |  Tango::DevBoolean	Scalar
//  RUTimeCtrl    |  Tango::DevBoolean	Scalar
//  ErrorAckn     |  Tango::DevBoolean	Scalar
//  PumpgStatn    |  Tango::DevBoolean	Scalar
//  EnableVent    |  Tango::DevBoolean	Scalar
//  MotorPump     |  Tango::DevBoolean	Scalar
//  OpModeBKP     |  Tango::DevUShort	Scalar
//  SpdSetMode    |  Tango::DevUShort	Scalar
//  GasMode       |  Tango::DevUShort	Scalar
//  VentMode      |  Tango::DevUShort	Scalar
//  CfgAO1        |  Tango::DevUShort	Scalar
//  ErrHist       |  Tango::DevString	Spectrum  ( max = 10)
//================================================================

namespace Hipace_ns
{
/*----- PROTECTED REGION ID(Hipace::namespace_starting) ENABLED START -----*/

//	static initializations

/*----- PROTECTED REGION END -----*/	//	Hipace::namespace_starting

//--------------------------------------------------------
/**
 *	Method      : Hipace::Hipace()
 *	Description : Constructors for a Tango device
 *                implementing the classHipace
 */
//--------------------------------------------------------
Hipace::Hipace(Tango::DeviceClass *cl, string &s)
 : Serial2Client(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(Hipace::constructor_1) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::constructor_1
}
//--------------------------------------------------------
Hipace::Hipace(Tango::DeviceClass *cl, const char *s)
 : Serial2Client(cl, s)
{
	/*----- PROTECTED REGION ID(Hipace::constructor_2) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::constructor_2
}
//--------------------------------------------------------
Hipace::Hipace(Tango::DeviceClass *cl, const char *s, const char *d)
 : Serial2Client(cl, s, d)
{
	/*----- PROTECTED REGION ID(Hipace::constructor_3) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::constructor_3
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::delete_device()
 *	Description : will be called at device destruction or at init command
 */
//--------------------------------------------------------
void Hipace::delete_device()
{
	DEBUG_STREAM << "Hipace::delete_device() " << device_name << endl;
	/*----- PROTECTED REGION ID(Hipace::delete_device) ENABLED START -----*/
	
	if (attr_FwVersion_read[0])
		delete attr_FwVersion_read[0];

	if (attr_ErrorCode_read[0])
		delete attr_ErrorCode_read[0];

	if (attr_ElecName_read[0])
		delete attr_ElecName_read[0];

	for (unsigned int i=0; i<10; ++i)
		if (attr_ErrHist_read[i])
			delete attr_ErrHist_read[i];

	/*----- PROTECTED REGION END -----*/	//	Hipace::delete_device
	delete[] attr_RemotePrio_read;
	delete[] attr_SpdSwPtAtt_read;
	delete[] attr_ErrorCode_read;
	delete[] attr_OvTempElec_read;
	delete[] attr_OvTempPump_read;
	delete[] attr_SetSpdAtt_read;
	delete[] attr_PumpAccel_read;
	delete[] attr_DrvCurrent_read;
	delete[] attr_OpHrsPump_read;
	delete[] attr_FwVersion_read;
	delete[] attr_DrvVoltage_read;
	delete[] attr_OpHrsElec_read;
	delete[] attr_DrvPower_read;
	delete[] attr_PumpCycles_read;
	delete[] attr_ElecName_read;
	delete[] attr_SetRotSpdHz_read;
	delete[] attr_ActualSpdHz_read;
	delete[] attr_NominalSpdHz_read;
	delete[] attr_RUTimeSVal_read;
	delete[] attr_SpdSwPt1_read;
	delete[] attr_SpdSVal_read;
	delete[] attr_PwrSVal_read;
	delete[] attr_SwoffBKP_read;
	delete[] attr_SwonBKP_read;
	delete[] attr_StdbyVal_read;
	delete[] attr_SpdSwPt2_read;
	delete[] attr_VentSpd_read;
	delete[] attr_VentTime_read;
	delete[] attr_Heating_read;
	delete[] attr_Standby_read;
	delete[] attr_RUTimeCtrl_read;
	delete[] attr_PumpgStatn_read;
	delete[] attr_EnableVent_read;
	delete[] attr_MotorPump_read;
	delete[] attr_OpModeBKP_read;
	delete[] attr_SpdSetMode_read;
	delete[] attr_GasMode_read;
	delete[] attr_VentMode_read;
	delete[] attr_CfgAO1_read;
	delete[] attr_ErrHist_read;

	if (Tango::Util::instance()->is_svr_shutting_down()==false  &&
		Tango::Util::instance()->is_device_restarting(device_name)==false &&
		Tango::Util::instance()->is_svr_starting()==false)
	{
		//	If not shutting down call delete device for inherited object
		Serial2Client_ns::Serial2Client::delete_device();
	}
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::init_device()
 *	Description : will be called at device initialization.
 */
//--------------------------------------------------------
void Hipace::init_device()
{
	DEBUG_STREAM << "Hipace::init_device() create device " << device_name << endl;
	/*----- PROTECTED REGION ID(Hipace::init_device_before) ENABLED START -----*/
	
	//	Initialization before get_device_property() call
	mandatoryNotDefined = false;
	init_error.clear();
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::init_device_before
	
	if (Tango::Util::instance()->is_svr_starting() == false  &&
		Tango::Util::instance()->is_device_restarting(device_name)==false)
	{
		//	If not starting up call init device for inherited object
		Serial2Client_ns::Serial2Client::init_device();
	}

	//	Get the device properties from database
	get_device_property();
	
	attr_RemotePrio_read = new Tango::DevBoolean[1];
	attr_SpdSwPtAtt_read = new Tango::DevBoolean[1];
	attr_ErrorCode_read = new Tango::DevString[1];
	attr_OvTempElec_read = new Tango::DevBoolean[1];
	attr_OvTempPump_read = new Tango::DevBoolean[1];
	attr_SetSpdAtt_read = new Tango::DevBoolean[1];
	attr_PumpAccel_read = new Tango::DevBoolean[1];
	attr_DrvCurrent_read = new Tango::DevFloat[1];
	attr_OpHrsPump_read = new Tango::DevULong[1];
	attr_FwVersion_read = new Tango::DevString[1];
	attr_DrvVoltage_read = new Tango::DevFloat[1];
	attr_OpHrsElec_read = new Tango::DevULong[1];
	attr_DrvPower_read = new Tango::DevULong[1];
	attr_PumpCycles_read = new Tango::DevULong[1];
	attr_ElecName_read = new Tango::DevString[1];
	attr_SetRotSpdHz_read = new Tango::DevULong[1];
	attr_ActualSpdHz_read = new Tango::DevULong[1];
	attr_NominalSpdHz_read = new Tango::DevULong[1];
	attr_RUTimeSVal_read = new Tango::DevULong[1];
	attr_SpdSwPt1_read = new Tango::DevULong[1];
	attr_SpdSVal_read = new Tango::DevFloat[1];
	attr_PwrSVal_read = new Tango::DevUShort[1];
	attr_SwoffBKP_read = new Tango::DevULong[1];
	attr_SwonBKP_read = new Tango::DevULong[1];
	attr_StdbyVal_read = new Tango::DevFloat[1];
	attr_SpdSwPt2_read = new Tango::DevULong[1];
	attr_VentSpd_read = new Tango::DevUShort[1];
	attr_VentTime_read = new Tango::DevULong[1];
	attr_Heating_read = new Tango::DevBoolean[1];
	attr_Standby_read = new Tango::DevBoolean[1];
	attr_RUTimeCtrl_read = new Tango::DevBoolean[1];
	attr_PumpgStatn_read = new Tango::DevBoolean[1];
	attr_EnableVent_read = new Tango::DevBoolean[1];
	attr_MotorPump_read = new Tango::DevBoolean[1];
	attr_OpModeBKP_read = new Tango::DevUShort[1];
	attr_SpdSetMode_read = new Tango::DevUShort[1];
	attr_GasMode_read = new Tango::DevUShort[1];
	attr_VentMode_read = new Tango::DevUShort[1];
	attr_CfgAO1_read = new Tango::DevUShort[1];
	attr_ErrHist_read = new Tango::DevString[10];
	//	No longer if mandatory property not set. 
	if (mandatoryNotDefined)
		return;

	/*----- PROTECTED REGION ID(Hipace::init_device) ENABLED START -----*/
	try {
		attr_FwVersion_read[0] = new char[MAX_DEVSTRING_LENGTH];
		attr_ErrorCode_read[0] = new char[MAX_DEVSTRING_LENGTH];
		attr_ElecName_read[0] = new char[MAX_DEVSTRING_LENGTH];
		for (unsigned int i=0; i<10; ++i)
			attr_ErrHist_read[i] = new char[MAX_DEVSTRING_LENGTH];

		// Waiting the device
		int retries = 0;
		while(get_state2() == 9 && retries++ < 5) {
			sleep(1);
		}	

		// Flush the buffer
		try {
			string rep;
			command("", rep);
		} catch (...) { /* Ignore */ }

		query("312", attr_FwVersion_read[0]);
		query("349", attr_ElecName_read[0]);

	} catch (Tango::DevFailed &e) {
		init_error = string(e.errors[0].desc);
	} catch(...) { 
		init_error = "Unknown exception";
	}

	if (! init_error.empty()) {
		set_state(Tango::UNKNOWN);
		set_status(init_error);
		ERROR_STREAM << init_error << endl;
		assert(false);
	}

	/*----- PROTECTED REGION END -----*/	//	Hipace::init_device
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::get_device_property()
 *	Description : Read database to initialize property data members.
 */
//--------------------------------------------------------
void Hipace::get_device_property()
{
	/*----- PROTECTED REGION ID(Hipace::get_device_property_before) ENABLED START -----*/
	
	//	Initialize property data members
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::get_device_property_before

	mandatoryNotDefined = false;

	//	Read device properties from database.
	Tango::DbData	dev_prop;
	dev_prop.push_back(Tango::DbDatum("DeviceName"));
	dev_prop.push_back(Tango::DbDatum("DeviceAddress"));

	//	is there at least one property to be read ?
	if (dev_prop.size()>0)
	{
		//	Call database and extract values
		if (Tango::Util::instance()->_UseDb==true)
			get_db_device()->get_property(dev_prop);
	
		//	get instance on HipaceClass to get class property
		Tango::DbDatum	def_prop, cl_prop;
		HipaceClass	*ds_class =
			(static_cast<HipaceClass *>(get_device_class()));
		int	i = -1;

		//	Try to initialize DeviceName from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  deviceName;
		else {
			//	Try to initialize DeviceName from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  deviceName;
		}
		//	And try to extract DeviceName value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  deviceName;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize DeviceAddress from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  deviceAddress;
		else {
			//	Try to initialize DeviceAddress from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  deviceAddress;
		}
		//	And try to extract DeviceAddress value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  deviceAddress;

	}

	/*----- PROTECTED REGION ID(Hipace::get_device_property_after) ENABLED START -----*/

	if (deviceAddress.size() > 3)
		init_error = "Device Address must be three characters lenght max!";

	/*----- PROTECTED REGION END -----*/	//	Hipace::get_device_property_after
}
//--------------------------------------------------------
/**
 *	Method      : Hipace::check_mandatory_property()
 *	Description : For mandatory properties check if defined in database.
 */
//--------------------------------------------------------
void Hipace::check_mandatory_property(Tango::DbDatum &class_prop, Tango::DbDatum &dev_prop)
{
	//	Check if all properties are empty
	if (class_prop.is_empty() && dev_prop.is_empty())
	{
		TangoSys_OMemStream	tms;
		tms << endl <<"Property \'" << dev_prop.name;
		if (Tango::Util::instance()->_UseDb==true)
			tms << "\' is mandatory but not defined in database";
		else
			tms << "\' is mandatory but cannot be defined without database";
		string	status(get_status());
		status += tms.str();
		set_status(status);
		mandatoryNotDefined = true;
		/*----- PROTECTED REGION ID(Hipace::check_mandatory_property) ENABLED START -----*/
		cerr << tms.str() << " for " << device_name << endl;
		
		/*----- PROTECTED REGION END -----*/	//	Hipace::check_mandatory_property
	}
}


//--------------------------------------------------------
/**
 *	Method      : Hipace::always_executed_hook()
 *	Description : method always executed before any command is executed
 */
//--------------------------------------------------------
void Hipace::always_executed_hook()
{
	DEBUG_STREAM << "Hipace::always_executed_hook()  " << device_name << endl;
	if (mandatoryNotDefined)
	{
		string	status(get_status());
		Tango::Except::throw_exception(
					(const char *)"PROPERTY_NOT_SET",
					status.c_str(),
					(const char *)"Hipace::always_executed_hook()");
	}
	/*----- PROTECTED REGION ID(Hipace::always_executed_hook) ENABLED START -----*/
	
	//	code always executed before all requests
	if (! init_error.empty()) {
		ERROR_STREAM << init_error << endl;
		set_state(Tango::UNKNOWN);
		set_status(init_error);
		return;
	}

	try {
		string unexpanded_error, expanded_error;
		query("303", unexpanded_error);

		if (expand_error(unexpanded_error, expanded_error)) {
			strncpy(attr_ErrorCode_read[0], expanded_error.c_str(), MAX_DEVSTRING_LENGTH);
			set_status(string(expanded_error));
			if (unexpanded_error.substr(0, 3) == "Err") {
				set_state(Tango::FAULT);
			} else if (unexpanded_error.substr(0, 3) == "Wrn") {
				set_state(Tango::ALARM);
			}
		} else {
			attr_ErrorCode_read[0][0] = '\0';
			set_state(Tango::ON);
			set_status("The device is in ON state");
		}
	} catch (Tango::DevFailed &e) {
		set_state(Tango::FAULT);
		set_status(string(e.errors[0].desc));
		ERROR_STREAM << string(e.errors[0].desc) << endl;
		assert(false);
	} catch (...) {
		set_state(Tango::FAULT);
		set_status("Unknown error");
		ERROR_STREAM << "Unknown error" << endl;
		assert(false);
	}	

	/*----- PROTECTED REGION END -----*/	//	Hipace::always_executed_hook
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::read_attr_hardware()
 *	Description : Hardware acquisition for attributes
 */
//--------------------------------------------------------
void Hipace::read_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "Hipace::read_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	check_init();
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_attr_hardware
}
//--------------------------------------------------------
/**
 *	Method      : Hipace::write_attr_hardware()
 *	Description : Hardware writing for attributes
 */
//--------------------------------------------------------
void Hipace::write_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "Hipace::write_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::write_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::write_attr_hardware
}

//--------------------------------------------------------
/**
 *	Read attribute RemotePrio related method
 *	Description: Priorita` Remote
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_RemotePrio(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_RemotePrio(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_RemotePrio) ENABLED START -----*/

	query("300", attr_RemotePrio_read[0]);
	attr.set_value(attr_RemotePrio_read);

	/*----- PROTECTED REGION END -----*/	//	Hipace::read_RemotePrio
}
//--------------------------------------------------------
/**
 *	Read attribute SpdSwPtAtt related method
 *	Description: Punto di scatto velocita` raggiunto
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_SpdSwPtAtt(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_SpdSwPtAtt(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_SpdSwPtAtt) ENABLED START -----*/

	query("302", attr_SpdSwPtAtt_read[0]);
	attr.set_value(attr_SpdSwPtAtt_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_SpdSwPtAtt
}
//--------------------------------------------------------
/**
 *	Read attribute ErrorCode related method
 *	Description: Codice errore
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_ErrorCode(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_ErrorCode(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_ErrorCode) ENABLED START -----*/

	attr.set_value(attr_ErrorCode_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_ErrorCode
}
//--------------------------------------------------------
/**
 *	Read attribute OvTempElec related method
 *	Description: Sovratemperatura apparecchiatura elettronica di comando
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_OvTempElec(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_OvTempElec(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_OvTempElec) ENABLED START -----*/

	query("304", attr_OvTempElec_read[0]);
	attr.set_value(attr_OvTempElec_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_OvTempElec
}
//--------------------------------------------------------
/**
 *	Read attribute OvTempPump related method
 *	Description: Sovratemperatura pompe
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_OvTempPump(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_OvTempPump(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_OvTempPump) ENABLED START -----*/

	query("305", attr_OvTempPump_read[0]);
	attr.set_value(attr_OvTempPump_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_OvTempPump
}
//--------------------------------------------------------
/**
 *	Read attribute SetSpdAtt related method
 *	Description: Velocita` nominale raggiunta
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_SetSpdAtt(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_SetSpdAtt(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_SetSpdAtt) ENABLED START -----*/

	query("306", attr_SetSpdAtt_read[0]);
	attr.set_value(attr_SetSpdAtt_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_SetSpdAtt
}
//--------------------------------------------------------
/**
 *	Read attribute PumpAccel related method
 *	Description: Pompa accelerata
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_PumpAccel(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_PumpAccel(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_PumpAccel) ENABLED START -----*/

	query("307", attr_PumpAccel_read[0]);
	attr.set_value(attr_PumpAccel_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_PumpAccel
}
//--------------------------------------------------------
/**
 *	Read attribute DrvCurrent related method
 *	Description: Corrente di avviamento
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_DrvCurrent(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_DrvCurrent(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_DrvCurrent) ENABLED START -----*/

	query("310", attr_DrvCurrent_read[0]);
	attr.set_value(attr_DrvCurrent_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_DrvCurrent
}
//--------------------------------------------------------
/**
 *	Read attribute OpHrsPump related method
 *	Description: Ore operative pompa
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_OpHrsPump(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_OpHrsPump(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_OpHrsPump) ENABLED START -----*/

	query("311", attr_OpHrsPump_read[0]);
	attr.set_value(attr_OpHrsPump_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_OpHrsPump
}
//--------------------------------------------------------
/**
 *	Read attribute FwVersion related method
 *	Description: Versione software apparecchiatura elettronica di comando
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_FwVersion(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_FwVersion(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_FwVersion) ENABLED START -----*/
	attr.set_value(attr_FwVersion_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_FwVersion
}
//--------------------------------------------------------
/**
 *	Read attribute DrvVoltage related method
 *	Description: Tensione di avviamento
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_DrvVoltage(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_DrvVoltage(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_DrvVoltage) ENABLED START -----*/

	query("313", attr_DrvVoltage_read[0]);
	attr.set_value(attr_DrvVoltage_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_DrvVoltage
}
//--------------------------------------------------------
/**
 *	Read attribute OpHrsElec related method
 *	Description: Ore operative apparecchiatura elettronica di comando
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_OpHrsElec(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_OpHrsElec(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_OpHrsElec) ENABLED START -----*/

	query("314", attr_OpHrsElec_read[0]);
	attr.set_value(attr_OpHrsElec_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_OpHrsElec
}
//--------------------------------------------------------
/**
 *	Read attribute DrvPower related method
 *	Description: Potenza motrice
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_DrvPower(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_DrvPower(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_DrvPower) ENABLED START -----*/

	query("316", attr_DrvPower_read[0]);
	attr.set_value(attr_DrvPower_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_DrvPower
}
//--------------------------------------------------------
/**
 *	Read attribute PumpCycles related method
 *	Description: Cicli pompa
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_PumpCycles(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_PumpCycles(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_PumpCycles) ENABLED START -----*/

	query("319", attr_PumpCycles_read[0]);
	attr.set_value(attr_PumpCycles_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_PumpCycles
}
//--------------------------------------------------------
/**
 *	Read attribute ElecName related method
 *	Description: Denominazione apparecchiatura elettronica di comando
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_ElecName(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_ElecName(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_ElecName) ENABLED START -----*/
	attr.set_value(attr_ElecName_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_ElecName
}
//--------------------------------------------------------
/**
 *	Read attribute SetRotSpdHz related method
 *	Description: Velocita` nominale
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_SetRotSpdHz(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_SetRotSpdHz(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_SetRotSpdHz) ENABLED START -----*/

	query("308", attr_SetRotSpdHz_read[0]);
	attr.set_value(attr_SetRotSpdHz_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_SetRotSpdHz
}
//--------------------------------------------------------
/**
 *	Read attribute ActualSpdHz related method
 *	Description: Velocita` effettiva
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_ActualSpdHz(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_ActualSpdHz(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_ActualSpdHz) ENABLED START -----*/

	query("309", attr_ActualSpdHz_read[0]);
	attr.set_value(attr_ActualSpdHz_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_ActualSpdHz
}
//--------------------------------------------------------
/**
 *	Read attribute NominalSpdHz related method
 *	Description: Velocita` nominale
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_NominalSpdHz(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_NominalSpdHz(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_NominalSpdHz) ENABLED START -----*/

	query("315", attr_NominalSpdHz_read[0]);
	attr.set_value(attr_NominalSpdHz_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_NominalSpdHz
}
//--------------------------------------------------------
/**
 *	Read attribute RUTimeSVal related method
 *	Description: Valore nominale tempo di accelerazione
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_RUTimeSVal(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_RUTimeSVal(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_RUTimeSVal) ENABLED START -----*/

	query("700", attr_RUTimeSVal_read[0]);
	attr.set_value(attr_RUTimeSVal_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_RUTimeSVal
}
//--------------------------------------------------------
/**
 *	Write attribute RUTimeSVal related method
 *	Description: Valore nominale tempo di accelerazione
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::write_RUTimeSVal(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Hipace::write_RUTimeSVal(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevULong	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Hipace::write_RUTimeSVal) ENABLED START -----*/
	check_init();
	
	command("700", w_val);

	/*----- PROTECTED REGION END -----*/	//	Hipace::write_RUTimeSVal
}
//--------------------------------------------------------
/**
 *	Read attribute SpdSwPt1 related method
 *	Description: Punto di scatto velocita` 1
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_SpdSwPt1(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_SpdSwPt1(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_SpdSwPt1) ENABLED START -----*/

	query("701", attr_SpdSwPt1_read[0]);
	attr.set_value(attr_SpdSwPt1_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_SpdSwPt1
}
//--------------------------------------------------------
/**
 *	Write attribute SpdSwPt1 related method
 *	Description: Punto di scatto velocita` 1
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::write_SpdSwPt1(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Hipace::write_SpdSwPt1(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevULong	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Hipace::write_SpdSwPt1) ENABLED START -----*/
	check_init();
	
	command("701", w_val);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::write_SpdSwPt1
}
//--------------------------------------------------------
/**
 *	Read attribute SpdSVal related method
 *	Description: Impostazione in posizionamento velocita`
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_SpdSVal(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_SpdSVal(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_SpdSVal) ENABLED START -----*/

	query("707", attr_SpdSVal_read[0]);
	attr.set_value(attr_SpdSVal_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_SpdSVal
}
//--------------------------------------------------------
/**
 *	Write attribute SpdSVal related method
 *	Description: Impostazione in posizionamento velocita`
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::write_SpdSVal(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Hipace::write_SpdSVal(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevFloat	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Hipace::write_SpdSVal) ENABLED START -----*/
	check_init();
	
	command("707", w_val);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::write_SpdSVal
}
//--------------------------------------------------------
/**
 *	Read attribute PwrSVal related method
 *	Description: Impostazione assorbimento di potenza
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_PwrSVal(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_PwrSVal(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_PwrSVal) ENABLED START -----*/

	query("708", attr_PwrSVal_read[0]);
	attr.set_value(attr_PwrSVal_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_PwrSVal
}
//--------------------------------------------------------
/**
 *	Write attribute PwrSVal related method
 *	Description: Impostazione assorbimento di potenza
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::write_PwrSVal(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Hipace::write_PwrSVal(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevUShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Hipace::write_PwrSVal) ENABLED START -----*/
	check_init();
	
	command("708", w_val);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::write_PwrSVal
}
//--------------------------------------------------------
/**
 *	Read attribute SwoffBKP related method
 *	Description: Soglia di spegnimento pompa preliminare con funzionamento a intervalli
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_SwoffBKP(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_SwoffBKP(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_SwoffBKP) ENABLED START -----*/

	query("710", attr_SwoffBKP_read[0]);
	attr.set_value(attr_SwoffBKP_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_SwoffBKP
}
//--------------------------------------------------------
/**
 *	Write attribute SwoffBKP related method
 *	Description: Soglia di spegnimento pompa preliminare con funzionamento a intervalli
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::write_SwoffBKP(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Hipace::write_SwoffBKP(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevULong	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Hipace::write_SwoffBKP) ENABLED START -----*/
	
	command("710", w_val);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::write_SwoffBKP
}
//--------------------------------------------------------
/**
 *	Read attribute SwonBKP related method
 *	Description: Soglia di accensione pompa preliminare con funzionamento a intervalli
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_SwonBKP(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_SwonBKP(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_SwonBKP) ENABLED START -----*/

	query("711", attr_SwonBKP_read[0]);
	attr.set_value(attr_SwonBKP_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_SwonBKP
}
//--------------------------------------------------------
/**
 *	Write attribute SwonBKP related method
 *	Description: Soglia di accensione pompa preliminare con funzionamento a intervalli
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::write_SwonBKP(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Hipace::write_SwonBKP(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevULong	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Hipace::write_SwonBKP) ENABLED START -----*/
	check_init();
	
	command("711", w_val);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::write_SwonBKP
}
//--------------------------------------------------------
/**
 *	Read attribute StdbyVal related method
 *	Description: Impostazione velocita` in Standby
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_StdbyVal(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_StdbyVal(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_StdbyVal) ENABLED START -----*/

	if (strcmp(" TC600", attr_ElecName_read[0]) == 0)
		Tango::Except::throw_exception("",
				"StdbyVal parameter doesn't work on TC600 yet",
				"Hipace::read_StdbyVal()");

	query("717", attr_StdbyVal_read[0]);
	attr.set_value(attr_StdbyVal_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_StdbyVal
}
//--------------------------------------------------------
/**
 *	Write attribute StdbyVal related method
 *	Description: Impostazione velocita` in Standby
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::write_StdbyVal(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Hipace::write_StdbyVal(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevFloat	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Hipace::write_StdbyVal) ENABLED START -----*/
	check_init();

	if (strcmp("TC600", attr_ElecName_read[0]) == 0)
		Tango::Except::throw_exception("",
				"StdbyVal parameter doesn't work on TC600 yet",
				"Hipace::write_StdbyVal()");

	command("717", w_val);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::write_StdbyVal
}
//--------------------------------------------------------
/**
 *	Read attribute SpdSwPt2 related method
 *	Description: Punto di scatto velocita` 2
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_SpdSwPt2(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_SpdSwPt2(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_SpdSwPt2) ENABLED START -----*/

	query("719", attr_SpdSwPt2_read[0]);
	attr.set_value(attr_SpdSwPt2_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_SpdSwPt2
}
//--------------------------------------------------------
/**
 *	Write attribute SpdSwPt2 related method
 *	Description: Punto di scatto velocita` 2
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::write_SpdSwPt2(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Hipace::write_SpdSwPt2(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevULong	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Hipace::write_SpdSwPt2) ENABLED START -----*/
	check_init();
	
	command("719", w_val);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::write_SpdSwPt2
}
//--------------------------------------------------------
/**
 *	Read attribute VentSpd related method
 *	Description: Velocita` immissione aria con immissione ritardata
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_VentSpd(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_VentSpd(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_VentSpd) ENABLED START -----*/

	query("720", attr_VentSpd_read[0]);
	attr.set_value(attr_VentSpd_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_VentSpd
}
//--------------------------------------------------------
/**
 *	Write attribute VentSpd related method
 *	Description: Velocita` immissione aria con immissione ritardata
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::write_VentSpd(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Hipace::write_VentSpd(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevUShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Hipace::write_VentSpd) ENABLED START -----*/
	check_init();
	
	command("720", w_val);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::write_VentSpd
}
//--------------------------------------------------------
/**
 *	Read attribute VentTime related method
 *	Description: Tempo di immissione con immissione aria ritardata
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_VentTime(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_VentTime(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_VentTime) ENABLED START -----*/

	query("721", attr_VentTime_read[0]);
	attr.set_value(attr_VentTime_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_VentTime
}
//--------------------------------------------------------
/**
 *	Write attribute VentTime related method
 *	Description: Tempo di immissione con immissione aria ritardata
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::write_VentTime(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Hipace::write_VentTime(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevULong	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Hipace::write_VentTime) ENABLED START -----*/
	check_init();
	
	command("721", w_val);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::write_VentTime
}
//--------------------------------------------------------
/**
 *	Read attribute Heating related method
 *	Description: Riscaldamento
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_Heating(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_Heating(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_Heating) ENABLED START -----*/

	query("001", attr_Heating_read[0]);
	attr.set_value(attr_Heating_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_Heating
}
//--------------------------------------------------------
/**
 *	Write attribute Heating related method
 *	Description: Riscaldamento
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::write_Heating(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Hipace::write_Heating(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevBoolean	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Hipace::write_Heating) ENABLED START -----*/
	check_init();
	
	command("001", w_val);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::write_Heating
}
//--------------------------------------------------------
/**
 *	Read attribute Standby related method
 *	Description: Standby
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_Standby(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_Standby(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_Standby) ENABLED START -----*/

	query("002", attr_Standby_read[0]);
	attr.set_value(attr_Standby_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_Standby
}
//--------------------------------------------------------
/**
 *	Write attribute Standby related method
 *	Description: Standby
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::write_Standby(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Hipace::write_Standby(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevBoolean	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Hipace::write_Standby) ENABLED START -----*/
	check_init();
	
	command("002", w_val);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::write_Standby
}
//--------------------------------------------------------
/**
 *	Read attribute RUTimeCtrl related method
 *	Description: Monitoraggio tempo di accelerazione
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_RUTimeCtrl(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_RUTimeCtrl(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_RUTimeCtrl) ENABLED START -----*/

	query("004", attr_RUTimeCtrl_read[0]);
	attr.set_value(attr_RUTimeCtrl_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_RUTimeCtrl
}
//--------------------------------------------------------
/**
 *	Write attribute RUTimeCtrl related method
 *	Description: Monitoraggio tempo di accelerazione
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::write_RUTimeCtrl(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Hipace::write_RUTimeCtrl(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevBoolean	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Hipace::write_RUTimeCtrl) ENABLED START -----*/
	check_init();
	
	command("004", w_val);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::write_RUTimeCtrl
}
//--------------------------------------------------------
/**
 *	Write attribute ErrorAckn related method
 *	Description: Conferma guasti
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::write_ErrorAckn(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Hipace::write_ErrorAckn(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevBoolean	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Hipace::write_ErrorAckn) ENABLED START -----*/
	check_init();
	
	command("009", w_val);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::write_ErrorAckn
}
//--------------------------------------------------------
/**
 *	Read attribute PumpgStatn related method
 *	Description: Stato pompa
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_PumpgStatn(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_PumpgStatn(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_PumpgStatn) ENABLED START -----*/

	query("010", attr_PumpgStatn_read[0]);
	attr.set_value(attr_PumpgStatn_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_PumpgStatn
}
//--------------------------------------------------------
/**
 *	Write attribute PumpgStatn related method
 *	Description: Stato pompa
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::write_PumpgStatn(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Hipace::write_PumpgStatn(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevBoolean	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Hipace::write_PumpgStatn) ENABLED START -----*/
	check_init();
	
	command("010", w_val);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::write_PumpgStatn
}
//--------------------------------------------------------
/**
 *	Read attribute EnableVent related method
 *	Description: Rilascio immisione aria
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_EnableVent(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_EnableVent(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_EnableVent) ENABLED START -----*/

	query("012", attr_EnableVent_read[0]);
	attr.set_value(attr_EnableVent_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_EnableVent
}
//--------------------------------------------------------
/**
 *	Write attribute EnableVent related method
 *	Description: Rilascio immisione aria
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::write_EnableVent(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Hipace::write_EnableVent(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevBoolean	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Hipace::write_EnableVent) ENABLED START -----*/
	check_init();
	
	command("012", w_val);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::write_EnableVent
}
//--------------------------------------------------------
/**
 *	Read attribute MotorPump related method
 *	Description: Motore pompa
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_MotorPump(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_MotorPump(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_MotorPump) ENABLED START -----*/

	if (strcmp("TC 110", attr_ElecName_read[0]) == 0 &&
			strcmp("011100", attr_FwVersion_read[0]) == 0)
		Tango::Except::throw_exception("",
				"MotorPump parameter doesn't exist on this bogus firmware",
				"Hipace::read_MotorPump()");

	query("023", attr_MotorPump_read[0]);
	attr.set_value(attr_MotorPump_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_MotorPump
}
//--------------------------------------------------------
/**
 *	Write attribute MotorPump related method
 *	Description: Motore pompa
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::write_MotorPump(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Hipace::write_MotorPump(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevBoolean	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Hipace::write_MotorPump) ENABLED START -----*/
	check_init();
	
	if (strcmp("TC 110", attr_ElecName_read[0]) == 0 &&
			strcmp("011100", attr_FwVersion_read[0]) == 0)
		Tango::Except::throw_exception("",
				"MotorPump parameter doesn't exist on this bogus firmware",
				"Hipace::read_MotorPump()");
	command("023", w_val);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::write_MotorPump
}
//--------------------------------------------------------
/**
 *	Read attribute OpModeBKP related method
 *	Description: Tipo di azionamento pompa preliminare
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_OpModeBKP(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_OpModeBKP(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_OpModeBKP) ENABLED START -----*/

	query("025", attr_OpModeBKP_read[0]);
	attr.set_value(attr_OpModeBKP_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_OpModeBKP
}
//--------------------------------------------------------
/**
 *	Write attribute OpModeBKP related method
 *	Description: Tipo di azionamento pompa preliminare
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::write_OpModeBKP(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Hipace::write_OpModeBKP(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevUShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Hipace::write_OpModeBKP) ENABLED START -----*/
	check_init();
	
	command("025", w_val);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::write_OpModeBKP
}
//--------------------------------------------------------
/**
 *	Read attribute SpdSetMode related method
 *	Description: Modalita di posizionamento di velocita`
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_SpdSetMode(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_SpdSetMode(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_SpdSetMode) ENABLED START -----*/

	query("026", attr_SpdSetMode_read[0]);
	attr.set_value(attr_SpdSetMode_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_SpdSetMode
}
//--------------------------------------------------------
/**
 *	Write attribute SpdSetMode related method
 *	Description: Modalita di posizionamento di velocita`
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::write_SpdSetMode(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Hipace::write_SpdSetMode(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevUShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Hipace::write_SpdSetMode) ENABLED START -----*/
	check_init();
	
	command("026", w_val);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::write_SpdSetMode
}
//--------------------------------------------------------
/**
 *	Read attribute GasMode related method
 *	Description: Modalita gas
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_GasMode(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_GasMode(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_GasMode) ENABLED START -----*/

	query("027", attr_GasMode_read[0]);
	attr.set_value(attr_GasMode_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_GasMode
}
//--------------------------------------------------------
/**
 *	Write attribute GasMode related method
 *	Description: Modalita gas
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::write_GasMode(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Hipace::write_GasMode(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevUShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Hipace::write_GasMode) ENABLED START -----*/
	check_init();
	
	command("027", w_val);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::write_GasMode
}
//--------------------------------------------------------
/**
 *	Read attribute VentMode related method
 *	Description: Modalita` immissione aria
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_VentMode(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_VentMode(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_VentMode) ENABLED START -----*/

	query("030", attr_VentMode_read[0]);
	attr.set_value(attr_VentMode_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_VentMode
}
//--------------------------------------------------------
/**
 *	Write attribute VentMode related method
 *	Description: Modalita` immissione aria
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::write_VentMode(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Hipace::write_VentMode(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevUShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Hipace::write_VentMode) ENABLED START -----*/
	check_init();
	
	command("030", w_val);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::write_VentMode
}
//--------------------------------------------------------
/**
 *	Read attribute CfgAO1 related method
 *	Description: Configurazione uscita AO1
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::read_CfgAO1(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_CfgAO1(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_CfgAO1) ENABLED START -----*/

	query("055", attr_CfgAO1_read[0]);
	attr.set_value(attr_CfgAO1_read);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_CfgAO1
}
//--------------------------------------------------------
/**
 *	Write attribute CfgAO1 related method
 *	Description: Configurazione uscita AO1
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Hipace::write_CfgAO1(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Hipace::write_CfgAO1(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevUShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Hipace::write_CfgAO1) ENABLED START -----*/
	check_init();
	
	command("055", w_val);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::write_CfgAO1
}
//--------------------------------------------------------
/**
 *	Read attribute ErrHist related method
 *	Description: Cronologia codici errori
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Spectrum max = 10
 */
//--------------------------------------------------------
void Hipace::read_ErrHist(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Hipace::read_ErrHist(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Hipace::read_ErrHist) ENABLED START -----*/

	for (int i=0; i<10; ++i)
	{
		stringstream cmd;
		cmd << 360 + i << flush;
		string unexpanded_error, expanded_error;
		query(cmd.str(), unexpanded_error);

		if (expand_error(unexpanded_error, expanded_error)) {
			strncpy(attr_ErrHist_read[i], expanded_error.c_str(), MAX_DEVSTRING_LENGTH);
		} else {
			attr_ErrHist_read[i][0] = '\0';
		}
	}
	attr.set_value(attr_ErrHist_read, 10);
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::read_ErrHist
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::add_dynamic_attributes()
 *	Description : Create the dynamic attributes if any
 *                for specified device.
 */
//--------------------------------------------------------
void Hipace::add_dynamic_attributes()
{
	/*----- PROTECTED REGION ID(Hipace::add_dynamic_attributes) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic attributes if any
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::add_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::add_dynamic_commands()
 *	Description : Create the dynamic commands if any
 *                for specified device.
 */
//--------------------------------------------------------
void Hipace::add_dynamic_commands()
{
	/*----- PROTECTED REGION ID(Hipace::add_dynamic_commands) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic commands if any
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::add_dynamic_commands
}

/*----- PROTECTED REGION ID(Hipace::namespace_ending) ENABLED START -----*/

//	Additional Methods
void Hipace::check_init()
{
	if (! init_error.empty())
		Tango::Except::throw_exception( "",
				init_error.c_str(),
				"Hipace::check_init()");
}

void Hipace::compute_crc(const string &data, int &crc)
{
	crc = 0;
	for (size_t i=0; i<data.size(); ++i)
		crc += int(data[i]);
	crc %= 256;
}

void Hipace::encode_telegram(const string &action, const string &param,
		const string &data, string &telegram)
{
	stringstream tdata;

	tdata.width(3);
	tdata.fill('0');
	tdata << deviceAddress << flush;

	tdata.width(2);
	tdata.fill('0');
	tdata << action << flush;

	tdata.width(3);
	tdata.fill('0');
	tdata << param << flush;

	tdata.width(2);
	tdata.fill('0');
	tdata << data.size() << flush;

	tdata << data << flush;

	int crc;
	compute_crc(tdata.str(), crc);

	tdata.width(3);
	tdata.fill('0');
	tdata << crc << flush;

	tdata << '\r' << flush;

	telegram = tdata.str();
}

void Hipace::decode_telegram(const string &param,
		const string &telegram, string &data)
{
	stringstream conv;

	if (telegram.substr(0,3) != deviceAddress)
		Tango::Except::throw_exception("",
				"Invalid device address",
				"Hipace::decode_telegram()");

	if (telegram.substr(3,2) != "10")
		Tango::Except::throw_exception("",
				"Invalid action",
				"Hipace::decode_telegram()");

	if (telegram.substr(5,3) != param)
		Tango::Except::throw_exception("",
				"Invalid parameter number",
				"Hipace::decode_telegram()");

	conv << telegram.substr(8,2) << flush;

	size_t len;
	conv >> len;

	data = telegram.substr(10,len);

	if (len == 6) {
		if (data == "NO_DEF") {
			string mesg = "Parameter number " + param
				+ " doesn't exist";
			Tango::Except::throw_exception("",
					mesg,
					"Hipace::decode_telegram()");
		}
		if (data == "_RANGE")
			Tango::Except::throw_exception("",
					"Out of range",
					"Hipace::decode_telegram()");
		if (data == "_LOGIC")
			Tango::Except::throw_exception("",
					"Logic error",
					"Hipace::decode_telegram()");
	}

	int crc;
	compute_crc(telegram.substr(0,10+len), crc);

	conv.str("");
	conv.clear();

	conv.width(3);
	conv.fill('0');
	conv << crc << flush;

	if (telegram.substr(10+len,3) != conv.str())
		Tango::Except::throw_exception("",
				"Invalid checksum",
				"Hipace::decode_telegram()");

	if (telegram.substr(10+len+3,1) != "\r")
		Tango::Except::throw_exception("",
				"Invalid terminator",
				"Hipace::decode_telegram()");
}

void Hipace::_command(const string &action, const string &param,
		const string &data)
{
	string telegram;
	encode_telegram(action, param, data, telegram);
	write(telegram);
}

void Hipace::_command(const string &action, const string &param,
		const Tango::DevBoolean &data)
{
	string to;
	if (data == true)
		to = "111111";
	else // false
		to = "000000";
	_command(action, param, to);
}

void Hipace::_command(const string &action, const string &param,
		const Tango::DevULong &data)
{
	string to;
	stringstream conv;
	conv.width(6);
	conv.fill('0');
	conv << data << flush;
	conv >> to;
	_command(action, param, to);
}

void Hipace::_command(const string &action, const string &param,
		const Tango::DevFloat &data)
{
	string to;
	stringstream conv;
	conv.width(7);
	conv.precision(2);
	conv.fill('0');
	conv << fixed << data << flush;
	conv >> to;
	to.erase(to.find('.'), 1);
	_command(action, param, to);
}

void Hipace::_command(const string &action, const string &param,
		const Tango::DevUShort &data)
{
	string to;
	stringstream conv;
	conv.width(3);
	conv.fill('0');
	conv << data << flush;
	conv >> to;
	if (conv.fail())
		Tango::Except::throw_exception(
				"API_ConverionError",
				"Conversion fail " + conv.str(),
				"Hipace::_query()");
	_command(action, param, to);
}

void Hipace::_query(const string &param, string &argout)
{
	string telegram;
	read_until('\r', telegram);
	decode_telegram(param, telegram, argout);
}

void Hipace::_query(const string &param, Tango::DevBoolean &argout)
{
	string reply;
	_query(param, reply);
	if (reply == "111111") 
		argout = true;
	else if (reply == "000000")
		argout = false;
	else
		Tango::Except::throw_exception(
				"API_ConverionError",
				"Conversion fail " + reply,
				"Hipace::_query()");
}

void Hipace::_query(const string &param, Tango::DevULong &argout)
{
	string reply;
	_query(param, reply);
	stringstream conv;
	conv << reply << flush;
	conv >> argout;
	if (conv.fail())
		Tango::Except::throw_exception(
				"API_ConverionError",
				"Conversion fail " + conv.str(),
				"Hipace::_query()");
}

void Hipace::_query(const string &param, Tango::DevFloat &argout)
{
	string reply;
	_query(param, reply);
	stringstream conv;
	conv << reply.substr(0,4) + "." + reply.substr(4,2) << flush;
	conv >> argout;
	if (conv.fail())
		Tango::Except::throw_exception(
				"API_ConverionError",
				"Conversion fail " + conv.str(),
				"Hipace::_query()");
}

void Hipace::_query(const string &param, Tango::DevString &argout)
{
	string reply;
	_query(param, reply);
	strncpy(argout, reply.c_str(), MAX_DEVSTRING_LENGTH);
}

void Hipace::_query(const string &param, Tango::DevUShort &argout)
{
	string reply;
	_query(param, reply);
	stringstream conv;
	conv << reply << flush;
	conv >> argout;
	if (conv.fail())
		Tango::Except::throw_exception(
				"API_ConverionError",
				"Conversion fail " + conv.str(),
				"Hipace::_query()");
}

const char *Error[][2] = {
	{ "Err001", "Velocita' eccessiva" },
	{ "Err002", "Sovratensione (Possibili cause: Alimentatore utilizzato"
		" non idoneo)" },
	{ "Err006", "Errore tempo di accelerazione (Possibili cause: Tempo di"
		" accelerazione impostato troppo basso, flusso fi gas nel "
			"recipiente a causa di perdite o di valvole aperte o "
			"punto di scatto velocita' non raggiunto dopo il tempo"
			" di accelerazione)" },
	{ "Err007", "Carenza di fluido di esercizio (Possibili cause: Carenza"
		" di fluido di esercizio)" },
	{ "Err008", "Collegamento apparecchiatura di comando - pompa difettoso"
		" (Possibili cause: Collegamento alla pompa difettoso)" },
	{ "Err010", "Errore apparecchiatura interno" },
	{ "Err021", "L'apparecchiatura elettronica di comando non riconosce"
		" la pompa" },
	{ "Err043", "Errore di configurazione interno" },
	{ "Err044", "Sovratemperatura elettronica (Possibili cause: "
		"Raffredamento non sufficiente)" },
	{ "Err045", "Sovratemperatura motore (Possibili cause: Raffredamento"
		" non sufficiente)" },
	{ "Err046", "Errore di inizializzazione interno" },
	{ "Err091", "Errore apperecchiatura interno" },
	{ "Err092", "Pannello dei collegamenti sconosciuto" },
	{ "Err093", "Interpretazione temperatura motore difettosa" },
	{ "Err094", "Interpretazione temperatura elettronica difettosa" },
	{ "Err098", "Errore di comunicazione interno" },
	{ "Err107", "Errore cumulativo livello finale" },
	{ "Err108", "Misurazione velocita' difettosa" },
	{ "Err109", "Software non autorizzato" },
	{ "Err110", "Analisi fluido di esercizio difettosa" },
	{ "Err111", "Errore di comunicazione pompa fluido di esercizio" },
	{ "Err112", "Errore cumulativo pompa fluidi di esercizio" },
	{ "Err113", "Temperatura rotore non valida (Possibili cause: "
		"Misurazione non calibrata)" },
	{ "Err114", "Interpretazione temperatura livello finale difettosa" },
	{ "Err117", "Sovratemperatura parte inferiore pompa (Possibili cause: "
		"Raffredamento non sufficiente)" },
	{ "Err118", "Sovratemperatura livello finale (Possibili cause: "
		"Raffredamento non sufficiente)" },
	{ "Err119", "Sovratemperatura cuscinetto (Possibili cause: "
		"Raffredamento non sufficiente)" },
	{ "Err143", "Sovratemperatura pompa fluido di esercizio (Possibili "
		"cause: Raffredamento non sufficiente)" },
	{ "Err777", "Velocita' nominale non confermata (Possibili cause: "
		"Velocita' nominale non confermata dopo la sostituzione "
			"dell'apparecchiatura elettronica di comando)" },
	{ "Wrn001", "Tempo di riscaldamento TMS scaduto (Possibili cause: Timer"
		" interno per sorveglianza riscaldamento scaduto)" },
	{ "Wrn003", "Sensore temperatura circuito di riscaldamento TMS "
		"(Possibili cause: La temperatura TMS non e' all'interno della"
			" gamma permessa compresa fra +5 e +85 C)" },
	{ "Wrn007", "Tensione bassa / Guasto di alimentazione (Possibili cause:"
		" Guasto di alimentazione)" },
	{ "Wrn018", "Conflitto priorita' di comando (Possibili cause: Stato "
		"pompa attivato con PumpgStatn mentre l'ingresso E74 start/stop"
			" e' OFF-aperto)" },
	{ "Wrn045", "Temperatura elevata motore (Possibili cause: Raffredamento"
		" non sufficiente)" },
	{ "Wrn076", "Temperatura elettronica elevata (Possibili cause: "
		"Raffredamento non sufficiente)" },
	{ "Wrn097", "Informazione pompa non valide (Possibili cause: Dati pompa"
		" non corretti)" },
	{ "Wrn098", "Informazioni pompa incomplete (Possibili cause: "
		"Collegamento alla pompa difettoso)" },
	{ "Wrn100", "Velocita' alzata fino al valore minimo (Possibili cause: "
		"Specificazioni permesse per il controllo velocita' o standby "
			"non corretti)" },
	{ "Wrn113", "Temperatura rotore imprecisa (Possibili cause: Misurazione"
		" non calibrata)" },
	{ "Wrn115", "Interpretazione temperatura parte inferiore pompa non "
		"corretta" },
	{ "Wrn116", "Interpretazione temperatura cuscinetto non corretta" },
	{ "Wrn117", "Temperature parte inferiore pompa elevata (Possibili "
		"cause: Raffredamento non sufficiente)" },
	{ "Wrn118", "Temperatura livello finale elevata (Possibili cause: "
		"Raffredamento non sufficiente)" },
	{ "Wrn119", "Temperatura cuscinetto elevata (Possibili cause: "
		"Raffredamento non sufficiente)" },
	{ "Wrn143", "Temperatura pompa fluido di esercizio elevata (Possibili"
		" cause: Raffredamento non sufficiente)" },
	{ "Wrn168", "Ritardo elevato (Possibili cause: Velocita' di aumento "
		"della pressione troppo elevata o velocita' di immissione "
			"aria troppo alta)" },
	{ NULL, NULL } /* End */
};

bool Hipace::expand_error(const string &unexp, string &exp)
{
	for (int i=0; Error[i][0] != NULL; ++i) {
		if (strcmp(Error[i][0], unexp.c_str()) == 0) {
			exp = string(Error[i][0]) + string(" ") +  string(Error[i][1]);
			return true;
		}
	}
	return false;
}

/*----- PROTECTED REGION END -----*/	//	Hipace::namespace_ending
} //	namespace
