/*----- PROTECTED REGION ID(Hipace.h) ENABLED START -----*/
//=============================================================================
//
// file :        Hipace.h
//
// description : Include file for the Hipace class
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.5 $
// $Date: 2020-02-18 17:15:43 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef Hipace_H
#define Hipace_H

#include <tango.h>
#include <Serial2Client.h>

/*----- PROTECTED REGION END -----*/	//	Hipace.h

/**
 *  Hipace class description:
 *    
 */

namespace Hipace_ns
{
/*----- PROTECTED REGION ID(Hipace::Additional Class Declarations) ENABLED START -----*/

//	Additional Class Declarations

/*----- PROTECTED REGION END -----*/	//	Hipace::Additional Class Declarations

class Hipace : public Serial2Client_ns::Serial2Client
{

/*----- PROTECTED REGION ID(Hipace::Data Members) ENABLED START -----*/

//	Add your own data members
	string init_error;

/*----- PROTECTED REGION END -----*/	//	Hipace::Data Members

//	Device property data members
public:
	//	DeviceAddress:	Rs485`s address
	string	deviceAddress;

	bool	mandatoryNotDefined;

//	Attribute data members
public:
	Tango::DevBoolean	*attr_RemotePrio_read;
	Tango::DevBoolean	*attr_SpdSwPtAtt_read;
	Tango::DevString	*attr_ErrorCode_read;
	Tango::DevBoolean	*attr_OvTempElec_read;
	Tango::DevBoolean	*attr_OvTempPump_read;
	Tango::DevBoolean	*attr_SetSpdAtt_read;
	Tango::DevBoolean	*attr_PumpAccel_read;
	Tango::DevFloat	*attr_DrvCurrent_read;
	Tango::DevULong	*attr_OpHrsPump_read;
	Tango::DevString	*attr_FwVersion_read;
	Tango::DevFloat	*attr_DrvVoltage_read;
	Tango::DevULong	*attr_OpHrsElec_read;
	Tango::DevULong	*attr_DrvPower_read;
	Tango::DevULong	*attr_PumpCycles_read;
	Tango::DevString	*attr_ElecName_read;
	Tango::DevULong	*attr_SetRotSpdHz_read;
	Tango::DevULong	*attr_ActualSpdHz_read;
	Tango::DevULong	*attr_NominalSpdHz_read;
	Tango::DevULong	*attr_RUTimeSVal_read;
	Tango::DevULong	*attr_SpdSwPt1_read;
	Tango::DevFloat	*attr_SpdSVal_read;
	Tango::DevUShort	*attr_PwrSVal_read;
	Tango::DevULong	*attr_SwoffBKP_read;
	Tango::DevULong	*attr_SwonBKP_read;
	Tango::DevFloat	*attr_StdbyVal_read;
	Tango::DevULong	*attr_SpdSwPt2_read;
	Tango::DevUShort	*attr_VentSpd_read;
	Tango::DevULong	*attr_VentTime_read;
	Tango::DevBoolean	*attr_Heating_read;
	Tango::DevBoolean	*attr_Standby_read;
	Tango::DevBoolean	*attr_RUTimeCtrl_read;
	Tango::DevBoolean	*attr_PumpgStatn_read;
	Tango::DevBoolean	*attr_EnableVent_read;
	Tango::DevBoolean	*attr_MotorPump_read;
	Tango::DevUShort	*attr_OpModeBKP_read;
	Tango::DevUShort	*attr_SpdSetMode_read;
	Tango::DevUShort	*attr_GasMode_read;
	Tango::DevUShort	*attr_VentMode_read;
	Tango::DevUShort	*attr_CfgAO1_read;
	Tango::DevString	*attr_ErrHist_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Hipace(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Hipace(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	Hipace(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */
	~Hipace() {delete_device();};


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Read the device properties from database
	 */
	void get_device_property();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();

	/*
	 *	Check if mandatory property has been set
	 */
	 void check_mandatory_property(Tango::DbDatum &class_prop, Tango::DbDatum &dev_prop);

//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method      : Hipace::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(vector<long> &attr_list);
	//--------------------------------------------------------
	/*
	 *	Method      : Hipace::write_attr_hardware()
	 *	Description : Hardware writing for attributes.
	 */
	//--------------------------------------------------------
	virtual void write_attr_hardware(vector<long> &attr_list);

/**
 *	Attribute RemotePrio related methods
 *	Description: Priorita` Remote
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_RemotePrio(Tango::Attribute &attr);
	virtual bool is_RemotePrio_allowed(Tango::AttReqType type);
/**
 *	Attribute SpdSwPtAtt related methods
 *	Description: Punto di scatto velocita` raggiunto
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_SpdSwPtAtt(Tango::Attribute &attr);
	virtual bool is_SpdSwPtAtt_allowed(Tango::AttReqType type);
/**
 *	Attribute ErrorCode related methods
 *	Description: Codice errore
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_ErrorCode(Tango::Attribute &attr);
	virtual bool is_ErrorCode_allowed(Tango::AttReqType type);
/**
 *	Attribute OvTempElec related methods
 *	Description: Sovratemperatura apparecchiatura elettronica di comando
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_OvTempElec(Tango::Attribute &attr);
	virtual bool is_OvTempElec_allowed(Tango::AttReqType type);
/**
 *	Attribute OvTempPump related methods
 *	Description: Sovratemperatura pompe
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_OvTempPump(Tango::Attribute &attr);
	virtual bool is_OvTempPump_allowed(Tango::AttReqType type);
/**
 *	Attribute SetSpdAtt related methods
 *	Description: Velocita` nominale raggiunta
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_SetSpdAtt(Tango::Attribute &attr);
	virtual bool is_SetSpdAtt_allowed(Tango::AttReqType type);
/**
 *	Attribute PumpAccel related methods
 *	Description: Pompa accelerata
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_PumpAccel(Tango::Attribute &attr);
	virtual bool is_PumpAccel_allowed(Tango::AttReqType type);
/**
 *	Attribute DrvCurrent related methods
 *	Description: Corrente di avviamento
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
	virtual void read_DrvCurrent(Tango::Attribute &attr);
	virtual bool is_DrvCurrent_allowed(Tango::AttReqType type);
/**
 *	Attribute OpHrsPump related methods
 *	Description: Ore operative pompa
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
	virtual void read_OpHrsPump(Tango::Attribute &attr);
	virtual bool is_OpHrsPump_allowed(Tango::AttReqType type);
/**
 *	Attribute FwVersion related methods
 *	Description: Versione software apparecchiatura elettronica di comando
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_FwVersion(Tango::Attribute &attr);
	virtual bool is_FwVersion_allowed(Tango::AttReqType type);
/**
 *	Attribute DrvVoltage related methods
 *	Description: Tensione di avviamento
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
	virtual void read_DrvVoltage(Tango::Attribute &attr);
	virtual bool is_DrvVoltage_allowed(Tango::AttReqType type);
/**
 *	Attribute OpHrsElec related methods
 *	Description: Ore operative apparecchiatura elettronica di comando
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
	virtual void read_OpHrsElec(Tango::Attribute &attr);
	virtual bool is_OpHrsElec_allowed(Tango::AttReqType type);
/**
 *	Attribute DrvPower related methods
 *	Description: Potenza motrice
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
	virtual void read_DrvPower(Tango::Attribute &attr);
	virtual bool is_DrvPower_allowed(Tango::AttReqType type);
/**
 *	Attribute PumpCycles related methods
 *	Description: Cicli pompa
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
	virtual void read_PumpCycles(Tango::Attribute &attr);
	virtual bool is_PumpCycles_allowed(Tango::AttReqType type);
/**
 *	Attribute ElecName related methods
 *	Description: Denominazione apparecchiatura elettronica di comando
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_ElecName(Tango::Attribute &attr);
	virtual bool is_ElecName_allowed(Tango::AttReqType type);
/**
 *	Attribute SetRotSpdHz related methods
 *	Description: Velocita` nominale
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
	virtual void read_SetRotSpdHz(Tango::Attribute &attr);
	virtual bool is_SetRotSpdHz_allowed(Tango::AttReqType type);
/**
 *	Attribute ActualSpdHz related methods
 *	Description: Velocita` effettiva
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
	virtual void read_ActualSpdHz(Tango::Attribute &attr);
	virtual bool is_ActualSpdHz_allowed(Tango::AttReqType type);
/**
 *	Attribute NominalSpdHz related methods
 *	Description: Velocita` nominale
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
	virtual void read_NominalSpdHz(Tango::Attribute &attr);
	virtual bool is_NominalSpdHz_allowed(Tango::AttReqType type);
/**
 *	Attribute RUTimeSVal related methods
 *	Description: Valore nominale tempo di accelerazione
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
	virtual void read_RUTimeSVal(Tango::Attribute &attr);
	virtual void write_RUTimeSVal(Tango::WAttribute &attr);
	virtual bool is_RUTimeSVal_allowed(Tango::AttReqType type);
/**
 *	Attribute SpdSwPt1 related methods
 *	Description: Punto di scatto velocita` 1
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
	virtual void read_SpdSwPt1(Tango::Attribute &attr);
	virtual void write_SpdSwPt1(Tango::WAttribute &attr);
	virtual bool is_SpdSwPt1_allowed(Tango::AttReqType type);
/**
 *	Attribute SpdSVal related methods
 *	Description: Impostazione in posizionamento velocita`
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
	virtual void read_SpdSVal(Tango::Attribute &attr);
	virtual void write_SpdSVal(Tango::WAttribute &attr);
	virtual bool is_SpdSVal_allowed(Tango::AttReqType type);
/**
 *	Attribute PwrSVal related methods
 *	Description: Impostazione assorbimento di potenza
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
	virtual void read_PwrSVal(Tango::Attribute &attr);
	virtual void write_PwrSVal(Tango::WAttribute &attr);
	virtual bool is_PwrSVal_allowed(Tango::AttReqType type);
/**
 *	Attribute SwoffBKP related methods
 *	Description: Soglia di spegnimento pompa preliminare con funzionamento a intervalli
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
	virtual void read_SwoffBKP(Tango::Attribute &attr);
	virtual void write_SwoffBKP(Tango::WAttribute &attr);
	virtual bool is_SwoffBKP_allowed(Tango::AttReqType type);
/**
 *	Attribute SwonBKP related methods
 *	Description: Soglia di accensione pompa preliminare con funzionamento a intervalli
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
	virtual void read_SwonBKP(Tango::Attribute &attr);
	virtual void write_SwonBKP(Tango::WAttribute &attr);
	virtual bool is_SwonBKP_allowed(Tango::AttReqType type);
/**
 *	Attribute StdbyVal related methods
 *	Description: Impostazione velocita` in Standby
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
	virtual void read_StdbyVal(Tango::Attribute &attr);
	virtual void write_StdbyVal(Tango::WAttribute &attr);
	virtual bool is_StdbyVal_allowed(Tango::AttReqType type);
/**
 *	Attribute SpdSwPt2 related methods
 *	Description: Punto di scatto velocita` 2
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
	virtual void read_SpdSwPt2(Tango::Attribute &attr);
	virtual void write_SpdSwPt2(Tango::WAttribute &attr);
	virtual bool is_SpdSwPt2_allowed(Tango::AttReqType type);
/**
 *	Attribute VentSpd related methods
 *	Description: Velocita` immissione aria con immissione ritardata
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
	virtual void read_VentSpd(Tango::Attribute &attr);
	virtual void write_VentSpd(Tango::WAttribute &attr);
	virtual bool is_VentSpd_allowed(Tango::AttReqType type);
/**
 *	Attribute VentTime related methods
 *	Description: Tempo di immissione con immissione aria ritardata
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
	virtual void read_VentTime(Tango::Attribute &attr);
	virtual void write_VentTime(Tango::WAttribute &attr);
	virtual bool is_VentTime_allowed(Tango::AttReqType type);
/**
 *	Attribute Heating related methods
 *	Description: Riscaldamento
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_Heating(Tango::Attribute &attr);
	virtual void write_Heating(Tango::WAttribute &attr);
	virtual bool is_Heating_allowed(Tango::AttReqType type);
/**
 *	Attribute Standby related methods
 *	Description: Standby
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_Standby(Tango::Attribute &attr);
	virtual void write_Standby(Tango::WAttribute &attr);
	virtual bool is_Standby_allowed(Tango::AttReqType type);
/**
 *	Attribute RUTimeCtrl related methods
 *	Description: Monitoraggio tempo di accelerazione
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_RUTimeCtrl(Tango::Attribute &attr);
	virtual void write_RUTimeCtrl(Tango::WAttribute &attr);
	virtual bool is_RUTimeCtrl_allowed(Tango::AttReqType type);
/**
 *	Attribute ErrorAckn related methods
 *	Description: Conferma guasti
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void write_ErrorAckn(Tango::WAttribute &attr);
	virtual bool is_ErrorAckn_allowed(Tango::AttReqType type);
/**
 *	Attribute PumpgStatn related methods
 *	Description: Stato pompa
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_PumpgStatn(Tango::Attribute &attr);
	virtual void write_PumpgStatn(Tango::WAttribute &attr);
	virtual bool is_PumpgStatn_allowed(Tango::AttReqType type);
/**
 *	Attribute EnableVent related methods
 *	Description: Rilascio immisione aria
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_EnableVent(Tango::Attribute &attr);
	virtual void write_EnableVent(Tango::WAttribute &attr);
	virtual bool is_EnableVent_allowed(Tango::AttReqType type);
/**
 *	Attribute MotorPump related methods
 *	Description: Motore pompa
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_MotorPump(Tango::Attribute &attr);
	virtual void write_MotorPump(Tango::WAttribute &attr);
	virtual bool is_MotorPump_allowed(Tango::AttReqType type);
/**
 *	Attribute OpModeBKP related methods
 *	Description: Tipo di azionamento pompa preliminare
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
	virtual void read_OpModeBKP(Tango::Attribute &attr);
	virtual void write_OpModeBKP(Tango::WAttribute &attr);
	virtual bool is_OpModeBKP_allowed(Tango::AttReqType type);
/**
 *	Attribute SpdSetMode related methods
 *	Description: Modalita di posizionamento di velocita`
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
	virtual void read_SpdSetMode(Tango::Attribute &attr);
	virtual void write_SpdSetMode(Tango::WAttribute &attr);
	virtual bool is_SpdSetMode_allowed(Tango::AttReqType type);
/**
 *	Attribute GasMode related methods
 *	Description: Modalita gas
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
	virtual void read_GasMode(Tango::Attribute &attr);
	virtual void write_GasMode(Tango::WAttribute &attr);
	virtual bool is_GasMode_allowed(Tango::AttReqType type);
/**
 *	Attribute VentMode related methods
 *	Description: Modalita` immissione aria
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
	virtual void read_VentMode(Tango::Attribute &attr);
	virtual void write_VentMode(Tango::WAttribute &attr);
	virtual bool is_VentMode_allowed(Tango::AttReqType type);
/**
 *	Attribute CfgAO1 related methods
 *	Description: Configurazione uscita AO1
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
	virtual void read_CfgAO1(Tango::Attribute &attr);
	virtual void write_CfgAO1(Tango::WAttribute &attr);
	virtual bool is_CfgAO1_allowed(Tango::AttReqType type);
/**
 *	Attribute ErrHist related methods
 *	Description: Cronologia codici errori
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Spectrum max = 10
 */
	virtual void read_ErrHist(Tango::Attribute &attr);
	virtual bool is_ErrHist_allowed(Tango::AttReqType type);


	//--------------------------------------------------------
	/**
	 *	Method      : Hipace::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();




//	Command related methods
public:


	//--------------------------------------------------------
	/**
	 *	Method      : Hipace::add_dynamic_commands()
	 *	Description : Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(Hipace::Additional Method prototypes) ENABLED START -----*/

//	Additional Method prototypes
	void check_init();
	void compute_crc(const string &data, int &crc);
	void encode_telegram(const string &action, const string &param,
		const string &data, string &telegram);
	void decode_telegram(const string &param, const string &telegram, string &data);

	void _command(const string &action, const string &param, const string &data);
	void _command(const string &action, const string &param, const Tango::DevBoolean &argin); // Datatype n.0
	void _command(const string &action, const string &param, const Tango::DevULong &argin); // Datatype n.1
	void _command(const string &action, const string &param, const Tango::DevFloat &argin); // Datatype n.2
	void _command(const string &action, const string &param, const Tango::DevUShort &argin); // Datatype n.7
	template<typename T> void command(const string &param, const T &data)
	{
		_command("10", param, data);
		string data_ret;
		_query(param, data_ret);
	}

	void _query(const string &param, string &argout);
	void _query(const string &param, Tango::DevBoolean &argout); // Datatype n.0
	void _query(const string &param, Tango::DevULong &argout); // Datatype n.1
	void _query(const string &param, Tango::DevFloat &argout); // Datatype n.2
	void _query(const string &param, Tango::DevString &argout); // Datatype n.4
	void _query(const string &param, Tango::DevUShort &argout); // Datatype n.7
	template<typename T> void query(const string &param, T &argout)
	{
		_command("00", param, string("=?"));
		_query(param, argout);
	}

	static bool expand_error(const string&, string&);

/*----- PROTECTED REGION END -----*/	//	Hipace::Additional Method prototypes
};

/*----- PROTECTED REGION ID(Hipace::Additional Classes Definitions) ENABLED START -----*/

//	Additional Classes Definitions

/*----- PROTECTED REGION END -----*/	//	Hipace::Additional Classes Definitions

}	//	End of namespace

#endif   //	Hipace_H
