/*----- PROTECTED REGION ID(HipaceClass.h) ENABLED START -----*/
//=============================================================================
//
// file :        HipaceClass.h
//
// description : Include for the Hipace root class.
//               This class is the singleton class for
//                the Hipace device class.
//               It contains all properties and methods which the 
//               Hipace requires only once e.g. the commands.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.4 $
// $Date: 2020-02-18 17:15:43 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef HipaceClass_H
#define HipaceClass_H

#include <tango.h>
#include <Serial2ClientClass.h>
#include <Hipace.h>


/*----- PROTECTED REGION END -----*/	//	HipaceClass.h


namespace Hipace_ns
{
/*----- PROTECTED REGION ID(HipaceClass::classes for dynamic creation) ENABLED START -----*/


/*----- PROTECTED REGION END -----*/	//	HipaceClass::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute RemotePrio class definition
class RemotePrioAttrib: public Tango::Attr
{
public:
	RemotePrioAttrib():Attr("RemotePrio",
			Tango::DEV_BOOLEAN, Tango::READ) {};
	~RemotePrioAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_RemotePrio(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_RemotePrio_allowed(ty);}
};

//	Attribute SpdSwPtAtt class definition
class SpdSwPtAttAttrib: public Tango::Attr
{
public:
	SpdSwPtAttAttrib():Attr("SpdSwPtAtt",
			Tango::DEV_BOOLEAN, Tango::READ) {};
	~SpdSwPtAttAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_SpdSwPtAtt(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_SpdSwPtAtt_allowed(ty);}
};

//	Attribute ErrorCode class definition
class ErrorCodeAttrib: public Tango::Attr
{
public:
	ErrorCodeAttrib():Attr("ErrorCode",
			Tango::DEV_STRING, Tango::READ) {};
	~ErrorCodeAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_ErrorCode(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_ErrorCode_allowed(ty);}
};

//	Attribute OvTempElec class definition
class OvTempElecAttrib: public Tango::Attr
{
public:
	OvTempElecAttrib():Attr("OvTempElec",
			Tango::DEV_BOOLEAN, Tango::READ) {};
	~OvTempElecAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_OvTempElec(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_OvTempElec_allowed(ty);}
};

//	Attribute OvTempPump class definition
class OvTempPumpAttrib: public Tango::Attr
{
public:
	OvTempPumpAttrib():Attr("OvTempPump",
			Tango::DEV_BOOLEAN, Tango::READ) {};
	~OvTempPumpAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_OvTempPump(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_OvTempPump_allowed(ty);}
};

//	Attribute SetSpdAtt class definition
class SetSpdAttAttrib: public Tango::Attr
{
public:
	SetSpdAttAttrib():Attr("SetSpdAtt",
			Tango::DEV_BOOLEAN, Tango::READ) {};
	~SetSpdAttAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_SetSpdAtt(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_SetSpdAtt_allowed(ty);}
};

//	Attribute PumpAccel class definition
class PumpAccelAttrib: public Tango::Attr
{
public:
	PumpAccelAttrib():Attr("PumpAccel",
			Tango::DEV_BOOLEAN, Tango::READ) {};
	~PumpAccelAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_PumpAccel(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_PumpAccel_allowed(ty);}
};

//	Attribute DrvCurrent class definition
class DrvCurrentAttrib: public Tango::Attr
{
public:
	DrvCurrentAttrib():Attr("DrvCurrent",
			Tango::DEV_FLOAT, Tango::READ) {};
	~DrvCurrentAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_DrvCurrent(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_DrvCurrent_allowed(ty);}
};

//	Attribute OpHrsPump class definition
class OpHrsPumpAttrib: public Tango::Attr
{
public:
	OpHrsPumpAttrib():Attr("OpHrsPump",
			Tango::DEV_ULONG, Tango::READ) {};
	~OpHrsPumpAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_OpHrsPump(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_OpHrsPump_allowed(ty);}
};

//	Attribute FwVersion class definition
class FwVersionAttrib: public Tango::Attr
{
public:
	FwVersionAttrib():Attr("FwVersion",
			Tango::DEV_STRING, Tango::READ) {};
	~FwVersionAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_FwVersion(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_FwVersion_allowed(ty);}
};

//	Attribute DrvVoltage class definition
class DrvVoltageAttrib: public Tango::Attr
{
public:
	DrvVoltageAttrib():Attr("DrvVoltage",
			Tango::DEV_FLOAT, Tango::READ) {};
	~DrvVoltageAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_DrvVoltage(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_DrvVoltage_allowed(ty);}
};

//	Attribute OpHrsElec class definition
class OpHrsElecAttrib: public Tango::Attr
{
public:
	OpHrsElecAttrib():Attr("OpHrsElec",
			Tango::DEV_ULONG, Tango::READ) {};
	~OpHrsElecAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_OpHrsElec(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_OpHrsElec_allowed(ty);}
};

//	Attribute DrvPower class definition
class DrvPowerAttrib: public Tango::Attr
{
public:
	DrvPowerAttrib():Attr("DrvPower",
			Tango::DEV_ULONG, Tango::READ) {};
	~DrvPowerAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_DrvPower(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_DrvPower_allowed(ty);}
};

//	Attribute PumpCycles class definition
class PumpCyclesAttrib: public Tango::Attr
{
public:
	PumpCyclesAttrib():Attr("PumpCycles",
			Tango::DEV_ULONG, Tango::READ) {};
	~PumpCyclesAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_PumpCycles(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_PumpCycles_allowed(ty);}
};

//	Attribute ElecName class definition
class ElecNameAttrib: public Tango::Attr
{
public:
	ElecNameAttrib():Attr("ElecName",
			Tango::DEV_STRING, Tango::READ) {};
	~ElecNameAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_ElecName(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_ElecName_allowed(ty);}
};

//	Attribute SetRotSpdHz class definition
class SetRotSpdHzAttrib: public Tango::Attr
{
public:
	SetRotSpdHzAttrib():Attr("SetRotSpdHz",
			Tango::DEV_ULONG, Tango::READ) {};
	~SetRotSpdHzAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_SetRotSpdHz(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_SetRotSpdHz_allowed(ty);}
};

//	Attribute ActualSpdHz class definition
class ActualSpdHzAttrib: public Tango::Attr
{
public:
	ActualSpdHzAttrib():Attr("ActualSpdHz",
			Tango::DEV_ULONG, Tango::READ) {};
	~ActualSpdHzAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_ActualSpdHz(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_ActualSpdHz_allowed(ty);}
};

//	Attribute NominalSpdHz class definition
class NominalSpdHzAttrib: public Tango::Attr
{
public:
	NominalSpdHzAttrib():Attr("NominalSpdHz",
			Tango::DEV_ULONG, Tango::READ) {};
	~NominalSpdHzAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_NominalSpdHz(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_NominalSpdHz_allowed(ty);}
};

//	Attribute RUTimeSVal class definition
class RUTimeSValAttrib: public Tango::Attr
{
public:
	RUTimeSValAttrib():Attr("RUTimeSVal",
			Tango::DEV_ULONG, Tango::READ_WRITE) {};
	~RUTimeSValAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_RUTimeSVal(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Hipace *>(dev))->write_RUTimeSVal(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_RUTimeSVal_allowed(ty);}
};

//	Attribute SpdSwPt1 class definition
class SpdSwPt1Attrib: public Tango::Attr
{
public:
	SpdSwPt1Attrib():Attr("SpdSwPt1",
			Tango::DEV_ULONG, Tango::READ_WRITE) {};
	~SpdSwPt1Attrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_SpdSwPt1(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Hipace *>(dev))->write_SpdSwPt1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_SpdSwPt1_allowed(ty);}
};

//	Attribute SpdSVal class definition
class SpdSValAttrib: public Tango::Attr
{
public:
	SpdSValAttrib():Attr("SpdSVal",
			Tango::DEV_FLOAT, Tango::READ_WRITE) {};
	~SpdSValAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_SpdSVal(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Hipace *>(dev))->write_SpdSVal(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_SpdSVal_allowed(ty);}
};

//	Attribute PwrSVal class definition
class PwrSValAttrib: public Tango::Attr
{
public:
	PwrSValAttrib():Attr("PwrSVal",
			Tango::DEV_USHORT, Tango::READ_WRITE) {};
	~PwrSValAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_PwrSVal(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Hipace *>(dev))->write_PwrSVal(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_PwrSVal_allowed(ty);}
};

//	Attribute SwoffBKP class definition
class SwoffBKPAttrib: public Tango::Attr
{
public:
	SwoffBKPAttrib():Attr("SwoffBKP",
			Tango::DEV_ULONG, Tango::READ_WRITE) {};
	~SwoffBKPAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_SwoffBKP(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Hipace *>(dev))->write_SwoffBKP(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_SwoffBKP_allowed(ty);}
};

//	Attribute SwonBKP class definition
class SwonBKPAttrib: public Tango::Attr
{
public:
	SwonBKPAttrib():Attr("SwonBKP",
			Tango::DEV_ULONG, Tango::READ_WRITE) {};
	~SwonBKPAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_SwonBKP(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Hipace *>(dev))->write_SwonBKP(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_SwonBKP_allowed(ty);}
};

//	Attribute StdbyVal class definition
class StdbyValAttrib: public Tango::Attr
{
public:
	StdbyValAttrib():Attr("StdbyVal",
			Tango::DEV_FLOAT, Tango::READ_WRITE) {};
	~StdbyValAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_StdbyVal(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Hipace *>(dev))->write_StdbyVal(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_StdbyVal_allowed(ty);}
};

//	Attribute SpdSwPt2 class definition
class SpdSwPt2Attrib: public Tango::Attr
{
public:
	SpdSwPt2Attrib():Attr("SpdSwPt2",
			Tango::DEV_ULONG, Tango::READ_WRITE) {};
	~SpdSwPt2Attrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_SpdSwPt2(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Hipace *>(dev))->write_SpdSwPt2(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_SpdSwPt2_allowed(ty);}
};

//	Attribute VentSpd class definition
class VentSpdAttrib: public Tango::Attr
{
public:
	VentSpdAttrib():Attr("VentSpd",
			Tango::DEV_USHORT, Tango::READ_WRITE) {};
	~VentSpdAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_VentSpd(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Hipace *>(dev))->write_VentSpd(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_VentSpd_allowed(ty);}
};

//	Attribute VentTime class definition
class VentTimeAttrib: public Tango::Attr
{
public:
	VentTimeAttrib():Attr("VentTime",
			Tango::DEV_ULONG, Tango::READ_WRITE) {};
	~VentTimeAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_VentTime(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Hipace *>(dev))->write_VentTime(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_VentTime_allowed(ty);}
};

//	Attribute Heating class definition
class HeatingAttrib: public Tango::Attr
{
public:
	HeatingAttrib():Attr("Heating",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~HeatingAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_Heating(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Hipace *>(dev))->write_Heating(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_Heating_allowed(ty);}
};

//	Attribute Standby class definition
class StandbyAttrib: public Tango::Attr
{
public:
	StandbyAttrib():Attr("Standby",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~StandbyAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_Standby(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Hipace *>(dev))->write_Standby(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_Standby_allowed(ty);}
};

//	Attribute RUTimeCtrl class definition
class RUTimeCtrlAttrib: public Tango::Attr
{
public:
	RUTimeCtrlAttrib():Attr("RUTimeCtrl",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~RUTimeCtrlAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_RUTimeCtrl(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Hipace *>(dev))->write_RUTimeCtrl(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_RUTimeCtrl_allowed(ty);}
};

//	Attribute ErrorAckn class definition
class ErrorAcknAttrib: public Tango::Attr
{
public:
	ErrorAcknAttrib():Attr("ErrorAckn",
			Tango::DEV_BOOLEAN, Tango::WRITE) {};
	~ErrorAcknAttrib() {};
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Hipace *>(dev))->write_ErrorAckn(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_ErrorAckn_allowed(ty);}
};

//	Attribute PumpgStatn class definition
class PumpgStatnAttrib: public Tango::Attr
{
public:
	PumpgStatnAttrib():Attr("PumpgStatn",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~PumpgStatnAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_PumpgStatn(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Hipace *>(dev))->write_PumpgStatn(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_PumpgStatn_allowed(ty);}
};

//	Attribute EnableVent class definition
class EnableVentAttrib: public Tango::Attr
{
public:
	EnableVentAttrib():Attr("EnableVent",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~EnableVentAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_EnableVent(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Hipace *>(dev))->write_EnableVent(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_EnableVent_allowed(ty);}
};

//	Attribute MotorPump class definition
class MotorPumpAttrib: public Tango::Attr
{
public:
	MotorPumpAttrib():Attr("MotorPump",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~MotorPumpAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_MotorPump(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Hipace *>(dev))->write_MotorPump(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_MotorPump_allowed(ty);}
};

//	Attribute OpModeBKP class definition
class OpModeBKPAttrib: public Tango::Attr
{
public:
	OpModeBKPAttrib():Attr("OpModeBKP",
			Tango::DEV_USHORT, Tango::READ_WRITE) {};
	~OpModeBKPAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_OpModeBKP(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Hipace *>(dev))->write_OpModeBKP(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_OpModeBKP_allowed(ty);}
};

//	Attribute SpdSetMode class definition
class SpdSetModeAttrib: public Tango::Attr
{
public:
	SpdSetModeAttrib():Attr("SpdSetMode",
			Tango::DEV_USHORT, Tango::READ_WRITE) {};
	~SpdSetModeAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_SpdSetMode(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Hipace *>(dev))->write_SpdSetMode(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_SpdSetMode_allowed(ty);}
};

//	Attribute GasMode class definition
class GasModeAttrib: public Tango::Attr
{
public:
	GasModeAttrib():Attr("GasMode",
			Tango::DEV_USHORT, Tango::READ_WRITE) {};
	~GasModeAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_GasMode(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Hipace *>(dev))->write_GasMode(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_GasMode_allowed(ty);}
};

//	Attribute VentMode class definition
class VentModeAttrib: public Tango::Attr
{
public:
	VentModeAttrib():Attr("VentMode",
			Tango::DEV_USHORT, Tango::READ_WRITE) {};
	~VentModeAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_VentMode(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Hipace *>(dev))->write_VentMode(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_VentMode_allowed(ty);}
};

//	Attribute CfgAO1 class definition
class CfgAO1Attrib: public Tango::Attr
{
public:
	CfgAO1Attrib():Attr("CfgAO1",
			Tango::DEV_USHORT, Tango::READ_WRITE) {};
	~CfgAO1Attrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_CfgAO1(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Hipace *>(dev))->write_CfgAO1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_CfgAO1_allowed(ty);}
};

//	Attribute ErrHist class definition
class ErrHistAttrib: public Tango::SpectrumAttr
{
public:
	ErrHistAttrib():SpectrumAttr("ErrHist",
			Tango::DEV_STRING, Tango::READ, 10) {};
	~ErrHistAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Hipace *>(dev))->read_ErrHist(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Hipace *>(dev))->is_ErrHist_allowed(ty);}
};


/**
 *	The HipaceClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  HipaceClass : public Serial2Client_ns::Serial2ClientClass
#else
class HipaceClass : public Serial2Client_ns::Serial2ClientClass
#endif
{
	/*----- PROTECTED REGION ID(HipaceClass::Additionnal DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	HipaceClass::Additionnal DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
	
		//	Method prototypes
		static HipaceClass *init(const char *);
		static HipaceClass *instance();
		~HipaceClass();
		Tango::DbDatum	get_class_property(string &);
		Tango::DbDatum	get_default_device_property(string &);
		Tango::DbDatum	get_default_class_property(string &);
	
	protected:
		HipaceClass(string &);
		static HipaceClass *_instance;
		void command_factory();
		void attribute_factory(vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		string get_cvstag();
		string get_cvsroot();
	
	private:
		void device_factory(const Tango::DevVarStringArray *);
		void create_static_attribute_list(vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
		vector<string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname);
};

}	//	End of namespace

#endif   //	Hipace_H
