/*----- PROTECTED REGION ID(HipaceStateMachine.cpp) ENABLED START -----*/
static const char *RcsId = "$Id: HipaceStateMachine.cpp,v 1.4 2020-02-18 17:15:43 alessio Exp $";
//=============================================================================
//
// file :        HipaceStateMachine.cpp
//
// description : State machine file for the Hipace class
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.4 $
// $Date: 2020-02-18 17:15:43 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include <Hipace.h>

/*----- PROTECTED REGION END -----*/	//	Hipace::HipaceStateMachine.cpp

//================================================================
//  States   |  Description
//================================================================
//  ON       |  
//  FAULT    |  
//  ALARM    |  
//  UNKNOWN  |  


namespace Hipace_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_RemotePrio_allowed()
 *	Description : Execution allowed for RemotePrio attribute
 */
//--------------------------------------------------------
bool Hipace::is_RemotePrio_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for RemotePrio attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::RemotePrioStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::RemotePrioStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_SpdSwPtAtt_allowed()
 *	Description : Execution allowed for SpdSwPtAtt attribute
 */
//--------------------------------------------------------
bool Hipace::is_SpdSwPtAtt_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for SpdSwPtAtt attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::SpdSwPtAttStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::SpdSwPtAttStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_ErrorCode_allowed()
 *	Description : Execution allowed for ErrorCode attribute
 */
//--------------------------------------------------------
bool Hipace::is_ErrorCode_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for ErrorCode attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::ErrorCodeStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::ErrorCodeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_OvTempElec_allowed()
 *	Description : Execution allowed for OvTempElec attribute
 */
//--------------------------------------------------------
bool Hipace::is_OvTempElec_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for OvTempElec attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::OvTempElecStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::OvTempElecStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_OvTempPump_allowed()
 *	Description : Execution allowed for OvTempPump attribute
 */
//--------------------------------------------------------
bool Hipace::is_OvTempPump_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for OvTempPump attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::OvTempPumpStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::OvTempPumpStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_SetSpdAtt_allowed()
 *	Description : Execution allowed for SetSpdAtt attribute
 */
//--------------------------------------------------------
bool Hipace::is_SetSpdAtt_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for SetSpdAtt attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::SetSpdAttStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::SetSpdAttStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_PumpAccel_allowed()
 *	Description : Execution allowed for PumpAccel attribute
 */
//--------------------------------------------------------
bool Hipace::is_PumpAccel_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for PumpAccel attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::PumpAccelStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::PumpAccelStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_DrvCurrent_allowed()
 *	Description : Execution allowed for DrvCurrent attribute
 */
//--------------------------------------------------------
bool Hipace::is_DrvCurrent_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for DrvCurrent attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::DrvCurrentStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::DrvCurrentStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_OpHrsPump_allowed()
 *	Description : Execution allowed for OpHrsPump attribute
 */
//--------------------------------------------------------
bool Hipace::is_OpHrsPump_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for OpHrsPump attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::OpHrsPumpStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::OpHrsPumpStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_FwVersion_allowed()
 *	Description : Execution allowed for FwVersion attribute
 */
//--------------------------------------------------------
bool Hipace::is_FwVersion_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for FwVersion attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::FwVersionStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::FwVersionStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_DrvVoltage_allowed()
 *	Description : Execution allowed for DrvVoltage attribute
 */
//--------------------------------------------------------
bool Hipace::is_DrvVoltage_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for DrvVoltage attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::DrvVoltageStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::DrvVoltageStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_OpHrsElec_allowed()
 *	Description : Execution allowed for OpHrsElec attribute
 */
//--------------------------------------------------------
bool Hipace::is_OpHrsElec_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for OpHrsElec attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::OpHrsElecStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::OpHrsElecStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_DrvPower_allowed()
 *	Description : Execution allowed for DrvPower attribute
 */
//--------------------------------------------------------
bool Hipace::is_DrvPower_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for DrvPower attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::DrvPowerStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::DrvPowerStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_PumpCycles_allowed()
 *	Description : Execution allowed for PumpCycles attribute
 */
//--------------------------------------------------------
bool Hipace::is_PumpCycles_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for PumpCycles attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::PumpCyclesStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::PumpCyclesStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_ElecName_allowed()
 *	Description : Execution allowed for ElecName attribute
 */
//--------------------------------------------------------
bool Hipace::is_ElecName_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for ElecName attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::ElecNameStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::ElecNameStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_SetRotSpdHz_allowed()
 *	Description : Execution allowed for SetRotSpdHz attribute
 */
//--------------------------------------------------------
bool Hipace::is_SetRotSpdHz_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for SetRotSpdHz attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::SetRotSpdHzStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::SetRotSpdHzStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_ActualSpdHz_allowed()
 *	Description : Execution allowed for ActualSpdHz attribute
 */
//--------------------------------------------------------
bool Hipace::is_ActualSpdHz_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for ActualSpdHz attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::ActualSpdHzStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::ActualSpdHzStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_NominalSpdHz_allowed()
 *	Description : Execution allowed for NominalSpdHz attribute
 */
//--------------------------------------------------------
bool Hipace::is_NominalSpdHz_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for NominalSpdHz attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::NominalSpdHzStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::NominalSpdHzStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_RUTimeSVal_allowed()
 *	Description : Execution allowed for RUTimeSVal attribute
 */
//--------------------------------------------------------
bool Hipace::is_RUTimeSVal_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for RUTimeSVal attribute in Write access.
	/*----- PROTECTED REGION ID(Hipace::RUTimeSValStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::RUTimeSValStateAllowed_WRITE

	//	Not any excluded states for RUTimeSVal attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::RUTimeSValStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::RUTimeSValStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_SpdSwPt1_allowed()
 *	Description : Execution allowed for SpdSwPt1 attribute
 */
//--------------------------------------------------------
bool Hipace::is_SpdSwPt1_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for SpdSwPt1 attribute in Write access.
	/*----- PROTECTED REGION ID(Hipace::SpdSwPt1StateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::SpdSwPt1StateAllowed_WRITE

	//	Not any excluded states for SpdSwPt1 attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::SpdSwPt1StateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::SpdSwPt1StateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_SpdSVal_allowed()
 *	Description : Execution allowed for SpdSVal attribute
 */
//--------------------------------------------------------
bool Hipace::is_SpdSVal_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for SpdSVal attribute in Write access.
	/*----- PROTECTED REGION ID(Hipace::SpdSValStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::SpdSValStateAllowed_WRITE

	//	Not any excluded states for SpdSVal attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::SpdSValStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::SpdSValStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_PwrSVal_allowed()
 *	Description : Execution allowed for PwrSVal attribute
 */
//--------------------------------------------------------
bool Hipace::is_PwrSVal_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for PwrSVal attribute in Write access.
	/*----- PROTECTED REGION ID(Hipace::PwrSValStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::PwrSValStateAllowed_WRITE

	//	Not any excluded states for PwrSVal attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::PwrSValStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::PwrSValStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_SwoffBKP_allowed()
 *	Description : Execution allowed for SwoffBKP attribute
 */
//--------------------------------------------------------
bool Hipace::is_SwoffBKP_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for SwoffBKP attribute in Write access.
	/*----- PROTECTED REGION ID(Hipace::SwoffBKPStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::SwoffBKPStateAllowed_WRITE

	//	Not any excluded states for SwoffBKP attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::SwoffBKPStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::SwoffBKPStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_SwonBKP_allowed()
 *	Description : Execution allowed for SwonBKP attribute
 */
//--------------------------------------------------------
bool Hipace::is_SwonBKP_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for SwonBKP attribute in Write access.
	/*----- PROTECTED REGION ID(Hipace::SwonBKPStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::SwonBKPStateAllowed_WRITE

	//	Not any excluded states for SwonBKP attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::SwonBKPStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::SwonBKPStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_StdbyVal_allowed()
 *	Description : Execution allowed for StdbyVal attribute
 */
//--------------------------------------------------------
bool Hipace::is_StdbyVal_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for StdbyVal attribute in Write access.
	/*----- PROTECTED REGION ID(Hipace::StdbyValStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::StdbyValStateAllowed_WRITE

	//	Not any excluded states for StdbyVal attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::StdbyValStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::StdbyValStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_SpdSwPt2_allowed()
 *	Description : Execution allowed for SpdSwPt2 attribute
 */
//--------------------------------------------------------
bool Hipace::is_SpdSwPt2_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for SpdSwPt2 attribute in Write access.
	/*----- PROTECTED REGION ID(Hipace::SpdSwPt2StateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::SpdSwPt2StateAllowed_WRITE

	//	Not any excluded states for SpdSwPt2 attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::SpdSwPt2StateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::SpdSwPt2StateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_VentSpd_allowed()
 *	Description : Execution allowed for VentSpd attribute
 */
//--------------------------------------------------------
bool Hipace::is_VentSpd_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for VentSpd attribute in Write access.
	/*----- PROTECTED REGION ID(Hipace::VentSpdStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::VentSpdStateAllowed_WRITE

	//	Not any excluded states for VentSpd attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::VentSpdStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::VentSpdStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_VentTime_allowed()
 *	Description : Execution allowed for VentTime attribute
 */
//--------------------------------------------------------
bool Hipace::is_VentTime_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for VentTime attribute in Write access.
	/*----- PROTECTED REGION ID(Hipace::VentTimeStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::VentTimeStateAllowed_WRITE

	//	Not any excluded states for VentTime attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::VentTimeStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::VentTimeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_Heating_allowed()
 *	Description : Execution allowed for Heating attribute
 */
//--------------------------------------------------------
bool Hipace::is_Heating_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Heating attribute in Write access.
	/*----- PROTECTED REGION ID(Hipace::HeatingStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::HeatingStateAllowed_WRITE

	//	Not any excluded states for Heating attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::HeatingStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::HeatingStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_Standby_allowed()
 *	Description : Execution allowed for Standby attribute
 */
//--------------------------------------------------------
bool Hipace::is_Standby_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Standby attribute in Write access.
	/*----- PROTECTED REGION ID(Hipace::StandbyStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::StandbyStateAllowed_WRITE

	//	Not any excluded states for Standby attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::StandbyStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::StandbyStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_RUTimeCtrl_allowed()
 *	Description : Execution allowed for RUTimeCtrl attribute
 */
//--------------------------------------------------------
bool Hipace::is_RUTimeCtrl_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for RUTimeCtrl attribute in Write access.
	/*----- PROTECTED REGION ID(Hipace::RUTimeCtrlStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::RUTimeCtrlStateAllowed_WRITE

	//	Not any excluded states for RUTimeCtrl attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::RUTimeCtrlStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::RUTimeCtrlStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_ErrorAckn_allowed()
 *	Description : Execution allowed for ErrorAckn attribute
 */
//--------------------------------------------------------
bool Hipace::is_ErrorAckn_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for ErrorAckn attribute in Write access.
	/*----- PROTECTED REGION ID(Hipace::ErrorAcknStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::ErrorAcknStateAllowed_WRITE

	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_PumpgStatn_allowed()
 *	Description : Execution allowed for PumpgStatn attribute
 */
//--------------------------------------------------------
bool Hipace::is_PumpgStatn_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for PumpgStatn attribute in Write access.
	/*----- PROTECTED REGION ID(Hipace::PumpgStatnStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::PumpgStatnStateAllowed_WRITE

	//	Not any excluded states for PumpgStatn attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::PumpgStatnStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::PumpgStatnStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_EnableVent_allowed()
 *	Description : Execution allowed for EnableVent attribute
 */
//--------------------------------------------------------
bool Hipace::is_EnableVent_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for EnableVent attribute in Write access.
	/*----- PROTECTED REGION ID(Hipace::EnableVentStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::EnableVentStateAllowed_WRITE

	//	Not any excluded states for EnableVent attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::EnableVentStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::EnableVentStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_MotorPump_allowed()
 *	Description : Execution allowed for MotorPump attribute
 */
//--------------------------------------------------------
bool Hipace::is_MotorPump_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for MotorPump attribute in Write access.
	/*----- PROTECTED REGION ID(Hipace::MotorPumpStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::MotorPumpStateAllowed_WRITE

	//	Not any excluded states for MotorPump attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::MotorPumpStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::MotorPumpStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_OpModeBKP_allowed()
 *	Description : Execution allowed for OpModeBKP attribute
 */
//--------------------------------------------------------
bool Hipace::is_OpModeBKP_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for OpModeBKP attribute in Write access.
	/*----- PROTECTED REGION ID(Hipace::OpModeBKPStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::OpModeBKPStateAllowed_WRITE

	//	Not any excluded states for OpModeBKP attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::OpModeBKPStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::OpModeBKPStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_SpdSetMode_allowed()
 *	Description : Execution allowed for SpdSetMode attribute
 */
//--------------------------------------------------------
bool Hipace::is_SpdSetMode_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for SpdSetMode attribute in Write access.
	/*----- PROTECTED REGION ID(Hipace::SpdSetModeStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::SpdSetModeStateAllowed_WRITE

	//	Not any excluded states for SpdSetMode attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::SpdSetModeStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::SpdSetModeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_GasMode_allowed()
 *	Description : Execution allowed for GasMode attribute
 */
//--------------------------------------------------------
bool Hipace::is_GasMode_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for GasMode attribute in Write access.
	/*----- PROTECTED REGION ID(Hipace::GasModeStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::GasModeStateAllowed_WRITE

	//	Not any excluded states for GasMode attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::GasModeStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::GasModeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_VentMode_allowed()
 *	Description : Execution allowed for VentMode attribute
 */
//--------------------------------------------------------
bool Hipace::is_VentMode_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for VentMode attribute in Write access.
	/*----- PROTECTED REGION ID(Hipace::VentModeStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::VentModeStateAllowed_WRITE

	//	Not any excluded states for VentMode attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::VentModeStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::VentModeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_CfgAO1_allowed()
 *	Description : Execution allowed for CfgAO1 attribute
 */
//--------------------------------------------------------
bool Hipace::is_CfgAO1_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for CfgAO1 attribute in Write access.
	/*----- PROTECTED REGION ID(Hipace::CfgAO1StateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::CfgAO1StateAllowed_WRITE

	//	Not any excluded states for CfgAO1 attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::CfgAO1StateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::CfgAO1StateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Hipace::is_ErrHist_allowed()
 *	Description : Execution allowed for ErrHist attribute
 */
//--------------------------------------------------------
bool Hipace::is_ErrHist_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for ErrHist attribute in read access.
	/*----- PROTECTED REGION ID(Hipace::ErrHistStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Hipace::ErrHistStateAllowed_READ
	return true;
}


//=================================================
//		Commands Allowed Methods
//=================================================


/*----- PROTECTED REGION ID(Hipace::HipaceStateAllowed.AdditionalMethods) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	Hipace::HipaceStateAllowed.AdditionalMethods

}	//	End of namespace
