/*----- PROTECTED REGION ID(Tc110.cpp) ENABLED START -----*/
static const char *RcsId = "$Id: Tc110.cpp,v 1.5 2014-05-07 14:47:45 alessio Exp $";
//=============================================================================
//
// file :        Tc110.cpp
//
// description : C++ source for the Tc110 class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               Tc110 are implemented in this file.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.5 $
// $Date: 2014-05-07 14:47:45 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <Tc110.h>
#include <Tc110Class.h>

#define MAX_DEVSTRING_LENGTH 255

/*----- PROTECTED REGION END -----*/	//	Tc110.cpp

/**
 *  Tc110 class description:
 *    
 */

//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name  |  Method name
//================================================================
//  State         |  Inherited (no method)
//  Status        |  Inherited (no method)
//================================================================

//================================================================
//  Attributes managed are:
//================================================================
//  FwVersion      |  Tango::DevString	Scalar
//  RemotePrio     |  Tango::DevBoolean	Scalar
//  SpdSwPtAtt     |  Tango::DevBoolean	Scalar
//  ErrorCode      |  Tango::DevString	Scalar
//  OvTempElec     |  Tango::DevBoolean	Scalar
//  OvTempPump     |  Tango::DevBoolean	Scalar
//  SetSpdAtt      |  Tango::DevBoolean	Scalar
//  PumpAccel      |  Tango::DevBoolean	Scalar
//  DrvCurrent     |  Tango::DevFloat	Scalar
//  OpHrsPump      |  Tango::DevULong	Scalar
//  DrvVoltage     |  Tango::DevFloat	Scalar
//  OpHrsElec      |  Tango::DevULong	Scalar
//  DrvPower       |  Tango::DevULong	Scalar
//  PumpCycles     |  Tango::DevULong	Scalar
//  ElecName       |  Tango::DevString	Scalar
//  RUTimeSVal     |  Tango::DevULong	Scalar
//  SpdSwPt1       |  Tango::DevULong	Scalar
//  SpdSVal        |  Tango::DevFloat	Scalar
//  PwrSVal        |  Tango::DevUShort	Scalar
//  SwoffBKP       |  Tango::DevULong	Scalar
//  SwonBKP        |  Tango::DevULong	Scalar
//  StdbyVal       |  Tango::DevFloat	Scalar
//  SpdSwPt2       |  Tango::DevULong	Scalar
//  VentSpd        |  Tango::DevUShort	Scalar
//  VentTime       |  Tango::DevULong	Scalar
//  Heating        |  Tango::DevBoolean	Scalar
//  Standby        |  Tango::DevBoolean	Scalar
//  RUTimeCtrl     |  Tango::DevBoolean	Scalar
//  ErrorAckn      |  Tango::DevBoolean	Scalar
//  PumpgStatn     |  Tango::DevBoolean	Scalar
//  EnableVent     |  Tango::DevBoolean	Scalar
//  MotorPump      |  Tango::DevBoolean	Scalar
//  OpModeBKP      |  Tango::DevUShort	Scalar
//  SpdSetMode     |  Tango::DevUShort	Scalar
//  GasMode        |  Tango::DevUShort	Scalar
//  VentMode       |  Tango::DevUShort	Scalar
//  CfgAO1         |  Tango::DevUShort	Scalar
//  CfgSpdSwPt     |  Tango::DevUShort	Scalar
//  CfgDO2         |  Tango::DevUShort	Scalar
//  CfgAccA1       |  Tango::DevUShort	Scalar
//  CfgAccB1       |  Tango::DevUShort	Scalar
//  CfgAccA2       |  Tango::DevUShort	Scalar
//  CfgAccB2       |  Tango::DevUShort	Scalar
//  SealingGas     |  Tango::DevBoolean	Scalar
//  CtrlViaInt     |  Tango::DevUShort	Scalar
//  IntSelLckd     |  Tango::DevBoolean	Scalar
//  CfgDO1         |  Tango::DevUShort	Scalar
//  TempElec       |  Tango::DevULong	Scalar
//  TempPmpBot     |  Tango::DevULong	Scalar
//  AccelDecel     |  Tango::DevULong	Scalar
//  TempBearng     |  Tango::DevULong	Scalar
//  TempMotor      |  Tango::DevULong	Scalar
//  HwVersion      |  Tango::DevString	Scalar
//  NomSpdConf     |  Tango::DevULong	Scalar
//  SetRotSpdRpm   |  Tango::DevULong	Scalar
//  ActualSpdRpm   |  Tango::DevULong	Scalar
//  NominalSpdRpm  |  Tango::DevULong	Scalar
//  SetRotSpdHz    |  Tango::DevULong	Scalar
//  ActualSpdHz    |  Tango::DevULong	Scalar
//  NominalSpdHz   |  Tango::DevULong	Scalar
//  ErrHist        |  Tango::DevString	Spectrum  ( max = 10)
//================================================================

namespace Tc110_ns
{
/*----- PROTECTED REGION ID(Tc110::namespace_starting) ENABLED START -----*/

//	static initializations

/*----- PROTECTED REGION END -----*/	//	Tc110::namespace_starting

//--------------------------------------------------------
/**
 *	Method      : Tc110::Tc110()
 *	Description : Constructors for a Tango device
 *                implementing the classTc110
 */
//--------------------------------------------------------
Tc110::Tc110(Tango::DeviceClass *cl, string &s)
 : Hipace(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(Tc110::constructor_1) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::constructor_1
}
//--------------------------------------------------------
Tc110::Tc110(Tango::DeviceClass *cl, const char *s)
 : Hipace(cl, s)
{
	/*----- PROTECTED REGION ID(Tc110::constructor_2) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::constructor_2
}
//--------------------------------------------------------
Tc110::Tc110(Tango::DeviceClass *cl, const char *s, const char *d)
 : Hipace(cl, s, d)
{
	/*----- PROTECTED REGION ID(Tc110::constructor_3) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::constructor_3
}

//--------------------------------------------------------
/**
 *	Method      : Tc110::delete_device()
 *	Description : will be called at device destruction or at init command
 */
//--------------------------------------------------------
void Tc110::delete_device()
{
	DEBUG_STREAM << "Tc110::delete_device() " << device_name << endl;
	/*----- PROTECTED REGION ID(Tc110::delete_device) ENABLED START -----*/
	
	//	Delete device allocated objects
	if (attr_HwVersion_read[0])
		delete attr_HwVersion_read[0];

	
	/*----- PROTECTED REGION END -----*/	//	Tc110::delete_device
	delete[] attr_CfgSpdSwPt_read;
	delete[] attr_CfgDO2_read;
	delete[] attr_CfgAccA1_read;
	delete[] attr_CfgAccB1_read;
	delete[] attr_CfgAccA2_read;
	delete[] attr_CfgAccB2_read;
	delete[] attr_SealingGas_read;
	delete[] attr_CtrlViaInt_read;
	delete[] attr_IntSelLckd_read;
	delete[] attr_CfgDO1_read;
	delete[] attr_TempElec_read;
	delete[] attr_TempPmpBot_read;
	delete[] attr_AccelDecel_read;
	delete[] attr_TempBearng_read;
	delete[] attr_TempMotor_read;
	delete[] attr_HwVersion_read;
	delete[] attr_NomSpdConf_read;
	delete[] attr_SetRotSpdRpm_read;
	delete[] attr_ActualSpdRpm_read;
	delete[] attr_NominalSpdRpm_read;

	if (Tango::Util::instance()->is_svr_shutting_down()==false  &&
		Tango::Util::instance()->is_device_restarting(device_name)==false &&
		Tango::Util::instance()->is_svr_starting()==false)
	{
		//	If not shutting down call delete device for inherited object
		Hipace_ns::Hipace::delete_device();
	}
}

//--------------------------------------------------------
/**
 *	Method      : Tc110::init_device()
 *	Description : will be called at device initialization.
 */
//--------------------------------------------------------
void Tc110::init_device()
{
	DEBUG_STREAM << "Tc110::init_device() create device " << device_name << endl;
	/*----- PROTECTED REGION ID(Tc110::init_device_before) ENABLED START -----*/
	
	//	Initialization before get_device_property() call
	mandatoryNotDefined = false;
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::init_device_before
	
	if (Tango::Util::instance()->is_svr_starting() == false  &&
		Tango::Util::instance()->is_device_restarting(device_name)==false)
	{
		//	If not starting up call init device for inherited object
		Hipace_ns::Hipace::init_device();
	}
	//	No device property to be read from database
	
	attr_CfgSpdSwPt_read = new Tango::DevUShort[1];
	attr_CfgDO2_read = new Tango::DevUShort[1];
	attr_CfgAccA1_read = new Tango::DevUShort[1];
	attr_CfgAccB1_read = new Tango::DevUShort[1];
	attr_CfgAccA2_read = new Tango::DevUShort[1];
	attr_CfgAccB2_read = new Tango::DevUShort[1];
	attr_SealingGas_read = new Tango::DevBoolean[1];
	attr_CtrlViaInt_read = new Tango::DevUShort[1];
	attr_IntSelLckd_read = new Tango::DevBoolean[1];
	attr_CfgDO1_read = new Tango::DevUShort[1];
	attr_TempElec_read = new Tango::DevULong[1];
	attr_TempPmpBot_read = new Tango::DevULong[1];
	attr_AccelDecel_read = new Tango::DevULong[1];
	attr_TempBearng_read = new Tango::DevULong[1];
	attr_TempMotor_read = new Tango::DevULong[1];
	attr_HwVersion_read = new Tango::DevString[1];
	attr_NomSpdConf_read = new Tango::DevULong[1];
	attr_SetRotSpdRpm_read = new Tango::DevULong[1];
	attr_ActualSpdRpm_read = new Tango::DevULong[1];
	attr_NominalSpdRpm_read = new Tango::DevULong[1];
	//	No longer if mandatory property not set. 
	if (mandatoryNotDefined)
		return;

	/*----- PROTECTED REGION ID(Tc110::init_device) ENABLED START -----*/
	
	//	Initialize device
	attr_HwVersion_read[0] = new char[MAX_DEVSTRING_LENGTH];
			
	/*----- PROTECTED REGION END -----*/	//	Tc110::init_device
}


//--------------------------------------------------------
/**
 *	Method      : Tc110::always_executed_hook()
 *	Description : method always executed before any command is executed
 */
//--------------------------------------------------------
void Tc110::always_executed_hook()
{
	DEBUG_STREAM << "Tc110::always_executed_hook()  " << device_name << endl;
	if (mandatoryNotDefined)
	{
		string	status(get_status());
		Tango::Except::throw_exception(
					(const char *)"PROPERTY_NOT_SET",
					status.c_str(),
					(const char *)"Tc110::always_executed_hook()");
	}
	/*----- PROTECTED REGION ID(Tc110::always_executed_hook) ENABLED START -----*/
	
	//	code always executed before all requests
	Hipace_ns::Hipace::always_executed_hook();
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::always_executed_hook
}

//--------------------------------------------------------
/**
 *	Method      : Tc110::read_attr_hardware()
 *	Description : Hardware acquisition for attributes
 */
//--------------------------------------------------------
void Tc110::read_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "Tc110::read_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc110::read_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	check_init();
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::read_attr_hardware
}
//--------------------------------------------------------
/**
 *	Method      : Tc110::write_attr_hardware()
 *	Description : Hardware writing for attributes
 */
//--------------------------------------------------------
void Tc110::write_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "Tc110::write_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc110::write_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::write_attr_hardware
}

//--------------------------------------------------------
/**
 *	Read attribute CfgSpdSwPt related method
 *	Description: Configurazione del punto di scatto velocita`
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc110::read_CfgSpdSwPt(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tc110::read_CfgSpdSwPt(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc110::read_CfgSpdSwPt) ENABLED START -----*/
	//	Set the attribute value

 	query("017", attr_CfgSpdSwPt_read[0]);
	attr.set_value(attr_CfgSpdSwPt_read);
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::read_CfgSpdSwPt
}
//--------------------------------------------------------
/**
 *	Write attribute CfgSpdSwPt related method
 *	Description: Configurazione del punto di scatto velocita`
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc110::write_CfgSpdSwPt(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Tc110::write_CfgSpdSwPt(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevUShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Tc110::write_CfgSpdSwPt) ENABLED START -----*/
	check_init();
 	command("017", w_val);
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::write_CfgSpdSwPt
}
//--------------------------------------------------------
/**
 *	Read attribute CfgDO2 related method
 *	Description: Configurazione uscita DO2
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc110::read_CfgDO2(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tc110::read_CfgDO2(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc110::read_CfgDO2) ENABLED START -----*/
	//	Set the attribute value

 	query("019", attr_CfgDO2_read[0]);
	attr.set_value(attr_CfgDO2_read);
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::read_CfgDO2
}
//--------------------------------------------------------
/**
 *	Write attribute CfgDO2 related method
 *	Description: Configurazione uscita DO2
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc110::write_CfgDO2(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Tc110::write_CfgDO2(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevUShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Tc110::write_CfgDO2) ENABLED START -----*/

	check_init();	
 	command("019", w_val);

	/*----- PROTECTED REGION END -----*/	//	Tc110::write_CfgDO2
}
//--------------------------------------------------------
/**
 *	Read attribute CfgAccA1 related method
 *	Description: Configurazione attacco accessori A1
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc110::read_CfgAccA1(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tc110::read_CfgAccA1(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc110::read_CfgAccA1) ENABLED START -----*/
	//	Set the attribute value

 	query("035", attr_CfgAccA1_read[0]);
	attr.set_value(attr_CfgAccA1_read);
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::read_CfgAccA1
}
//--------------------------------------------------------
/**
 *	Write attribute CfgAccA1 related method
 *	Description: Configurazione attacco accessori A1
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc110::write_CfgAccA1(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Tc110::write_CfgAccA1(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevUShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Tc110::write_CfgAccA1) ENABLED START -----*/

	check_init();	
 	command("035", w_val);
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::write_CfgAccA1
}
//--------------------------------------------------------
/**
 *	Read attribute CfgAccB1 related method
 *	Description: Configurazione attacco accessori B1
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc110::read_CfgAccB1(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tc110::read_CfgAccB1(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc110::read_CfgAccB1) ENABLED START -----*/
	//	Set the attribute value

 	query("036", attr_CfgAccB1_read[0]);
	attr.set_value(attr_CfgAccB1_read);
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::read_CfgAccB1
}
//--------------------------------------------------------
/**
 *	Write attribute CfgAccB1 related method
 *	Description: Configurazione attacco accessori B1
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc110::write_CfgAccB1(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Tc110::write_CfgAccB1(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevUShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Tc110::write_CfgAccB1) ENABLED START -----*/

	check_init();	
 	command("036", w_val);
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::write_CfgAccB1
}
//--------------------------------------------------------
/**
 *	Read attribute CfgAccA2 related method
 *	Description: Configurazione attacco accessori A2
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc110::read_CfgAccA2(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tc110::read_CfgAccA2(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc110::read_CfgAccA2) ENABLED START -----*/
	//	Set the attribute value

 	query("037", attr_CfgAccA2_read[0]);
	attr.set_value(attr_CfgAccA2_read);
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::read_CfgAccA2
}
//--------------------------------------------------------
/**
 *	Write attribute CfgAccA2 related method
 *	Description: Configurazione attacco accessori A2
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc110::write_CfgAccA2(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Tc110::write_CfgAccA2(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevUShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Tc110::write_CfgAccA2) ENABLED START -----*/
	
	check_init();
 	command("037", w_val);
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::write_CfgAccA2
}
//--------------------------------------------------------
/**
 *	Read attribute CfgAccB2 related method
 *	Description: Configurazione attacco accessori B2
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc110::read_CfgAccB2(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tc110::read_CfgAccB2(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc110::read_CfgAccB2) ENABLED START -----*/
	//	Set the attribute value

 	query("038", attr_CfgAccB2_read[0]);
	attr.set_value(attr_CfgAccB2_read);
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::read_CfgAccB2
}
//--------------------------------------------------------
/**
 *	Write attribute CfgAccB2 related method
 *	Description: Configurazione attacco accessori B2
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc110::write_CfgAccB2(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Tc110::write_CfgAccB2(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevUShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Tc110::write_CfgAccB2) ENABLED START -----*/
	
	check_init();
 	command("038", w_val);
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::write_CfgAccB2
}
//--------------------------------------------------------
/**
 *	Read attribute SealingGas related method
 *	Description: Gas di sbarramento
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc110::read_SealingGas(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tc110::read_SealingGas(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc110::read_SealingGas) ENABLED START -----*/
	//	Set the attribute value

 	query("050", attr_SealingGas_read[0]);
	attr.set_value(attr_SealingGas_read);
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::read_SealingGas
}
//--------------------------------------------------------
/**
 *	Write attribute SealingGas related method
 *	Description: Gas di sbarramento
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc110::write_SealingGas(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Tc110::write_SealingGas(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevBoolean	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Tc110::write_SealingGas) ENABLED START -----*/

	check_init();	
 	command("050", w_val);
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::write_SealingGas
}
//--------------------------------------------------------
/**
 *	Read attribute CtrlViaInt related method
 *	Description: Comando tramite interfaccia
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc110::read_CtrlViaInt(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tc110::read_CtrlViaInt(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc110::read_CtrlViaInt) ENABLED START -----*/
	//	Set the attribute value

 	query("060", attr_CtrlViaInt_read[0]);
	attr.set_value(attr_CtrlViaInt_read);
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::read_CtrlViaInt
}
//--------------------------------------------------------
/**
 *	Read attribute IntSelLckd related method
 *	Description: Selezione interfaccia bloccata
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc110::read_IntSelLckd(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tc110::read_IntSelLckd(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc110::read_IntSelLckd) ENABLED START -----*/
	//	Set the attribute value

 	query("061", attr_IntSelLckd_read[0]);
	attr.set_value(attr_IntSelLckd_read);
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::read_IntSelLckd
}
//--------------------------------------------------------
/**
 *	Read attribute CfgDO1 related method
 *	Description: Configurazione uscita DO1
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc110::read_CfgDO1(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tc110::read_CfgDO1(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc110::read_CfgDO1) ENABLED START -----*/
	//	Set the attribute value

 	query("024", attr_CfgDO1_read[0]);
	attr.set_value(attr_CfgDO1_read);
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::read_CfgDO1
}
//--------------------------------------------------------
/**
 *	Write attribute CfgDO1 related method
 *	Description: Configurazione uscita DO1
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc110::write_CfgDO1(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Tc110::write_CfgDO1(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevUShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Tc110::write_CfgDO1) ENABLED START -----*/
	
	check_init();
 	command("024", w_val);
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::write_CfgDO1
}
//--------------------------------------------------------
/**
 *	Read attribute TempElec related method
 *	Description: Temperatura elettronica
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc110::read_TempElec(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tc110::read_TempElec(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc110::read_TempElec) ENABLED START -----*/
	//	Set the attribute value

 	query("326", attr_TempElec_read[0]);
	attr.set_value(attr_TempElec_read);
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::read_TempElec
}
//--------------------------------------------------------
/**
 *	Read attribute TempPmpBot related method
 *	Description: Temperatura parte inferiore pompa
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc110::read_TempPmpBot(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tc110::read_TempPmpBot(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc110::read_TempPmpBot) ENABLED START -----*/
	//	Set the attribute value

 	query("330", attr_TempPmpBot_read[0]);
	attr.set_value(attr_TempPmpBot_read);
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::read_TempPmpBot
}
//--------------------------------------------------------
/**
 *	Read attribute AccelDecel related method
 *	Description: Accelerazione/Decelerazione
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc110::read_AccelDecel(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tc110::read_AccelDecel(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc110::read_AccelDecel) ENABLED START -----*/
	//	Set the attribute value

 	query("336", attr_AccelDecel_read[0]);
	attr.set_value(attr_AccelDecel_read);
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::read_AccelDecel
}
//--------------------------------------------------------
/**
 *	Read attribute TempBearng related method
 *	Description: Temperatura cuscinetto
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc110::read_TempBearng(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tc110::read_TempBearng(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc110::read_TempBearng) ENABLED START -----*/
	//	Set the attribute value

 	query("342", attr_TempBearng_read[0]);
	attr.set_value(attr_TempBearng_read);
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::read_TempBearng
}
//--------------------------------------------------------
/**
 *	Read attribute TempMotor related method
 *	Description: Temperatura motore
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc110::read_TempMotor(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tc110::read_TempMotor(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc110::read_TempMotor) ENABLED START -----*/
	//	Set the attribute value

 	query("346", attr_TempMotor_read[0]);
	attr.set_value(attr_TempMotor_read);
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::read_TempMotor
}
//--------------------------------------------------------
/**
 *	Read attribute HwVersion related method
 *	Description: Versione hardware apparecchiatura elettronica di comando
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc110::read_HwVersion(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tc110::read_HwVersion(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc110::read_HwVersion) ENABLED START -----*/
	//	Set the attribute value

 	query("354", attr_HwVersion_read[0]);
	attr.set_value(attr_HwVersion_read);
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::read_HwVersion
}
//--------------------------------------------------------
/**
 *	Read attribute NomSpdConf related method
 *	Description: Conferma velocita` nominale
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc110::read_NomSpdConf(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tc110::read_NomSpdConf(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc110::read_NomSpdConf) ENABLED START -----*/
	//	Set the attribute value

 	query("777", attr_NomSpdConf_read[0]);
	attr.set_value(attr_NomSpdConf_read);
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::read_NomSpdConf
}
//--------------------------------------------------------
/**
 *	Write attribute NomSpdConf related method
 *	Description: Conferma velocita` nominale
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc110::write_NomSpdConf(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Tc110::write_NomSpdConf(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevULong	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Tc110::write_NomSpdConf) ENABLED START -----*/
	
	check_init();
 	command("777", w_val);
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::write_NomSpdConf
}
//--------------------------------------------------------
/**
 *	Read attribute SetRotSpdRpm related method
 *	Description: Velocita` nominale
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc110::read_SetRotSpdRpm(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tc110::read_SetRotSpdRpm(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc110::read_SetRotSpdRpm) ENABLED START -----*/
	//	Set the attribute value

  	query("397", attr_SetRotSpdRpm_read[0]);
	attr.set_value(attr_SetRotSpdRpm_read);
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::read_SetRotSpdRpm
}
//--------------------------------------------------------
/**
 *	Read attribute ActualSpdRpm related method
 *	Description: Velocita` effettiva
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc110::read_ActualSpdRpm(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tc110::read_ActualSpdRpm(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc110::read_ActualSpdRpm) ENABLED START -----*/
	//	Set the attribute value

  	query("398", attr_ActualSpdRpm_read[0]);
	attr.set_value(attr_ActualSpdRpm_read);
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::read_ActualSpdRpm
}
//--------------------------------------------------------
/**
 *	Read attribute NominalSpdRpm related method
 *	Description: Velocita` nominale
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc110::read_NominalSpdRpm(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tc110::read_NominalSpdRpm(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc110::read_NominalSpdRpm) ENABLED START -----*/
	//	Set the attribute value

  	query("399", attr_NominalSpdRpm_read[0]);
	attr.set_value(attr_NominalSpdRpm_read);

	/*----- PROTECTED REGION END -----*/	//	Tc110::read_NominalSpdRpm
}

//--------------------------------------------------------
/**
 *	Method      : Tc110::add_dynamic_attributes()
 *	Description : Create the dynamic attributes if any
 *                for specified device.
 */
//--------------------------------------------------------
void Tc110::add_dynamic_attributes()
{
	/*----- PROTECTED REGION ID(Tc110::add_dynamic_attributes) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic attributes if any
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::add_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : Tc110::add_dynamic_commands()
 *	Description : Create the dynamic commands if any
 *                for specified device.
 */
//--------------------------------------------------------
void Tc110::add_dynamic_commands()
{
	/*----- PROTECTED REGION ID(Tc110::add_dynamic_commands) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic commands if any
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::add_dynamic_commands
}

/*----- PROTECTED REGION ID(Tc110::namespace_ending) ENABLED START -----*/

//	Additional Methods
/*----- PROTECTED REGION END -----*/	//	Tc110::namespace_ending
} //	namespace
