/*----- PROTECTED REGION ID(Tc110.h) ENABLED START -----*/
//=============================================================================
//
// file :        Tc110.h
//
// description : Include file for the Tc110 class
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.4 $
// $Date: 2014-05-07 14:47:45 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef Tc110_H
#define Tc110_H

#include <tango.h>
#include <Hipace.h>


/*----- PROTECTED REGION END -----*/	//	Tc110.h

/**
 *  Tc110 class description:
 *    
 */

namespace Tc110_ns
{
/*----- PROTECTED REGION ID(Tc110::Additional Class Declarations) ENABLED START -----*/

//	Additional Class Declarations

/*----- PROTECTED REGION END -----*/	//	Tc110::Additional Class Declarations

class Tc110 : public Hipace_ns::Hipace
{

/*----- PROTECTED REGION ID(Tc110::Data Members) ENABLED START -----*/

//	Add your own data members

/*----- PROTECTED REGION END -----*/	//	Tc110::Data Members

//	Device property data members
public:

	bool	mandatoryNotDefined;

//	Attribute data members
public:
	Tango::DevUShort	*attr_CfgSpdSwPt_read;
	Tango::DevUShort	*attr_CfgDO2_read;
	Tango::DevUShort	*attr_CfgAccA1_read;
	Tango::DevUShort	*attr_CfgAccB1_read;
	Tango::DevUShort	*attr_CfgAccA2_read;
	Tango::DevUShort	*attr_CfgAccB2_read;
	Tango::DevBoolean	*attr_SealingGas_read;
	Tango::DevUShort	*attr_CtrlViaInt_read;
	Tango::DevBoolean	*attr_IntSelLckd_read;
	Tango::DevUShort	*attr_CfgDO1_read;
	Tango::DevULong	*attr_TempElec_read;
	Tango::DevULong	*attr_TempPmpBot_read;
	Tango::DevULong	*attr_AccelDecel_read;
	Tango::DevULong	*attr_TempBearng_read;
	Tango::DevULong	*attr_TempMotor_read;
	Tango::DevString	*attr_HwVersion_read;
	Tango::DevULong	*attr_NomSpdConf_read;
	Tango::DevULong	*attr_SetRotSpdRpm_read;
	Tango::DevULong	*attr_ActualSpdRpm_read;
	Tango::DevULong	*attr_NominalSpdRpm_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Tc110(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Tc110(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	Tc110(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */
	~Tc110() {delete_device();};


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();

	/*
	 *	Check if mandatory property has been set
	 */
	 void check_mandatory_property(Tango::DbDatum &class_prop, Tango::DbDatum &dev_prop);

//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method      : Tc110::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(vector<long> &attr_list);
	//--------------------------------------------------------
	/*
	 *	Method      : Tc110::write_attr_hardware()
	 *	Description : Hardware writing for attributes.
	 */
	//--------------------------------------------------------
	virtual void write_attr_hardware(vector<long> &attr_list);

/**
 *	Attribute CfgSpdSwPt related methods
 *	Description: Configurazione del punto di scatto velocita`
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
	virtual void read_CfgSpdSwPt(Tango::Attribute &attr);
	virtual void write_CfgSpdSwPt(Tango::WAttribute &attr);
	virtual bool is_CfgSpdSwPt_allowed(Tango::AttReqType type);
/**
 *	Attribute CfgDO2 related methods
 *	Description: Configurazione uscita DO2
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
	virtual void read_CfgDO2(Tango::Attribute &attr);
	virtual void write_CfgDO2(Tango::WAttribute &attr);
	virtual bool is_CfgDO2_allowed(Tango::AttReqType type);
/**
 *	Attribute CfgAccA1 related methods
 *	Description: Configurazione attacco accessori A1
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
	virtual void read_CfgAccA1(Tango::Attribute &attr);
	virtual void write_CfgAccA1(Tango::WAttribute &attr);
	virtual bool is_CfgAccA1_allowed(Tango::AttReqType type);
/**
 *	Attribute CfgAccB1 related methods
 *	Description: Configurazione attacco accessori B1
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
	virtual void read_CfgAccB1(Tango::Attribute &attr);
	virtual void write_CfgAccB1(Tango::WAttribute &attr);
	virtual bool is_CfgAccB1_allowed(Tango::AttReqType type);
/**
 *	Attribute CfgAccA2 related methods
 *	Description: Configurazione attacco accessori A2
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
	virtual void read_CfgAccA2(Tango::Attribute &attr);
	virtual void write_CfgAccA2(Tango::WAttribute &attr);
	virtual bool is_CfgAccA2_allowed(Tango::AttReqType type);
/**
 *	Attribute CfgAccB2 related methods
 *	Description: Configurazione attacco accessori B2
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
	virtual void read_CfgAccB2(Tango::Attribute &attr);
	virtual void write_CfgAccB2(Tango::WAttribute &attr);
	virtual bool is_CfgAccB2_allowed(Tango::AttReqType type);
/**
 *	Attribute SealingGas related methods
 *	Description: Gas di sbarramento
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_SealingGas(Tango::Attribute &attr);
	virtual void write_SealingGas(Tango::WAttribute &attr);
	virtual bool is_SealingGas_allowed(Tango::AttReqType type);
/**
 *	Attribute CtrlViaInt related methods
 *	Description: Comando tramite interfaccia
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
	virtual void read_CtrlViaInt(Tango::Attribute &attr);
	virtual bool is_CtrlViaInt_allowed(Tango::AttReqType type);
/**
 *	Attribute IntSelLckd related methods
 *	Description: Selezione interfaccia bloccata
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_IntSelLckd(Tango::Attribute &attr);
	virtual bool is_IntSelLckd_allowed(Tango::AttReqType type);
/**
 *	Attribute CfgDO1 related methods
 *	Description: Configurazione uscita DO1
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
	virtual void read_CfgDO1(Tango::Attribute &attr);
	virtual void write_CfgDO1(Tango::WAttribute &attr);
	virtual bool is_CfgDO1_allowed(Tango::AttReqType type);
/**
 *	Attribute TempElec related methods
 *	Description: Temperatura elettronica
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
	virtual void read_TempElec(Tango::Attribute &attr);
	virtual bool is_TempElec_allowed(Tango::AttReqType type);
/**
 *	Attribute TempPmpBot related methods
 *	Description: Temperatura parte inferiore pompa
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
	virtual void read_TempPmpBot(Tango::Attribute &attr);
	virtual bool is_TempPmpBot_allowed(Tango::AttReqType type);
/**
 *	Attribute AccelDecel related methods
 *	Description: Accelerazione/Decelerazione
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
	virtual void read_AccelDecel(Tango::Attribute &attr);
	virtual bool is_AccelDecel_allowed(Tango::AttReqType type);
/**
 *	Attribute TempBearng related methods
 *	Description: Temperatura cuscinetto
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
	virtual void read_TempBearng(Tango::Attribute &attr);
	virtual bool is_TempBearng_allowed(Tango::AttReqType type);
/**
 *	Attribute TempMotor related methods
 *	Description: Temperatura motore
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
	virtual void read_TempMotor(Tango::Attribute &attr);
	virtual bool is_TempMotor_allowed(Tango::AttReqType type);
/**
 *	Attribute HwVersion related methods
 *	Description: Versione hardware apparecchiatura elettronica di comando
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_HwVersion(Tango::Attribute &attr);
	virtual bool is_HwVersion_allowed(Tango::AttReqType type);
/**
 *	Attribute NomSpdConf related methods
 *	Description: Conferma velocita` nominale
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
	virtual void read_NomSpdConf(Tango::Attribute &attr);
	virtual void write_NomSpdConf(Tango::WAttribute &attr);
	virtual bool is_NomSpdConf_allowed(Tango::AttReqType type);
/**
 *	Attribute SetRotSpdRpm related methods
 *	Description: Velocita` nominale
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
	virtual void read_SetRotSpdRpm(Tango::Attribute &attr);
	virtual bool is_SetRotSpdRpm_allowed(Tango::AttReqType type);
/**
 *	Attribute ActualSpdRpm related methods
 *	Description: Velocita` effettiva
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
	virtual void read_ActualSpdRpm(Tango::Attribute &attr);
	virtual bool is_ActualSpdRpm_allowed(Tango::AttReqType type);
/**
 *	Attribute NominalSpdRpm related methods
 *	Description: Velocita` nominale
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
	virtual void read_NominalSpdRpm(Tango::Attribute &attr);
	virtual bool is_NominalSpdRpm_allowed(Tango::AttReqType type);


	//--------------------------------------------------------
	/**
	 *	Method      : Tc110::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();




//	Command related methods
public:


	//--------------------------------------------------------
	/**
	 *	Method      : Tc110::add_dynamic_commands()
	 *	Description : Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(Tc110::Additional Method prototypes) ENABLED START -----*/

//	Additional Method prototypes

/*----- PROTECTED REGION END -----*/	//	Tc110::Additional Method prototypes
};

/*----- PROTECTED REGION ID(Tc110::Additional Classes Definitions) ENABLED START -----*/

//	Additional Classes Definitions

/*----- PROTECTED REGION END -----*/	//	Tc110::Additional Classes Definitions

}	//	End of namespace

#endif   //	Tc110_H
