/*----- PROTECTED REGION ID(Tc110Class.cpp) ENABLED START -----*/
static const char *RcsId      = "$Id: Tc110Class.cpp,v 1.5 2015-08-03 09:26:54 alessio Exp $";
static const char *TagName    = "Tc110 $Name:  $";
static const char *CvsPath    = "$Source: /home/cvsadm/cvsroot/fermi/servers/hipace/src/Tc110Class.cpp,v $";
static const char *SvnPath    = "$HeadURL:  $";
static const char *HttpServer = "http://www.esrf.eu/computing/cs/tango/tango_doc/ds_doc/";
//=============================================================================
//
// file :        Tc110Class.cpp
//
// description : C++ source for the Tc110Class.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the Tc110 once per process.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.5 $
// $Date: 2015-08-03 09:26:54 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <Tc110Class.h>

/*----- PROTECTED REGION END -----*/	//	Tc110Class.cpp

//-------------------------------------------------------------------
/**
 *	Create Tc110Class singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_Tc110_class(const char *name) {
		return Tc110_ns::Tc110Class::init(name);
	}
}

namespace Tc110_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
Tc110Class *Tc110Class::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		Tc110Class::Tc110Class(string &s)
 * description : 	constructor for the Tc110Class
 *
 * @param s	The class name
 */
//--------------------------------------------------------
Tc110Class::Tc110Class(string &s):Hipace_ns::HipaceClass(s)
{
	cout2 << "Entering Tc110Class constructor" << endl;
	set_default_property();
	write_class_property();

	/*----- PROTECTED REGION ID(Tc110Class::constructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc110Class::constructor

	cout2 << "Leaving Tc110Class constructor" << endl;
}

//--------------------------------------------------------
/**
 * method : 		Tc110Class::~Tc110Class()
 * description : 	destructor for the Tc110Class
 */
//--------------------------------------------------------
Tc110Class::~Tc110Class()
{
	/*----- PROTECTED REGION ID(Tc110Class::destructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc110Class::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		Tc110Class::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
Tc110Class *Tc110Class::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new Tc110Class(s);
		}
		catch (bad_alloc &)
		{
			throw;
		}
	}
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		Tc110Class::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
Tc110Class *Tc110Class::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================

//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method      : Tc110Class::get_class_property()
 *	Description : Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum Tc110Class::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : Tc110Class::get_default_device_property()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum Tc110Class::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : Tc110Class::get_default_class_property()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum Tc110Class::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : Tc110Class::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void Tc110Class::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;
	vector<string>	vect_data;

	//	Set Default Class Properties

	//	Set Default device Properties
}

//--------------------------------------------------------
/**
 *	Method      : Tc110Class::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void Tc110Class::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("");
	description << str_desc;
	data.push_back(description);

	//	put cvs or svn location
	string	filename("Tc110");
	filename += "Class.cpp";

	// check for cvs information
	string	src_path(CvsPath);
	start = src_path.find("/");
	if (start!=string::npos)
	{
		end   = src_path.find(filename);
		if (end>start)
		{
			string	strloc = src_path.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}

	// check for svn information
	else
	{
		string	src_path(SvnPath);
		start = src_path.find("://");
		if (start!=string::npos)
		{
			end = src_path.find(filename);
			if (end>start)
			{
				header = "$HeadURL: ";
				start = header.length();
				string	strloc = src_path.substr(start, (end-start));
				
				Tango::DbDatum	svn_loc("svn_location");
				svn_loc << strloc;
				data.push_back(svn_loc);
			}
		}
	}

	//	Get CVS or SVN revision tag
	
	// CVS tag
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}
	
	// SVN tag
	string	svnpath(SvnPath);
	header = "$HeadURL: ";
	start = header.length();
	
	end   = svnpath.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strloc = svnpath.substr(start, end-start);
		
		string tagstr ("/tags/");
		start = strloc.find(tagstr);
		if ( start!=string::npos )
		{
			start = start + tagstr.length();
			end   = strloc.find(filename);
			string	strtag = strloc.substr(start, end-start-1);
			
			Tango::DbDatum	svn_tag("svn_tag");
			svn_tag << strtag;
			data.push_back(svn_tag);
		}
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method      : Tc110Class::device_factory()
 *	Description : Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void Tc110Class::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(Tc110Class::device_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Tc110Class::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new Tc110(this, (*devlist_ptr)[i]));
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		Tc110 *dev = static_cast<Tc110 *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(Tc110Class::device_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Tc110Class::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : Tc110Class::attribute_factory()
 *	Description : Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void Tc110Class::attribute_factory(vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(Tc110Class::attribute_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Tc110Class::attribute_factory_before
	//	Call atribute_factory for inherited class
	Hipace_ns::HipaceClass::attribute_factory(att_list);

	//	Attribute : FwVersion - Check if not concrete in inherited class
	Tango::Attr *FwVersionAttr = get_attr_object_by_name(att_list, "FwVersion");
	if (FwVersionAttr == NULL)
	{
	}

	//	Attribute : RemotePrio - Check if not concrete in inherited class
	Tango::Attr *RemotePrioAttr = get_attr_object_by_name(att_list, "RemotePrio");
	if (RemotePrioAttr == NULL)
	{
	}

	//	Attribute : SpdSwPtAtt - Check if not concrete in inherited class
	Tango::Attr *SpdSwPtAttAttr = get_attr_object_by_name(att_list, "SpdSwPtAtt");
	if (SpdSwPtAttAttr == NULL)
	{
	}

	//	Attribute : ErrorCode - Check if not concrete in inherited class
	Tango::Attr *ErrorCodeAttr = get_attr_object_by_name(att_list, "ErrorCode");
	if (ErrorCodeAttr == NULL)
	{
	}

	//	Attribute : OvTempElec - Check if not concrete in inherited class
	Tango::Attr *OvTempElecAttr = get_attr_object_by_name(att_list, "OvTempElec");
	if (OvTempElecAttr == NULL)
	{
	}

	//	Attribute : OvTempPump - Check if not concrete in inherited class
	Tango::Attr *OvTempPumpAttr = get_attr_object_by_name(att_list, "OvTempPump");
	if (OvTempPumpAttr == NULL)
	{
	}

	//	Attribute : SetSpdAtt - Check if not concrete in inherited class
	Tango::Attr *SetSpdAttAttr = get_attr_object_by_name(att_list, "SetSpdAtt");
	if (SetSpdAttAttr == NULL)
	{
	}

	//	Attribute : PumpAccel - Check if not concrete in inherited class
	Tango::Attr *PumpAccelAttr = get_attr_object_by_name(att_list, "PumpAccel");
	if (PumpAccelAttr == NULL)
	{
	}

	//	Attribute : DrvCurrent - Check if not concrete in inherited class
	Tango::Attr *DrvCurrentAttr = get_attr_object_by_name(att_list, "DrvCurrent");
	if (DrvCurrentAttr == NULL)
	{
	}

	//	Attribute : OpHrsPump - Check if not concrete in inherited class
	Tango::Attr *OpHrsPumpAttr = get_attr_object_by_name(att_list, "OpHrsPump");
	if (OpHrsPumpAttr == NULL)
	{
	}

	//	Attribute : DrvVoltage - Check if not concrete in inherited class
	Tango::Attr *DrvVoltageAttr = get_attr_object_by_name(att_list, "DrvVoltage");
	if (DrvVoltageAttr == NULL)
	{
	}

	//	Attribute : OpHrsElec - Check if not concrete in inherited class
	Tango::Attr *OpHrsElecAttr = get_attr_object_by_name(att_list, "OpHrsElec");
	if (OpHrsElecAttr == NULL)
	{
	}

	//	Attribute : DrvPower - Check if not concrete in inherited class
	Tango::Attr *DrvPowerAttr = get_attr_object_by_name(att_list, "DrvPower");
	if (DrvPowerAttr == NULL)
	{
	}

	//	Attribute : PumpCycles - Check if not concrete in inherited class
	Tango::Attr *PumpCyclesAttr = get_attr_object_by_name(att_list, "PumpCycles");
	if (PumpCyclesAttr == NULL)
	{
	}

	//	Attribute : ElecName - Check if not concrete in inherited class
	Tango::Attr *ElecNameAttr = get_attr_object_by_name(att_list, "ElecName");
	if (ElecNameAttr == NULL)
	{
	}

	//	Attribute : RUTimeSVal - Check if not concrete in inherited class
	Tango::Attr *RUTimeSValAttr = get_attr_object_by_name(att_list, "RUTimeSVal");
	if (RUTimeSValAttr == NULL)
	{
	}

	//	Attribute : SpdSwPt1 - Check if not concrete in inherited class
	Tango::Attr *SpdSwPt1Attr = get_attr_object_by_name(att_list, "SpdSwPt1");
	if (SpdSwPt1Attr == NULL)
	{
	}

	//	Attribute : SpdSVal - Check if not concrete in inherited class
	Tango::Attr *SpdSValAttr = get_attr_object_by_name(att_list, "SpdSVal");
	if (SpdSValAttr == NULL)
	{
	}

	//	Attribute : PwrSVal - Check if not concrete in inherited class
	Tango::Attr *PwrSValAttr = get_attr_object_by_name(att_list, "PwrSVal");
	if (PwrSValAttr == NULL)
	{
	}

	//	Attribute : SwoffBKP - Check if not concrete in inherited class
	Tango::Attr *SwoffBKPAttr = get_attr_object_by_name(att_list, "SwoffBKP");
	if (SwoffBKPAttr == NULL)
	{
	}

	//	Attribute : SwonBKP - Check if not concrete in inherited class
	Tango::Attr *SwonBKPAttr = get_attr_object_by_name(att_list, "SwonBKP");
	if (SwonBKPAttr == NULL)
	{
	}

	//	Attribute : StdbyVal - Check if not concrete in inherited class
	Tango::Attr *StdbyValAttr = get_attr_object_by_name(att_list, "StdbyVal");
	if (StdbyValAttr == NULL)
	{
	}

	//	Attribute : SpdSwPt2 - Check if not concrete in inherited class
	Tango::Attr *SpdSwPt2Attr = get_attr_object_by_name(att_list, "SpdSwPt2");
	if (SpdSwPt2Attr == NULL)
	{
	}

	//	Attribute : VentSpd - Check if not concrete in inherited class
	Tango::Attr *VentSpdAttr = get_attr_object_by_name(att_list, "VentSpd");
	if (VentSpdAttr == NULL)
	{
	}

	//	Attribute : VentTime - Check if not concrete in inherited class
	Tango::Attr *VentTimeAttr = get_attr_object_by_name(att_list, "VentTime");
	if (VentTimeAttr == NULL)
	{
	}

	//	Attribute : Heating - Check if not concrete in inherited class
	Tango::Attr *HeatingAttr = get_attr_object_by_name(att_list, "Heating");
	if (HeatingAttr == NULL)
	{
	}

	//	Attribute : Standby - Check if not concrete in inherited class
	Tango::Attr *StandbyAttr = get_attr_object_by_name(att_list, "Standby");
	if (StandbyAttr == NULL)
	{
	}

	//	Attribute : RUTimeCtrl - Check if not concrete in inherited class
	Tango::Attr *RUTimeCtrlAttr = get_attr_object_by_name(att_list, "RUTimeCtrl");
	if (RUTimeCtrlAttr == NULL)
	{
	}

	//	Attribute : ErrorAckn - Check if not concrete in inherited class
	Tango::Attr *ErrorAcknAttr = get_attr_object_by_name(att_list, "ErrorAckn");
	if (ErrorAcknAttr == NULL)
	{
	}

	//	Attribute : PumpgStatn - Check if not concrete in inherited class
	Tango::Attr *PumpgStatnAttr = get_attr_object_by_name(att_list, "PumpgStatn");
	if (PumpgStatnAttr == NULL)
	{
	}

	//	Attribute : EnableVent - Check if not concrete in inherited class
	Tango::Attr *EnableVentAttr = get_attr_object_by_name(att_list, "EnableVent");
	if (EnableVentAttr == NULL)
	{
	}

	//	Attribute : MotorPump - Check if not concrete in inherited class
	Tango::Attr *MotorPumpAttr = get_attr_object_by_name(att_list, "MotorPump");
	if (MotorPumpAttr == NULL)
	{
	}

	//	Attribute : OpModeBKP - Check if not concrete in inherited class
	Tango::Attr *OpModeBKPAttr = get_attr_object_by_name(att_list, "OpModeBKP");
	if (OpModeBKPAttr == NULL)
	{
	}

	//	Attribute : SpdSetMode - Check if not concrete in inherited class
	Tango::Attr *SpdSetModeAttr = get_attr_object_by_name(att_list, "SpdSetMode");
	if (SpdSetModeAttr == NULL)
	{
	}

	//	Attribute : GasMode - Check if not concrete in inherited class
	Tango::Attr *GasModeAttr = get_attr_object_by_name(att_list, "GasMode");
	if (GasModeAttr == NULL)
	{
	}

	//	Attribute : VentMode - Check if not concrete in inherited class
	Tango::Attr *VentModeAttr = get_attr_object_by_name(att_list, "VentMode");
	if (VentModeAttr == NULL)
	{
	}

	//	Attribute : CfgAO1 - Check if not concrete in inherited class
	Tango::Attr *CfgAO1Attr = get_attr_object_by_name(att_list, "CfgAO1");
	if (CfgAO1Attr == NULL)
	{
	}

	//	Attribute : CfgSpdSwPt
	CfgSpdSwPtAttrib	*cfgspdswpt = new CfgSpdSwPtAttrib();
	Tango::UserDefaultAttrProp	cfgspdswpt_prop;
	cfgspdswpt_prop.set_description("Configurazione del punto di scatto velocita`");
	cfgspdswpt_prop.set_label("CfgSpdSwPt (017)");
	//	unit	not set for CfgSpdSwPt
	//	standard_unit	not set for CfgSpdSwPt
	//	display_unit	not set for CfgSpdSwPt
	//	format	not set for CfgSpdSwPt
	cfgspdswpt_prop.set_max_value("1");
	cfgspdswpt_prop.set_min_value("0");
	//	max_alarm	not set for CfgSpdSwPt
	//	min_alarm	not set for CfgSpdSwPt
	//	max_warning	not set for CfgSpdSwPt
	//	min_warning	not set for CfgSpdSwPt
	//	delta_t	not set for CfgSpdSwPt
	//	delta_val	not set for CfgSpdSwPt
	
	cfgspdswpt->set_default_properties(cfgspdswpt_prop);
	//	Not Polled
	cfgspdswpt->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(cfgspdswpt);

	//	Attribute : CfgDO2
	CfgDO2Attrib	*cfgdo2 = new CfgDO2Attrib();
	Tango::UserDefaultAttrProp	cfgdo2_prop;
	cfgdo2_prop.set_description("Configurazione uscita DO2");
	cfgdo2_prop.set_label("CfgDO2 (019)");
	//	unit	not set for CfgDO2
	//	standard_unit	not set for CfgDO2
	//	display_unit	not set for CfgDO2
	//	format	not set for CfgDO2
	cfgdo2_prop.set_max_value("17");
	cfgdo2_prop.set_min_value("0");
	//	max_alarm	not set for CfgDO2
	//	min_alarm	not set for CfgDO2
	//	max_warning	not set for CfgDO2
	//	min_warning	not set for CfgDO2
	//	delta_t	not set for CfgDO2
	//	delta_val	not set for CfgDO2
	
	cfgdo2->set_default_properties(cfgdo2_prop);
	//	Not Polled
	cfgdo2->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(cfgdo2);

	//	Attribute : CfgAccA1
	CfgAccA1Attrib	*cfgacca1 = new CfgAccA1Attrib();
	Tango::UserDefaultAttrProp	cfgacca1_prop;
	cfgacca1_prop.set_description("Configurazione attacco accessori A1");
	cfgacca1_prop.set_label("CfgAccA1 (035)");
	//	unit	not set for CfgAccA1
	//	standard_unit	not set for CfgAccA1
	//	display_unit	not set for CfgAccA1
	//	format	not set for CfgAccA1
	cfgacca1_prop.set_max_value("8");
	cfgacca1_prop.set_min_value("0");
	//	max_alarm	not set for CfgAccA1
	//	min_alarm	not set for CfgAccA1
	//	max_warning	not set for CfgAccA1
	//	min_warning	not set for CfgAccA1
	//	delta_t	not set for CfgAccA1
	//	delta_val	not set for CfgAccA1
	
	cfgacca1->set_default_properties(cfgacca1_prop);
	//	Not Polled
	cfgacca1->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(cfgacca1);

	//	Attribute : CfgAccB1
	CfgAccB1Attrib	*cfgaccb1 = new CfgAccB1Attrib();
	Tango::UserDefaultAttrProp	cfgaccb1_prop;
	cfgaccb1_prop.set_description("Configurazione attacco accessori B1");
	cfgaccb1_prop.set_label("CfgAccB1 (036)");
	//	unit	not set for CfgAccB1
	//	standard_unit	not set for CfgAccB1
	//	display_unit	not set for CfgAccB1
	//	format	not set for CfgAccB1
	cfgaccb1_prop.set_max_value("8");
	cfgaccb1_prop.set_min_value("0");
	//	max_alarm	not set for CfgAccB1
	//	min_alarm	not set for CfgAccB1
	//	max_warning	not set for CfgAccB1
	//	min_warning	not set for CfgAccB1
	//	delta_t	not set for CfgAccB1
	//	delta_val	not set for CfgAccB1
	
	cfgaccb1->set_default_properties(cfgaccb1_prop);
	//	Not Polled
	cfgaccb1->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(cfgaccb1);

	//	Attribute : CfgAccA2
	CfgAccA2Attrib	*cfgacca2 = new CfgAccA2Attrib();
	Tango::UserDefaultAttrProp	cfgacca2_prop;
	cfgacca2_prop.set_description("Configurazione attacco accessori A2");
	cfgacca2_prop.set_label("CfgAccA2 (037)");
	//	unit	not set for CfgAccA2
	//	standard_unit	not set for CfgAccA2
	//	display_unit	not set for CfgAccA2
	//	format	not set for CfgAccA2
	cfgacca2_prop.set_max_value("8");
	cfgacca2_prop.set_min_value("0");
	//	max_alarm	not set for CfgAccA2
	//	min_alarm	not set for CfgAccA2
	//	max_warning	not set for CfgAccA2
	//	min_warning	not set for CfgAccA2
	//	delta_t	not set for CfgAccA2
	//	delta_val	not set for CfgAccA2
	
	cfgacca2->set_default_properties(cfgacca2_prop);
	//	Not Polled
	cfgacca2->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(cfgacca2);

	//	Attribute : CfgAccB2
	CfgAccB2Attrib	*cfgaccb2 = new CfgAccB2Attrib();
	Tango::UserDefaultAttrProp	cfgaccb2_prop;
	cfgaccb2_prop.set_description("Configurazione attacco accessori B2");
	cfgaccb2_prop.set_label("CfgAccB2 (038)");
	//	unit	not set for CfgAccB2
	//	standard_unit	not set for CfgAccB2
	//	display_unit	not set for CfgAccB2
	//	format	not set for CfgAccB2
	cfgaccb2_prop.set_max_value("8");
	cfgaccb2_prop.set_min_value("0");
	//	max_alarm	not set for CfgAccB2
	//	min_alarm	not set for CfgAccB2
	//	max_warning	not set for CfgAccB2
	//	min_warning	not set for CfgAccB2
	//	delta_t	not set for CfgAccB2
	//	delta_val	not set for CfgAccB2
	
	cfgaccb2->set_default_properties(cfgaccb2_prop);
	//	Not Polled
	cfgaccb2->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(cfgaccb2);

	//	Attribute : SealingGas
	SealingGasAttrib	*sealinggas = new SealingGasAttrib();
	Tango::UserDefaultAttrProp	sealinggas_prop;
	sealinggas_prop.set_description("Gas di sbarramento");
	sealinggas_prop.set_label("SealingGas (050)");
	//	unit	not set for SealingGas
	//	standard_unit	not set for SealingGas
	//	display_unit	not set for SealingGas
	//	format	not set for SealingGas
	//	max_value	not set for SealingGas
	//	min_value	not set for SealingGas
	//	max_alarm	not set for SealingGas
	//	min_alarm	not set for SealingGas
	//	max_warning	not set for SealingGas
	//	min_warning	not set for SealingGas
	//	delta_t	not set for SealingGas
	//	delta_val	not set for SealingGas
	
	sealinggas->set_default_properties(sealinggas_prop);
	//	Not Polled
	sealinggas->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(sealinggas);

	//	Attribute : CtrlViaInt
	CtrlViaIntAttrib	*ctrlviaint = new CtrlViaIntAttrib();
	Tango::UserDefaultAttrProp	ctrlviaint_prop;
	ctrlviaint_prop.set_description("Comando tramite interfaccia");
	ctrlviaint_prop.set_label("CtrlViaInt (060)");
	//	unit	not set for CtrlViaInt
	//	standard_unit	not set for CtrlViaInt
	//	display_unit	not set for CtrlViaInt
	//	format	not set for CtrlViaInt
	ctrlviaint_prop.set_max_value("255");
	ctrlviaint_prop.set_min_value("1");
	//	max_alarm	not set for CtrlViaInt
	//	min_alarm	not set for CtrlViaInt
	//	max_warning	not set for CtrlViaInt
	//	min_warning	not set for CtrlViaInt
	//	delta_t	not set for CtrlViaInt
	//	delta_val	not set for CtrlViaInt
	
	ctrlviaint->set_default_properties(ctrlviaint_prop);
	//	Not Polled
	ctrlviaint->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(ctrlviaint);

	//	Attribute : IntSelLckd
	IntSelLckdAttrib	*intsellckd = new IntSelLckdAttrib();
	Tango::UserDefaultAttrProp	intsellckd_prop;
	intsellckd_prop.set_description("Selezione interfaccia bloccata");
	intsellckd_prop.set_label("IntSelLckd (061)");
	//	unit	not set for IntSelLckd
	//	standard_unit	not set for IntSelLckd
	//	display_unit	not set for IntSelLckd
	//	format	not set for IntSelLckd
	//	max_value	not set for IntSelLckd
	//	min_value	not set for IntSelLckd
	//	max_alarm	not set for IntSelLckd
	//	min_alarm	not set for IntSelLckd
	//	max_warning	not set for IntSelLckd
	//	min_warning	not set for IntSelLckd
	//	delta_t	not set for IntSelLckd
	//	delta_val	not set for IntSelLckd
	
	intsellckd->set_default_properties(intsellckd_prop);
	//	Not Polled
	intsellckd->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(intsellckd);

	//	Attribute : CfgDO1
	CfgDO1Attrib	*cfgdo1 = new CfgDO1Attrib();
	Tango::UserDefaultAttrProp	cfgdo1_prop;
	cfgdo1_prop.set_description("Configurazione uscita DO1");
	cfgdo1_prop.set_label("CfgDO1 (024)");
	//	unit	not set for CfgDO1
	//	standard_unit	not set for CfgDO1
	//	display_unit	not set for CfgDO1
	//	format	not set for CfgDO1
	cfgdo1_prop.set_max_value("17");
	cfgdo1_prop.set_min_value("0");
	//	max_alarm	not set for CfgDO1
	//	min_alarm	not set for CfgDO1
	//	max_warning	not set for CfgDO1
	//	min_warning	not set for CfgDO1
	//	delta_t	not set for CfgDO1
	//	delta_val	not set for CfgDO1
	
	cfgdo1->set_default_properties(cfgdo1_prop);
	//	Not Polled
	cfgdo1->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(cfgdo1);

	//	Attribute : TempElec
	TempElecAttrib	*tempelec = new TempElecAttrib();
	Tango::UserDefaultAttrProp	tempelec_prop;
	tempelec_prop.set_description("Temperatura elettronica");
	tempelec_prop.set_label("TempElec (326)");
	tempelec_prop.set_unit("C");
	//	standard_unit	not set for TempElec
	//	display_unit	not set for TempElec
	//	format	not set for TempElec
	tempelec_prop.set_max_value("999999");
	tempelec_prop.set_min_value("0");
	//	max_alarm	not set for TempElec
	//	min_alarm	not set for TempElec
	//	max_warning	not set for TempElec
	//	min_warning	not set for TempElec
	//	delta_t	not set for TempElec
	//	delta_val	not set for TempElec
	
	tempelec->set_default_properties(tempelec_prop);
	//	Not Polled
	tempelec->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(tempelec);

	//	Attribute : TempPmpBot
	TempPmpBotAttrib	*temppmpbot = new TempPmpBotAttrib();
	Tango::UserDefaultAttrProp	temppmpbot_prop;
	temppmpbot_prop.set_description("Temperatura parte inferiore pompa");
	temppmpbot_prop.set_label("TempPmpBot (330)");
	temppmpbot_prop.set_unit("C");
	//	standard_unit	not set for TempPmpBot
	//	display_unit	not set for TempPmpBot
	//	format	not set for TempPmpBot
	temppmpbot_prop.set_max_value("999999");
	temppmpbot_prop.set_min_value("0");
	//	max_alarm	not set for TempPmpBot
	//	min_alarm	not set for TempPmpBot
	//	max_warning	not set for TempPmpBot
	//	min_warning	not set for TempPmpBot
	//	delta_t	not set for TempPmpBot
	//	delta_val	not set for TempPmpBot
	
	temppmpbot->set_default_properties(temppmpbot_prop);
	//	Not Polled
	temppmpbot->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(temppmpbot);

	//	Attribute : AccelDecel
	AccelDecelAttrib	*acceldecel = new AccelDecelAttrib();
	Tango::UserDefaultAttrProp	acceldecel_prop;
	acceldecel_prop.set_description("Accelerazione/Decelerazione");
	acceldecel_prop.set_label("AccelDecel (336)");
	acceldecel_prop.set_unit("rpm/s");
	//	standard_unit	not set for AccelDecel
	//	display_unit	not set for AccelDecel
	//	format	not set for AccelDecel
	acceldecel_prop.set_max_value("999999");
	acceldecel_prop.set_min_value("0");
	//	max_alarm	not set for AccelDecel
	//	min_alarm	not set for AccelDecel
	//	max_warning	not set for AccelDecel
	//	min_warning	not set for AccelDecel
	//	delta_t	not set for AccelDecel
	//	delta_val	not set for AccelDecel
	
	acceldecel->set_default_properties(acceldecel_prop);
	//	Not Polled
	acceldecel->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(acceldecel);

	//	Attribute : TempBearng
	TempBearngAttrib	*tempbearng = new TempBearngAttrib();
	Tango::UserDefaultAttrProp	tempbearng_prop;
	tempbearng_prop.set_description("Temperatura cuscinetto");
	tempbearng_prop.set_label("TempBearng (342)");
	tempbearng_prop.set_unit("C");
	//	standard_unit	not set for TempBearng
	//	display_unit	not set for TempBearng
	//	format	not set for TempBearng
	tempbearng_prop.set_max_value("999999");
	tempbearng_prop.set_min_value("0");
	//	max_alarm	not set for TempBearng
	//	min_alarm	not set for TempBearng
	//	max_warning	not set for TempBearng
	//	min_warning	not set for TempBearng
	//	delta_t	not set for TempBearng
	//	delta_val	not set for TempBearng
	
	tempbearng->set_default_properties(tempbearng_prop);
	//	Not Polled
	tempbearng->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(tempbearng);

	//	Attribute : TempMotor
	TempMotorAttrib	*tempmotor = new TempMotorAttrib();
	Tango::UserDefaultAttrProp	tempmotor_prop;
	tempmotor_prop.set_description("Temperatura motore");
	tempmotor_prop.set_label("TempMotor (346)");
	tempmotor_prop.set_unit("C");
	//	standard_unit	not set for TempMotor
	//	display_unit	not set for TempMotor
	//	format	not set for TempMotor
	//	max_value	not set for TempMotor
	//	min_value	not set for TempMotor
	tempmotor_prop.set_max_alarm("999999");
	tempmotor_prop.set_min_alarm("0");
	//	max_warning	not set for TempMotor
	//	min_warning	not set for TempMotor
	//	delta_t	not set for TempMotor
	//	delta_val	not set for TempMotor
	
	tempmotor->set_default_properties(tempmotor_prop);
	//	Not Polled
	tempmotor->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(tempmotor);

	//	Attribute : HwVersion
	HwVersionAttrib	*hwversion = new HwVersionAttrib();
	Tango::UserDefaultAttrProp	hwversion_prop;
	hwversion_prop.set_description("Versione hardware apparecchiatura elettronica di comando");
	hwversion_prop.set_label("HwVersion (354)");
	//	unit	not set for HwVersion
	//	standard_unit	not set for HwVersion
	//	display_unit	not set for HwVersion
	//	format	not set for HwVersion
	//	max_value	not set for HwVersion
	//	min_value	not set for HwVersion
	//	max_alarm	not set for HwVersion
	//	min_alarm	not set for HwVersion
	//	max_warning	not set for HwVersion
	//	min_warning	not set for HwVersion
	//	delta_t	not set for HwVersion
	//	delta_val	not set for HwVersion
	
	hwversion->set_default_properties(hwversion_prop);
	//	Not Polled
	hwversion->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(hwversion);

	//	Attribute : NomSpdConf
	NomSpdConfAttrib	*nomspdconf = new NomSpdConfAttrib();
	Tango::UserDefaultAttrProp	nomspdconf_prop;
	nomspdconf_prop.set_description("Conferma velocita` nominale");
	nomspdconf_prop.set_label("NomSpdConf (777)");
	nomspdconf_prop.set_unit("Hz");
	//	standard_unit	not set for NomSpdConf
	//	display_unit	not set for NomSpdConf
	//	format	not set for NomSpdConf
	nomspdconf_prop.set_max_value("1500");
	nomspdconf_prop.set_min_value("0");
	//	max_alarm	not set for NomSpdConf
	//	min_alarm	not set for NomSpdConf
	//	max_warning	not set for NomSpdConf
	//	min_warning	not set for NomSpdConf
	//	delta_t	not set for NomSpdConf
	//	delta_val	not set for NomSpdConf
	
	nomspdconf->set_default_properties(nomspdconf_prop);
	//	Not Polled
	nomspdconf->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(nomspdconf);

	//	Attribute : SetRotSpdRpm
	SetRotSpdRpmAttrib	*setrotspdrpm = new SetRotSpdRpmAttrib();
	Tango::UserDefaultAttrProp	setrotspdrpm_prop;
	setrotspdrpm_prop.set_description("Velocita` nominale");
	setrotspdrpm_prop.set_label("SetRotSpdRpm (397)");
	setrotspdrpm_prop.set_unit("rpm/m");
	//	standard_unit	not set for SetRotSpdRpm
	//	display_unit	not set for SetRotSpdRpm
	//	format	not set for SetRotSpdRpm
	setrotspdrpm_prop.set_max_value("999999");
	setrotspdrpm_prop.set_min_value("0");
	//	max_alarm	not set for SetRotSpdRpm
	//	min_alarm	not set for SetRotSpdRpm
	//	max_warning	not set for SetRotSpdRpm
	//	min_warning	not set for SetRotSpdRpm
	//	delta_t	not set for SetRotSpdRpm
	//	delta_val	not set for SetRotSpdRpm
	
	setrotspdrpm->set_default_properties(setrotspdrpm_prop);
	//	Not Polled
	setrotspdrpm->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(setrotspdrpm);

	//	Attribute : ActualSpdRpm
	ActualSpdRpmAttrib	*actualspdrpm = new ActualSpdRpmAttrib();
	Tango::UserDefaultAttrProp	actualspdrpm_prop;
	actualspdrpm_prop.set_description("Velocita` effettiva");
	actualspdrpm_prop.set_label("ActualSpdRpm (398)");
	actualspdrpm_prop.set_unit("rpm/m");
	//	standard_unit	not set for ActualSpdRpm
	//	display_unit	not set for ActualSpdRpm
	//	format	not set for ActualSpdRpm
	actualspdrpm_prop.set_max_value("999999");
	actualspdrpm_prop.set_min_value("0");
	//	max_alarm	not set for ActualSpdRpm
	//	min_alarm	not set for ActualSpdRpm
	//	max_warning	not set for ActualSpdRpm
	//	min_warning	not set for ActualSpdRpm
	//	delta_t	not set for ActualSpdRpm
	//	delta_val	not set for ActualSpdRpm
	
	actualspdrpm->set_default_properties(actualspdrpm_prop);
	//	Not Polled
	actualspdrpm->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(actualspdrpm);

	//	Attribute : NominalSpdRpm
	NominalSpdRpmAttrib	*nominalspdrpm = new NominalSpdRpmAttrib();
	Tango::UserDefaultAttrProp	nominalspdrpm_prop;
	nominalspdrpm_prop.set_description("Velocita` nominale");
	nominalspdrpm_prop.set_label("NominalSpdRpm (399)");
	nominalspdrpm_prop.set_unit("rpm/m");
	//	standard_unit	not set for NominalSpdRpm
	//	display_unit	not set for NominalSpdRpm
	//	format	not set for NominalSpdRpm
	nominalspdrpm_prop.set_max_value("999999");
	nominalspdrpm_prop.set_min_value("0");
	//	max_alarm	not set for NominalSpdRpm
	//	min_alarm	not set for NominalSpdRpm
	//	max_warning	not set for NominalSpdRpm
	//	min_warning	not set for NominalSpdRpm
	//	delta_t	not set for NominalSpdRpm
	//	delta_val	not set for NominalSpdRpm
	
	nominalspdrpm->set_default_properties(nominalspdrpm_prop);
	//	Not Polled
	nominalspdrpm->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(nominalspdrpm);

	//	Attribute : SetRotSpdHz - Check if not concrete in inherited class
	Tango::Attr *SetRotSpdHzAttr = get_attr_object_by_name(att_list, "SetRotSpdHz");
	if (SetRotSpdHzAttr == NULL)
	{
	}

	//	Attribute : ActualSpdHz - Check if not concrete in inherited class
	Tango::Attr *ActualSpdHzAttr = get_attr_object_by_name(att_list, "ActualSpdHz");
	if (ActualSpdHzAttr == NULL)
	{
	}

	//	Attribute : NominalSpdHz - Check if not concrete in inherited class
	Tango::Attr *NominalSpdHzAttr = get_attr_object_by_name(att_list, "NominalSpdHz");
	if (NominalSpdHzAttr == NULL)
	{
	}

	//	Attribute : ErrHist - Check if not concrete in inherited class
	Tango::Attr *ErrHistAttr = get_attr_object_by_name(att_list, "ErrHist");
	if (ErrHistAttr == NULL)
	{
	}


	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(Tc110Class::attribute_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Tc110Class::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : Tc110Class::pipe_factory()
 *	Description : Create the pipe object(s)
 *                and store them in the pipe list
 */
//--------------------------------------------------------
void Tc110Class::pipe_factory()
{
	/*----- PROTECTED REGION ID(Tc110Class::pipe_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Tc110Class::pipe_factory_before
	/*----- PROTECTED REGION ID(Tc110Class::pipe_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Tc110Class::pipe_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : Tc110Class::command_factory()
 *	Description : Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void Tc110Class::command_factory()
{
	/*----- PROTECTED REGION ID(Tc110Class::command_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Tc110Class::command_factory_before
	//	Call command_factory for inherited class
	Hipace_ns::HipaceClass::command_factory();



	/*----- PROTECTED REGION ID(Tc110Class::command_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Tc110Class::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		Tc110Class::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list
 */
//--------------------------------------------------------
void Tc110Class::create_static_attribute_list(vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	cout2 << defaultAttList.size() << " attributes in default list" << endl;

	/*----- PROTECTED REGION ID(Tc110Class::create_static_att_list) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc110Class::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		Tc110Class::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void Tc110Class::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((string)(*devlist_ptr)[i]).c_str());
		Tc110 *dev = static_cast<Tc110 *> (dev_impl);

		vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			vector<string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				cout2 << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(Tc110Class::erase_dynamic_attributes) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc110Class::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : Tc110Class::get_attr_by_name()
 *	Description : returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *Tc110Class::get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname)
{
	vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; ++it)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(Tc110Class::Additional Methods) ENABLED START -----*/

/*----- PROTECTED REGION END -----*/	//	Tc110Class::Additional Methods
} //	namespace
