/*----- PROTECTED REGION ID(Tc110Class.h) ENABLED START -----*/
//=============================================================================
//
// file :        Tc110Class.h
//
// description : Include for the Tc110 root class.
//               This class is the singleton class for
//                the Tc110 device class.
//               It contains all properties and methods which the 
//               Tc110 requires only once e.g. the commands.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.3 $
// $Date: 2014-05-07 14:47:45 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef Tc110Class_H
#define Tc110Class_H

#include <tango.h>
#include <HipaceClass.h>
#include <Tc110.h>


/*----- PROTECTED REGION END -----*/	//	Tc110Class.h


namespace Tc110_ns
{
/*----- PROTECTED REGION ID(Tc110Class::classes for dynamic creation) ENABLED START -----*/


/*----- PROTECTED REGION END -----*/	//	Tc110Class::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute CfgSpdSwPt class definition
class CfgSpdSwPtAttrib: public Tango::Attr
{
public:
	CfgSpdSwPtAttrib():Attr("CfgSpdSwPt",
			Tango::DEV_USHORT, Tango::READ_WRITE) {};
	~CfgSpdSwPtAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Tc110 *>(dev))->read_CfgSpdSwPt(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Tc110 *>(dev))->write_CfgSpdSwPt(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Tc110 *>(dev))->is_CfgSpdSwPt_allowed(ty);}
};

//	Attribute CfgDO2 class definition
class CfgDO2Attrib: public Tango::Attr
{
public:
	CfgDO2Attrib():Attr("CfgDO2",
			Tango::DEV_USHORT, Tango::READ_WRITE) {};
	~CfgDO2Attrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Tc110 *>(dev))->read_CfgDO2(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Tc110 *>(dev))->write_CfgDO2(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Tc110 *>(dev))->is_CfgDO2_allowed(ty);}
};

//	Attribute CfgAccA1 class definition
class CfgAccA1Attrib: public Tango::Attr
{
public:
	CfgAccA1Attrib():Attr("CfgAccA1",
			Tango::DEV_USHORT, Tango::READ_WRITE) {};
	~CfgAccA1Attrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Tc110 *>(dev))->read_CfgAccA1(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Tc110 *>(dev))->write_CfgAccA1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Tc110 *>(dev))->is_CfgAccA1_allowed(ty);}
};

//	Attribute CfgAccB1 class definition
class CfgAccB1Attrib: public Tango::Attr
{
public:
	CfgAccB1Attrib():Attr("CfgAccB1",
			Tango::DEV_USHORT, Tango::READ_WRITE) {};
	~CfgAccB1Attrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Tc110 *>(dev))->read_CfgAccB1(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Tc110 *>(dev))->write_CfgAccB1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Tc110 *>(dev))->is_CfgAccB1_allowed(ty);}
};

//	Attribute CfgAccA2 class definition
class CfgAccA2Attrib: public Tango::Attr
{
public:
	CfgAccA2Attrib():Attr("CfgAccA2",
			Tango::DEV_USHORT, Tango::READ_WRITE) {};
	~CfgAccA2Attrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Tc110 *>(dev))->read_CfgAccA2(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Tc110 *>(dev))->write_CfgAccA2(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Tc110 *>(dev))->is_CfgAccA2_allowed(ty);}
};

//	Attribute CfgAccB2 class definition
class CfgAccB2Attrib: public Tango::Attr
{
public:
	CfgAccB2Attrib():Attr("CfgAccB2",
			Tango::DEV_USHORT, Tango::READ_WRITE) {};
	~CfgAccB2Attrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Tc110 *>(dev))->read_CfgAccB2(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Tc110 *>(dev))->write_CfgAccB2(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Tc110 *>(dev))->is_CfgAccB2_allowed(ty);}
};

//	Attribute SealingGas class definition
class SealingGasAttrib: public Tango::Attr
{
public:
	SealingGasAttrib():Attr("SealingGas",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~SealingGasAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Tc110 *>(dev))->read_SealingGas(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Tc110 *>(dev))->write_SealingGas(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Tc110 *>(dev))->is_SealingGas_allowed(ty);}
};

//	Attribute CtrlViaInt class definition
class CtrlViaIntAttrib: public Tango::Attr
{
public:
	CtrlViaIntAttrib():Attr("CtrlViaInt",
			Tango::DEV_USHORT, Tango::READ) {};
	~CtrlViaIntAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Tc110 *>(dev))->read_CtrlViaInt(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Tc110 *>(dev))->is_CtrlViaInt_allowed(ty);}
};

//	Attribute IntSelLckd class definition
class IntSelLckdAttrib: public Tango::Attr
{
public:
	IntSelLckdAttrib():Attr("IntSelLckd",
			Tango::DEV_BOOLEAN, Tango::READ) {};
	~IntSelLckdAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Tc110 *>(dev))->read_IntSelLckd(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Tc110 *>(dev))->is_IntSelLckd_allowed(ty);}
};

//	Attribute CfgDO1 class definition
class CfgDO1Attrib: public Tango::Attr
{
public:
	CfgDO1Attrib():Attr("CfgDO1",
			Tango::DEV_USHORT, Tango::READ_WRITE) {};
	~CfgDO1Attrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Tc110 *>(dev))->read_CfgDO1(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Tc110 *>(dev))->write_CfgDO1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Tc110 *>(dev))->is_CfgDO1_allowed(ty);}
};

//	Attribute TempElec class definition
class TempElecAttrib: public Tango::Attr
{
public:
	TempElecAttrib():Attr("TempElec",
			Tango::DEV_ULONG, Tango::READ) {};
	~TempElecAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Tc110 *>(dev))->read_TempElec(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Tc110 *>(dev))->is_TempElec_allowed(ty);}
};

//	Attribute TempPmpBot class definition
class TempPmpBotAttrib: public Tango::Attr
{
public:
	TempPmpBotAttrib():Attr("TempPmpBot",
			Tango::DEV_ULONG, Tango::READ) {};
	~TempPmpBotAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Tc110 *>(dev))->read_TempPmpBot(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Tc110 *>(dev))->is_TempPmpBot_allowed(ty);}
};

//	Attribute AccelDecel class definition
class AccelDecelAttrib: public Tango::Attr
{
public:
	AccelDecelAttrib():Attr("AccelDecel",
			Tango::DEV_ULONG, Tango::READ) {};
	~AccelDecelAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Tc110 *>(dev))->read_AccelDecel(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Tc110 *>(dev))->is_AccelDecel_allowed(ty);}
};

//	Attribute TempBearng class definition
class TempBearngAttrib: public Tango::Attr
{
public:
	TempBearngAttrib():Attr("TempBearng",
			Tango::DEV_ULONG, Tango::READ) {};
	~TempBearngAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Tc110 *>(dev))->read_TempBearng(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Tc110 *>(dev))->is_TempBearng_allowed(ty);}
};

//	Attribute TempMotor class definition
class TempMotorAttrib: public Tango::Attr
{
public:
	TempMotorAttrib():Attr("TempMotor",
			Tango::DEV_ULONG, Tango::READ) {};
	~TempMotorAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Tc110 *>(dev))->read_TempMotor(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Tc110 *>(dev))->is_TempMotor_allowed(ty);}
};

//	Attribute HwVersion class definition
class HwVersionAttrib: public Tango::Attr
{
public:
	HwVersionAttrib():Attr("HwVersion",
			Tango::DEV_STRING, Tango::READ) {};
	~HwVersionAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Tc110 *>(dev))->read_HwVersion(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Tc110 *>(dev))->is_HwVersion_allowed(ty);}
};

//	Attribute NomSpdConf class definition
class NomSpdConfAttrib: public Tango::Attr
{
public:
	NomSpdConfAttrib():Attr("NomSpdConf",
			Tango::DEV_ULONG, Tango::READ_WRITE) {};
	~NomSpdConfAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Tc110 *>(dev))->read_NomSpdConf(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Tc110 *>(dev))->write_NomSpdConf(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Tc110 *>(dev))->is_NomSpdConf_allowed(ty);}
};

//	Attribute SetRotSpdRpm class definition
class SetRotSpdRpmAttrib: public Tango::Attr
{
public:
	SetRotSpdRpmAttrib():Attr("SetRotSpdRpm",
			Tango::DEV_ULONG, Tango::READ) {};
	~SetRotSpdRpmAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Tc110 *>(dev))->read_SetRotSpdRpm(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Tc110 *>(dev))->is_SetRotSpdRpm_allowed(ty);}
};

//	Attribute ActualSpdRpm class definition
class ActualSpdRpmAttrib: public Tango::Attr
{
public:
	ActualSpdRpmAttrib():Attr("ActualSpdRpm",
			Tango::DEV_ULONG, Tango::READ) {};
	~ActualSpdRpmAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Tc110 *>(dev))->read_ActualSpdRpm(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Tc110 *>(dev))->is_ActualSpdRpm_allowed(ty);}
};

//	Attribute NominalSpdRpm class definition
class NominalSpdRpmAttrib: public Tango::Attr
{
public:
	NominalSpdRpmAttrib():Attr("NominalSpdRpm",
			Tango::DEV_ULONG, Tango::READ) {};
	~NominalSpdRpmAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Tc110 *>(dev))->read_NominalSpdRpm(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Tc110 *>(dev))->is_NominalSpdRpm_allowed(ty);}
};


/**
 *	The Tc110Class singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  Tc110Class : public Hipace_ns::HipaceClass
#else
class Tc110Class : public Hipace_ns::HipaceClass
#endif
{
	/*----- PROTECTED REGION ID(Tc110Class::Additionnal DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Tc110Class::Additionnal DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
	
		//	Method prototypes
		static Tc110Class *init(const char *);
		static Tc110Class *instance();
		~Tc110Class();
		Tango::DbDatum	get_class_property(string &);
		Tango::DbDatum	get_default_device_property(string &);
		Tango::DbDatum	get_default_class_property(string &);
	
	protected:
		Tc110Class(string &);
		static Tc110Class *_instance;
		void command_factory();
		void attribute_factory(vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		string get_cvstag();
		string get_cvsroot();
	
	private:
		void device_factory(const Tango::DevVarStringArray *);
		void create_static_attribute_list(vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
		vector<string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname);
};

}	//	End of namespace

#endif   //	Tc110_H
