/*----- PROTECTED REGION ID(Tc110StateMachine.cpp) ENABLED START -----*/
static const char *RcsId = "$Id: Tc110StateMachine.cpp,v 1.3 2014-05-07 14:47:45 alessio Exp $";
//=============================================================================
//
// file :        Tc110StateMachine.cpp
//
// description : State machine file for the Tc110 class
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.3 $
// $Date: 2014-05-07 14:47:45 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include <Tc110.h>

/*----- PROTECTED REGION END -----*/	//	Tc110::Tc110StateMachine.cpp

//================================================================
//  States   |  Description
//================================================================
//  ON       |  
//  FAULT    |  
//  ALARM    |  
//  UNKNOWN  |  


namespace Tc110_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : Tc110::is_CfgSpdSwPt_allowed()
 *	Description : Execution allowed for CfgSpdSwPt attribute
 */
//--------------------------------------------------------
bool Tc110::is_CfgSpdSwPt_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for CfgSpdSwPt attribute in Write access.
	/*----- PROTECTED REGION ID(Tc110::CfgSpdSwPtStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::CfgSpdSwPtStateAllowed_WRITE

	//	Not any excluded states for CfgSpdSwPt attribute in read access.
	/*----- PROTECTED REGION ID(Tc110::CfgSpdSwPtStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::CfgSpdSwPtStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Tc110::is_CfgDO2_allowed()
 *	Description : Execution allowed for CfgDO2 attribute
 */
//--------------------------------------------------------
bool Tc110::is_CfgDO2_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for CfgDO2 attribute in Write access.
	/*----- PROTECTED REGION ID(Tc110::CfgDO2StateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::CfgDO2StateAllowed_WRITE

	//	Not any excluded states for CfgDO2 attribute in read access.
	/*----- PROTECTED REGION ID(Tc110::CfgDO2StateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::CfgDO2StateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Tc110::is_CfgAccA1_allowed()
 *	Description : Execution allowed for CfgAccA1 attribute
 */
//--------------------------------------------------------
bool Tc110::is_CfgAccA1_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for CfgAccA1 attribute in Write access.
	/*----- PROTECTED REGION ID(Tc110::CfgAccA1StateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::CfgAccA1StateAllowed_WRITE

	//	Not any excluded states for CfgAccA1 attribute in read access.
	/*----- PROTECTED REGION ID(Tc110::CfgAccA1StateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::CfgAccA1StateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Tc110::is_CfgAccB1_allowed()
 *	Description : Execution allowed for CfgAccB1 attribute
 */
//--------------------------------------------------------
bool Tc110::is_CfgAccB1_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for CfgAccB1 attribute in Write access.
	/*----- PROTECTED REGION ID(Tc110::CfgAccB1StateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::CfgAccB1StateAllowed_WRITE

	//	Not any excluded states for CfgAccB1 attribute in read access.
	/*----- PROTECTED REGION ID(Tc110::CfgAccB1StateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::CfgAccB1StateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Tc110::is_CfgAccA2_allowed()
 *	Description : Execution allowed for CfgAccA2 attribute
 */
//--------------------------------------------------------
bool Tc110::is_CfgAccA2_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for CfgAccA2 attribute in Write access.
	/*----- PROTECTED REGION ID(Tc110::CfgAccA2StateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::CfgAccA2StateAllowed_WRITE

	//	Not any excluded states for CfgAccA2 attribute in read access.
	/*----- PROTECTED REGION ID(Tc110::CfgAccA2StateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::CfgAccA2StateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Tc110::is_CfgAccB2_allowed()
 *	Description : Execution allowed for CfgAccB2 attribute
 */
//--------------------------------------------------------
bool Tc110::is_CfgAccB2_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for CfgAccB2 attribute in Write access.
	/*----- PROTECTED REGION ID(Tc110::CfgAccB2StateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::CfgAccB2StateAllowed_WRITE

	//	Not any excluded states for CfgAccB2 attribute in read access.
	/*----- PROTECTED REGION ID(Tc110::CfgAccB2StateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::CfgAccB2StateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Tc110::is_SealingGas_allowed()
 *	Description : Execution allowed for SealingGas attribute
 */
//--------------------------------------------------------
bool Tc110::is_SealingGas_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for SealingGas attribute in Write access.
	/*----- PROTECTED REGION ID(Tc110::SealingGasStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::SealingGasStateAllowed_WRITE

	//	Not any excluded states for SealingGas attribute in read access.
	/*----- PROTECTED REGION ID(Tc110::SealingGasStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::SealingGasStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Tc110::is_CtrlViaInt_allowed()
 *	Description : Execution allowed for CtrlViaInt attribute
 */
//--------------------------------------------------------
bool Tc110::is_CtrlViaInt_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for CtrlViaInt attribute in read access.
	/*----- PROTECTED REGION ID(Tc110::CtrlViaIntStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::CtrlViaIntStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Tc110::is_IntSelLckd_allowed()
 *	Description : Execution allowed for IntSelLckd attribute
 */
//--------------------------------------------------------
bool Tc110::is_IntSelLckd_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for IntSelLckd attribute in read access.
	/*----- PROTECTED REGION ID(Tc110::IntSelLckdStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::IntSelLckdStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Tc110::is_CfgDO1_allowed()
 *	Description : Execution allowed for CfgDO1 attribute
 */
//--------------------------------------------------------
bool Tc110::is_CfgDO1_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for CfgDO1 attribute in Write access.
	/*----- PROTECTED REGION ID(Tc110::CfgDO1StateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::CfgDO1StateAllowed_WRITE

	//	Not any excluded states for CfgDO1 attribute in read access.
	/*----- PROTECTED REGION ID(Tc110::CfgDO1StateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::CfgDO1StateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Tc110::is_TempElec_allowed()
 *	Description : Execution allowed for TempElec attribute
 */
//--------------------------------------------------------
bool Tc110::is_TempElec_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for TempElec attribute in read access.
	/*----- PROTECTED REGION ID(Tc110::TempElecStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::TempElecStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Tc110::is_TempPmpBot_allowed()
 *	Description : Execution allowed for TempPmpBot attribute
 */
//--------------------------------------------------------
bool Tc110::is_TempPmpBot_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for TempPmpBot attribute in read access.
	/*----- PROTECTED REGION ID(Tc110::TempPmpBotStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::TempPmpBotStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Tc110::is_AccelDecel_allowed()
 *	Description : Execution allowed for AccelDecel attribute
 */
//--------------------------------------------------------
bool Tc110::is_AccelDecel_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for AccelDecel attribute in read access.
	/*----- PROTECTED REGION ID(Tc110::AccelDecelStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::AccelDecelStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Tc110::is_TempBearng_allowed()
 *	Description : Execution allowed for TempBearng attribute
 */
//--------------------------------------------------------
bool Tc110::is_TempBearng_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for TempBearng attribute in read access.
	/*----- PROTECTED REGION ID(Tc110::TempBearngStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::TempBearngStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Tc110::is_TempMotor_allowed()
 *	Description : Execution allowed for TempMotor attribute
 */
//--------------------------------------------------------
bool Tc110::is_TempMotor_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for TempMotor attribute in read access.
	/*----- PROTECTED REGION ID(Tc110::TempMotorStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::TempMotorStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Tc110::is_HwVersion_allowed()
 *	Description : Execution allowed for HwVersion attribute
 */
//--------------------------------------------------------
bool Tc110::is_HwVersion_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for HwVersion attribute in read access.
	/*----- PROTECTED REGION ID(Tc110::HwVersionStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::HwVersionStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Tc110::is_NomSpdConf_allowed()
 *	Description : Execution allowed for NomSpdConf attribute
 */
//--------------------------------------------------------
bool Tc110::is_NomSpdConf_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for NomSpdConf attribute in Write access.
	/*----- PROTECTED REGION ID(Tc110::NomSpdConfStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::NomSpdConfStateAllowed_WRITE

	//	Not any excluded states for NomSpdConf attribute in read access.
	/*----- PROTECTED REGION ID(Tc110::NomSpdConfStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::NomSpdConfStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Tc110::is_SetRotSpdRpm_allowed()
 *	Description : Execution allowed for SetRotSpdRpm attribute
 */
//--------------------------------------------------------
bool Tc110::is_SetRotSpdRpm_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for SetRotSpdRpm attribute in read access.
	/*----- PROTECTED REGION ID(Tc110::SetRotSpdRpmStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::SetRotSpdRpmStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Tc110::is_ActualSpdRpm_allowed()
 *	Description : Execution allowed for ActualSpdRpm attribute
 */
//--------------------------------------------------------
bool Tc110::is_ActualSpdRpm_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for ActualSpdRpm attribute in read access.
	/*----- PROTECTED REGION ID(Tc110::ActualSpdRpmStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::ActualSpdRpmStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Tc110::is_NominalSpdRpm_allowed()
 *	Description : Execution allowed for NominalSpdRpm attribute
 */
//--------------------------------------------------------
bool Tc110::is_NominalSpdRpm_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for NominalSpdRpm attribute in read access.
	/*----- PROTECTED REGION ID(Tc110::NominalSpdRpmStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc110::NominalSpdRpmStateAllowed_READ
	return true;
}


//=================================================
//		Commands Allowed Methods
//=================================================


/*----- PROTECTED REGION ID(Tc110::Tc110StateAllowed.AdditionalMethods) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	Tc110::Tc110StateAllowed.AdditionalMethods

}	//	End of namespace
