/*----- PROTECTED REGION ID(Tc400.cpp) ENABLED START -----*/
static const char *RcsId = "$Id: Tc400.cpp,v 1.4 2014-05-07 06:50:26 alessio Exp $";
//=============================================================================
//
// file :        Tc400.cpp
//
// description : C++ source for the Tc400 class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               Tc400 are implemented in this file.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.4 $
// $Date: 2014-05-07 06:50:26 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <Tc400.h>
#include <Tc400Class.h>

/*----- PROTECTED REGION END -----*/	//	Tc400.cpp

/**
 *  Tc400 class description:
 *    
 */

//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name  |  Method name
//================================================================
//  State         |  Inherited (no method)
//  Status        |  Inherited (no method)
//================================================================

//================================================================
//  Attributes managed are:
//================================================================
//  FwVersion      |  Tango::DevString	Scalar
//  RemotePrio     |  Tango::DevBoolean	Scalar
//  SpdSwPtAtt     |  Tango::DevBoolean	Scalar
//  ErrorCode      |  Tango::DevString	Scalar
//  OvTempElec     |  Tango::DevBoolean	Scalar
//  OvTempPump     |  Tango::DevBoolean	Scalar
//  SetSpdAtt      |  Tango::DevBoolean	Scalar
//  PumpAccel      |  Tango::DevBoolean	Scalar
//  SetRotSpdHz    |  Tango::DevULong	Scalar
//  ActualSpdHz    |  Tango::DevULong	Scalar
//  DrvCurrent     |  Tango::DevFloat	Scalar
//  OpHrsPump      |  Tango::DevULong	Scalar
//  DrvVoltage     |  Tango::DevFloat	Scalar
//  OpHrsElec      |  Tango::DevULong	Scalar
//  NominalSpdHz   |  Tango::DevULong	Scalar
//  DrvPower       |  Tango::DevULong	Scalar
//  PumpCycles     |  Tango::DevULong	Scalar
//  TempElec       |  Tango::DevULong	Scalar
//  TempPmpBot     |  Tango::DevULong	Scalar
//  AccelDecel     |  Tango::DevULong	Scalar
//  TempBearng     |  Tango::DevULong	Scalar
//  TempMotor      |  Tango::DevULong	Scalar
//  ElecName       |  Tango::DevString	Scalar
//  HwVersion      |  Tango::DevString	Scalar
//  SetRotSpdRpm   |  Tango::DevULong	Scalar
//  ActualSpdRpm   |  Tango::DevULong	Scalar
//  NominalSpdRpm  |  Tango::DevULong	Scalar
//  RUTimeSVal     |  Tango::DevULong	Scalar
//  SpdSwPt1       |  Tango::DevULong	Scalar
//  SpdSVal        |  Tango::DevFloat	Scalar
//  PwrSVal        |  Tango::DevUShort	Scalar
//  SwoffBKP       |  Tango::DevULong	Scalar
//  SwonBKP        |  Tango::DevULong	Scalar
//  StdbyVal       |  Tango::DevFloat	Scalar
//  SpdSwPt2       |  Tango::DevULong	Scalar
//  VentSpd        |  Tango::DevUShort	Scalar
//  VentTime       |  Tango::DevULong	Scalar
//  NomSpdConf     |  Tango::DevULong	Scalar
//  Heating        |  Tango::DevBoolean	Scalar
//  Standby        |  Tango::DevBoolean	Scalar
//  RUTimeCtrl     |  Tango::DevBoolean	Scalar
//  ErrorAckn      |  Tango::DevBoolean	Scalar
//  PumpgStatn     |  Tango::DevBoolean	Scalar
//  EnableVent     |  Tango::DevBoolean	Scalar
//  CfgSpdSwPt     |  Tango::DevUShort	Scalar
//  CfgDO1         |  Tango::DevUShort	Scalar
//  CfgDO2         |  Tango::DevUShort	Scalar
//  MotorPump      |  Tango::DevBoolean	Scalar
//  OpModeBKP      |  Tango::DevUShort	Scalar
//  SpdSetMode     |  Tango::DevUShort	Scalar
//  GasMode        |  Tango::DevUShort	Scalar
//  VentMode       |  Tango::DevUShort	Scalar
//  CfgAccA1       |  Tango::DevUShort	Scalar
//  CfgAccB1       |  Tango::DevUShort	Scalar
//  CfgAccA2       |  Tango::DevUShort	Scalar
//  CfgAccB2       |  Tango::DevUShort	Scalar
//  SealingGas     |  Tango::DevBoolean	Scalar
//  CfgAO1         |  Tango::DevUShort	Scalar
//  CtrlViaInt     |  Tango::DevUShort	Scalar
//  IntSelLckd     |  Tango::DevBoolean	Scalar
//  CfgRelR1       |  Tango::DevUShort	Scalar
//  CfgRelR2       |  Tango::DevUShort	Scalar
//  CfgRelR3       |  Tango::DevUShort	Scalar
//  CfgAI1         |  Tango::DevUShort	Scalar
//  CfgDI3         |  Tango::DevUShort	Scalar
//  ErrHist        |  Tango::DevString	Spectrum  ( max = 10)
//================================================================

namespace Tc400_ns
{
/*----- PROTECTED REGION ID(Tc400::namespace_starting) ENABLED START -----*/

//	static initializations

/*----- PROTECTED REGION END -----*/	//	Tc400::namespace_starting

//--------------------------------------------------------
/**
 *	Method      : Tc400::Tc400()
 *	Description : Constructors for a Tango device
 *                implementing the classTc400
 */
//--------------------------------------------------------
Tc400::Tc400(Tango::DeviceClass *cl, string &s)
 : Tc110(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(Tc400::constructor_1) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Tc400::constructor_1
}
//--------------------------------------------------------
Tc400::Tc400(Tango::DeviceClass *cl, const char *s)
 : Tc110(cl, s)
{
	/*----- PROTECTED REGION ID(Tc400::constructor_2) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Tc400::constructor_2
}
//--------------------------------------------------------
Tc400::Tc400(Tango::DeviceClass *cl, const char *s, const char *d)
 : Tc110(cl, s, d)
{
	/*----- PROTECTED REGION ID(Tc400::constructor_3) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Tc400::constructor_3
}

//--------------------------------------------------------
/**
 *	Method      : Tc400::delete_device()
 *	Description : will be called at device destruction or at init command
 */
//--------------------------------------------------------
void Tc400::delete_device()
{
	DEBUG_STREAM << "Tc400::delete_device() " << device_name << endl;
	/*----- PROTECTED REGION ID(Tc400::delete_device) ENABLED START -----*/
	
	//	Delete device allocated objects
	
	/*----- PROTECTED REGION END -----*/	//	Tc400::delete_device
	delete[] attr_CfgRelR1_read;
	delete[] attr_CfgRelR2_read;
	delete[] attr_CfgRelR3_read;
	delete[] attr_CfgAI1_read;
	delete[] attr_CfgDI3_read;

	if (Tango::Util::instance()->is_svr_shutting_down()==false  &&
		Tango::Util::instance()->is_device_restarting(device_name)==false &&
		Tango::Util::instance()->is_svr_starting()==false)
	{
		//	If not shutting down call delete device for inherited object
		Tc110_ns::Tc110::delete_device();
	}
}

//--------------------------------------------------------
/**
 *	Method      : Tc400::init_device()
 *	Description : will be called at device initialization.
 */
//--------------------------------------------------------
void Tc400::init_device()
{
	DEBUG_STREAM << "Tc400::init_device() create device " << device_name << endl;
	/*----- PROTECTED REGION ID(Tc400::init_device_before) ENABLED START -----*/
	
	//	Initialization before get_device_property() call
	mandatoryNotDefined = false;
	
	/*----- PROTECTED REGION END -----*/	//	Tc400::init_device_before
	
	if (Tango::Util::instance()->is_svr_starting() == false  &&
		Tango::Util::instance()->is_device_restarting(device_name)==false)
	{
		//	If not starting up call init device for inherited object
		Tc110_ns::Tc110::init_device();
	}
	//	No device property to be read from database
	
	attr_CfgRelR1_read = new Tango::DevUShort[1];
	attr_CfgRelR2_read = new Tango::DevUShort[1];
	attr_CfgRelR3_read = new Tango::DevUShort[1];
	attr_CfgAI1_read = new Tango::DevUShort[1];
	attr_CfgDI3_read = new Tango::DevUShort[1];
	//	No longer if mandatory property not set. 
	if (mandatoryNotDefined)
		return;

	/*----- PROTECTED REGION ID(Tc400::init_device) ENABLED START -----*/
	
	//	Initialize device
	
	/*----- PROTECTED REGION END -----*/	//	Tc400::init_device
}


//--------------------------------------------------------
/**
 *	Method      : Tc400::always_executed_hook()
 *	Description : method always executed before any command is executed
 */
//--------------------------------------------------------
void Tc400::always_executed_hook()
{
	DEBUG_STREAM << "Tc400::always_executed_hook()  " << device_name << endl;
	if (mandatoryNotDefined)
	{
		string	status(get_status());
		Tango::Except::throw_exception(
					(const char *)"PROPERTY_NOT_SET",
					status.c_str(),
					(const char *)"Tc400::always_executed_hook()");
	}
	/*----- PROTECTED REGION ID(Tc400::always_executed_hook) ENABLED START -----*/
	
	//	code always executed before all requests
	Tc110_ns::Tc110::always_executed_hook();
	
	/*----- PROTECTED REGION END -----*/	//	Tc400::always_executed_hook
}

//--------------------------------------------------------
/**
 *	Method      : Tc400::read_attr_hardware()
 *	Description : Hardware acquisition for attributes
 */
//--------------------------------------------------------
void Tc400::read_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "Tc400::read_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc400::read_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	check_init();
	
	/*----- PROTECTED REGION END -----*/	//	Tc400::read_attr_hardware
}
//--------------------------------------------------------
/**
 *	Method      : Tc400::write_attr_hardware()
 *	Description : Hardware writing for attributes
 */
//--------------------------------------------------------
void Tc400::write_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "Tc400::write_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc400::write_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Tc400::write_attr_hardware
}

//--------------------------------------------------------
/**
 *	Read attribute CfgRelR1 related method
 *	Description: Configurazione rele` R1
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc400::read_CfgRelR1(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tc400::read_CfgRelR1(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc400::read_CfgRelR1) ENABLED START -----*/
	//	Set the attribute value

 	query("045", attr_CfgRelR1_read[0]);
	attr.set_value(attr_CfgRelR1_read);

	/*----- PROTECTED REGION END -----*/	//	Tc400::read_CfgRelR1
}
//--------------------------------------------------------
/**
 *	Write attribute CfgRelR1 related method
 *	Description: Configurazione rele` R1
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc400::write_CfgRelR1(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Tc400::write_CfgRelR1(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevUShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Tc400::write_CfgRelR1) ENABLED START -----*/
	check_init();
 	command("045", w_val);

	/*----- PROTECTED REGION END -----*/	//	Tc400::write_CfgRelR1
}
//--------------------------------------------------------
/**
 *	Read attribute CfgRelR2 related method
 *	Description: Configurazione rele` R2
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc400::read_CfgRelR2(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tc400::read_CfgRelR2(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc400::read_CfgRelR2) ENABLED START -----*/
	//	Set the attribute value

 	query("046", attr_CfgRelR2_read[0]);
	attr.set_value(attr_CfgRelR2_read);

	/*----- PROTECTED REGION END -----*/	//	Tc400::read_CfgRelR2
}
//--------------------------------------------------------
/**
 *	Write attribute CfgRelR2 related method
 *	Description: Configurazione rele` R2
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc400::write_CfgRelR2(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Tc400::write_CfgRelR2(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevUShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Tc400::write_CfgRelR2) ENABLED START -----*/
	check_init();
 	command("046", w_val);

	/*----- PROTECTED REGION END -----*/	//	Tc400::write_CfgRelR2
}
//--------------------------------------------------------
/**
 *	Read attribute CfgRelR3 related method
 *	Description: Configurazione rele` R3
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc400::read_CfgRelR3(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tc400::read_CfgRelR3(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc400::read_CfgRelR3) ENABLED START -----*/
	//	Set the attribute value

 	query("047", attr_CfgRelR3_read[0]);
	attr.set_value(attr_CfgRelR3_read);

	/*----- PROTECTED REGION END -----*/	//	Tc400::read_CfgRelR3
}
//--------------------------------------------------------
/**
 *	Write attribute CfgRelR3 related method
 *	Description: Configurazione rele` R3
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc400::write_CfgRelR3(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Tc400::write_CfgRelR3(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevUShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Tc400::write_CfgRelR3) ENABLED START -----*/
	check_init();	
 	command("047", w_val);

	/*----- PROTECTED REGION END -----*/	//	Tc400::write_CfgRelR3
}
//--------------------------------------------------------
/**
 *	Read attribute CfgAI1 related method
 *	Description: Configurazione ingresso AI1
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc400::read_CfgAI1(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tc400::read_CfgAI1(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc400::read_CfgAI1) ENABLED START -----*/
	//	Set the attribute value

 	query("057", attr_CfgAI1_read[0]);
	attr.set_value(attr_CfgAI1_read);

	/*----- PROTECTED REGION END -----*/	//	Tc400::read_CfgAI1
}
//--------------------------------------------------------
/**
 *	Write attribute CfgAI1 related method
 *	Description: Configurazione ingresso AI1
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc400::write_CfgAI1(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Tc400::write_CfgAI1(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevUShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Tc400::write_CfgAI1) ENABLED START -----*/
	check_init();
 	command("057", w_val);

	/*----- PROTECTED REGION END -----*/	//	Tc400::write_CfgAI1
}
//--------------------------------------------------------
/**
 *	Read attribute CfgDI3 related method
 *	Description: Configurazione ingresso DI3
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc400::read_CfgDI3(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tc400::read_CfgDI3(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc400::read_CfgDI3) ENABLED START -----*/
	//	Set the attribute value

 	query("064", attr_CfgDI3_read[0]);
	attr.set_value(attr_CfgDI3_read);

	/*----- PROTECTED REGION END -----*/	//	Tc400::read_CfgDI3
}
//--------------------------------------------------------
/**
 *	Write attribute CfgDI3 related method
 *	Description: Configurazione ingresso DI3
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc400::write_CfgDI3(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Tc400::write_CfgDI3(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevUShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Tc400::write_CfgDI3) ENABLED START -----*/
	check_init();
 	command("064", w_val);

	/*----- PROTECTED REGION END -----*/	//	Tc400::write_CfgDI3
}

//--------------------------------------------------------
/**
 *	Method      : Tc400::add_dynamic_attributes()
 *	Description : Create the dynamic attributes if any
 *                for specified device.
 */
//--------------------------------------------------------
void Tc400::add_dynamic_attributes()
{
	/*----- PROTECTED REGION ID(Tc400::add_dynamic_attributes) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic attributes if any
	
	/*----- PROTECTED REGION END -----*/	//	Tc400::add_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : Tc400::add_dynamic_commands()
 *	Description : Create the dynamic commands if any
 *                for specified device.
 */
//--------------------------------------------------------
void Tc400::add_dynamic_commands()
{
	/*----- PROTECTED REGION ID(Tc400::add_dynamic_commands) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic commands if any
	
	/*----- PROTECTED REGION END -----*/	//	Tc400::add_dynamic_commands
}

/*----- PROTECTED REGION ID(Tc400::namespace_ending) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	Tc400::namespace_ending
} //	namespace
