/*----- PROTECTED REGION ID(Tc400.h) ENABLED START -----*/
//=============================================================================
//
// file :        Tc400.h
//
// description : Include file for the Tc400 class
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.3 $
// $Date: 2014-05-05 09:10:06 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef Tc400_H
#define Tc400_H

#include <tango.h>
#include <Hipace.h>
#include <Tc110.h>


/*----- PROTECTED REGION END -----*/	//	Tc400.h

/**
 *  Tc400 class description:
 *    
 */

namespace Tc400_ns
{
/*----- PROTECTED REGION ID(Tc400::Additional Class Declarations) ENABLED START -----*/

//	Additional Class Declarations

/*----- PROTECTED REGION END -----*/	//	Tc400::Additional Class Declarations

class Tc400 : public Tc110_ns::Tc110
{

/*----- PROTECTED REGION ID(Tc400::Data Members) ENABLED START -----*/

//	Add your own data members

/*----- PROTECTED REGION END -----*/	//	Tc400::Data Members

//	Device property data members
public:

	bool	mandatoryNotDefined;

//	Attribute data members
public:
	Tango::DevUShort	*attr_CfgRelR1_read;
	Tango::DevUShort	*attr_CfgRelR2_read;
	Tango::DevUShort	*attr_CfgRelR3_read;
	Tango::DevUShort	*attr_CfgAI1_read;
	Tango::DevUShort	*attr_CfgDI3_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Tc400(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Tc400(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	Tc400(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */
	~Tc400() {delete_device();};


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();

	/*
	 *	Check if mandatory property has been set
	 */
	 void check_mandatory_property(Tango::DbDatum &class_prop, Tango::DbDatum &dev_prop);

//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method      : Tc400::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(vector<long> &attr_list);
	//--------------------------------------------------------
	/*
	 *	Method      : Tc400::write_attr_hardware()
	 *	Description : Hardware writing for attributes.
	 */
	//--------------------------------------------------------
	virtual void write_attr_hardware(vector<long> &attr_list);

/**
 *	Attribute CfgRelR1 related methods
 *	Description: Configurazione rele` R1
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
	virtual void read_CfgRelR1(Tango::Attribute &attr);
	virtual void write_CfgRelR1(Tango::WAttribute &attr);
	virtual bool is_CfgRelR1_allowed(Tango::AttReqType type);
/**
 *	Attribute CfgRelR2 related methods
 *	Description: Configurazione rele` R2
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
	virtual void read_CfgRelR2(Tango::Attribute &attr);
	virtual void write_CfgRelR2(Tango::WAttribute &attr);
	virtual bool is_CfgRelR2_allowed(Tango::AttReqType type);
/**
 *	Attribute CfgRelR3 related methods
 *	Description: Configurazione rele` R3
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
	virtual void read_CfgRelR3(Tango::Attribute &attr);
	virtual void write_CfgRelR3(Tango::WAttribute &attr);
	virtual bool is_CfgRelR3_allowed(Tango::AttReqType type);
/**
 *	Attribute CfgAI1 related methods
 *	Description: Configurazione ingresso AI1
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
	virtual void read_CfgAI1(Tango::Attribute &attr);
	virtual void write_CfgAI1(Tango::WAttribute &attr);
	virtual bool is_CfgAI1_allowed(Tango::AttReqType type);
/**
 *	Attribute CfgDI3 related methods
 *	Description: Configurazione ingresso DI3
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
	virtual void read_CfgDI3(Tango::Attribute &attr);
	virtual void write_CfgDI3(Tango::WAttribute &attr);
	virtual bool is_CfgDI3_allowed(Tango::AttReqType type);


	//--------------------------------------------------------
	/**
	 *	Method      : Tc400::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();




//	Command related methods
public:


	//--------------------------------------------------------
	/**
	 *	Method      : Tc400::add_dynamic_commands()
	 *	Description : Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(Tc400::Additional Method prototypes) ENABLED START -----*/

//	Additional Method prototypes

/*----- PROTECTED REGION END -----*/	//	Tc400::Additional Method prototypes
};

/*----- PROTECTED REGION ID(Tc400::Additional Classes Definitions) ENABLED START -----*/

//	Additional Classes Definitions

/*----- PROTECTED REGION END -----*/	//	Tc400::Additional Classes Definitions

}	//	End of namespace

#endif   //	Tc400_H
