/*----- PROTECTED REGION ID(Tc400Class.cpp) ENABLED START -----*/
static const char *RcsId      = "$Id: Tc400Class.cpp,v 1.4 2015-08-03 09:26:54 alessio Exp $";
static const char *TagName    = "Tc400 $Name:  $";
static const char *CvsPath    = "$Source: /home/cvsadm/cvsroot/fermi/servers/hipace/src/Tc400Class.cpp,v $";
static const char *SvnPath    = "$HeadURL:  $";
static const char *HttpServer = "http://www.esrf.eu/computing/cs/tango/tango_doc/ds_doc/";
//=============================================================================
//
// file :        Tc400Class.cpp
//
// description : C++ source for the Tc400Class.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the Tc400 once per process.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.4 $
// $Date: 2015-08-03 09:26:54 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <Tc400Class.h>

/*----- PROTECTED REGION END -----*/	//	Tc400Class.cpp

//-------------------------------------------------------------------
/**
 *	Create Tc400Class singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_Tc400_class(const char *name) {
		return Tc400_ns::Tc400Class::init(name);
	}
}

namespace Tc400_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
Tc400Class *Tc400Class::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		Tc400Class::Tc400Class(string &s)
 * description : 	constructor for the Tc400Class
 *
 * @param s	The class name
 */
//--------------------------------------------------------
Tc400Class::Tc400Class(string &s):Tc110_ns::Tc110Class(s)
{
	cout2 << "Entering Tc400Class constructor" << endl;
	set_default_property();
	write_class_property();

	/*----- PROTECTED REGION ID(Tc400Class::constructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc400Class::constructor

	cout2 << "Leaving Tc400Class constructor" << endl;
}

//--------------------------------------------------------
/**
 * method : 		Tc400Class::~Tc400Class()
 * description : 	destructor for the Tc400Class
 */
//--------------------------------------------------------
Tc400Class::~Tc400Class()
{
	/*----- PROTECTED REGION ID(Tc400Class::destructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc400Class::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		Tc400Class::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
Tc400Class *Tc400Class::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new Tc400Class(s);
		}
		catch (bad_alloc &)
		{
			throw;
		}
	}
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		Tc400Class::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
Tc400Class *Tc400Class::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================

//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method      : Tc400Class::get_class_property()
 *	Description : Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum Tc400Class::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : Tc400Class::get_default_device_property()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum Tc400Class::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : Tc400Class::get_default_class_property()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum Tc400Class::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : Tc400Class::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void Tc400Class::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;
	vector<string>	vect_data;

	//	Set Default Class Properties

	//	Set Default device Properties
}

//--------------------------------------------------------
/**
 *	Method      : Tc400Class::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void Tc400Class::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("");
	description << str_desc;
	data.push_back(description);

	//	put cvs or svn location
	string	filename("Tc400");
	filename += "Class.cpp";

	// check for cvs information
	string	src_path(CvsPath);
	start = src_path.find("/");
	if (start!=string::npos)
	{
		end   = src_path.find(filename);
		if (end>start)
		{
			string	strloc = src_path.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}

	// check for svn information
	else
	{
		string	src_path(SvnPath);
		start = src_path.find("://");
		if (start!=string::npos)
		{
			end = src_path.find(filename);
			if (end>start)
			{
				header = "$HeadURL: ";
				start = header.length();
				string	strloc = src_path.substr(start, (end-start));
				
				Tango::DbDatum	svn_loc("svn_location");
				svn_loc << strloc;
				data.push_back(svn_loc);
			}
		}
	}

	//	Get CVS or SVN revision tag
	
	// CVS tag
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}
	
	// SVN tag
	string	svnpath(SvnPath);
	header = "$HeadURL: ";
	start = header.length();
	
	end   = svnpath.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strloc = svnpath.substr(start, end-start);
		
		string tagstr ("/tags/");
		start = strloc.find(tagstr);
		if ( start!=string::npos )
		{
			start = start + tagstr.length();
			end   = strloc.find(filename);
			string	strtag = strloc.substr(start, end-start-1);
			
			Tango::DbDatum	svn_tag("svn_tag");
			svn_tag << strtag;
			data.push_back(svn_tag);
		}
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method      : Tc400Class::device_factory()
 *	Description : Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void Tc400Class::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(Tc400Class::device_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Tc400Class::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new Tc400(this, (*devlist_ptr)[i]));
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		Tc400 *dev = static_cast<Tc400 *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(Tc400Class::device_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Tc400Class::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : Tc400Class::attribute_factory()
 *	Description : Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void Tc400Class::attribute_factory(vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(Tc400Class::attribute_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Tc400Class::attribute_factory_before
	//	Call atribute_factory for inherited class
	Tc110_ns::Tc110Class::attribute_factory(att_list);

	//	Attribute : FwVersion - Check if not concrete in inherited class
	Tango::Attr *FwVersionAttr = get_attr_object_by_name(att_list, "FwVersion");
	if (FwVersionAttr == NULL)
	{
	}

	//	Attribute : RemotePrio - Check if not concrete in inherited class
	Tango::Attr *RemotePrioAttr = get_attr_object_by_name(att_list, "RemotePrio");
	if (RemotePrioAttr == NULL)
	{
	}

	//	Attribute : SpdSwPtAtt - Check if not concrete in inherited class
	Tango::Attr *SpdSwPtAttAttr = get_attr_object_by_name(att_list, "SpdSwPtAtt");
	if (SpdSwPtAttAttr == NULL)
	{
	}

	//	Attribute : ErrorCode - Check if not concrete in inherited class
	Tango::Attr *ErrorCodeAttr = get_attr_object_by_name(att_list, "ErrorCode");
	if (ErrorCodeAttr == NULL)
	{
	}

	//	Attribute : OvTempElec - Check if not concrete in inherited class
	Tango::Attr *OvTempElecAttr = get_attr_object_by_name(att_list, "OvTempElec");
	if (OvTempElecAttr == NULL)
	{
	}

	//	Attribute : OvTempPump - Check if not concrete in inherited class
	Tango::Attr *OvTempPumpAttr = get_attr_object_by_name(att_list, "OvTempPump");
	if (OvTempPumpAttr == NULL)
	{
	}

	//	Attribute : SetSpdAtt - Check if not concrete in inherited class
	Tango::Attr *SetSpdAttAttr = get_attr_object_by_name(att_list, "SetSpdAtt");
	if (SetSpdAttAttr == NULL)
	{
	}

	//	Attribute : PumpAccel - Check if not concrete in inherited class
	Tango::Attr *PumpAccelAttr = get_attr_object_by_name(att_list, "PumpAccel");
	if (PumpAccelAttr == NULL)
	{
	}

	//	Attribute : SetRotSpdHz - Check if not concrete in inherited class
	Tango::Attr *SetRotSpdHzAttr = get_attr_object_by_name(att_list, "SetRotSpdHz");
	if (SetRotSpdHzAttr == NULL)
	{
	}

	//	Attribute : ActualSpdHz - Check if not concrete in inherited class
	Tango::Attr *ActualSpdHzAttr = get_attr_object_by_name(att_list, "ActualSpdHz");
	if (ActualSpdHzAttr == NULL)
	{
	}

	//	Attribute : DrvCurrent - Check if not concrete in inherited class
	Tango::Attr *DrvCurrentAttr = get_attr_object_by_name(att_list, "DrvCurrent");
	if (DrvCurrentAttr == NULL)
	{
	}

	//	Attribute : OpHrsPump - Check if not concrete in inherited class
	Tango::Attr *OpHrsPumpAttr = get_attr_object_by_name(att_list, "OpHrsPump");
	if (OpHrsPumpAttr == NULL)
	{
	}

	//	Attribute : DrvVoltage - Check if not concrete in inherited class
	Tango::Attr *DrvVoltageAttr = get_attr_object_by_name(att_list, "DrvVoltage");
	if (DrvVoltageAttr == NULL)
	{
	}

	//	Attribute : OpHrsElec - Check if not concrete in inherited class
	Tango::Attr *OpHrsElecAttr = get_attr_object_by_name(att_list, "OpHrsElec");
	if (OpHrsElecAttr == NULL)
	{
	}

	//	Attribute : NominalSpdHz - Check if not concrete in inherited class
	Tango::Attr *NominalSpdHzAttr = get_attr_object_by_name(att_list, "NominalSpdHz");
	if (NominalSpdHzAttr == NULL)
	{
	}

	//	Attribute : DrvPower - Check if not concrete in inherited class
	Tango::Attr *DrvPowerAttr = get_attr_object_by_name(att_list, "DrvPower");
	if (DrvPowerAttr == NULL)
	{
	}

	//	Attribute : PumpCycles - Check if not concrete in inherited class
	Tango::Attr *PumpCyclesAttr = get_attr_object_by_name(att_list, "PumpCycles");
	if (PumpCyclesAttr == NULL)
	{
	}

	//	Attribute : TempElec - Check if not concrete in inherited class
	Tango::Attr *TempElecAttr = get_attr_object_by_name(att_list, "TempElec");
	if (TempElecAttr == NULL)
	{
	}

	//	Attribute : TempPmpBot - Check if not concrete in inherited class
	Tango::Attr *TempPmpBotAttr = get_attr_object_by_name(att_list, "TempPmpBot");
	if (TempPmpBotAttr == NULL)
	{
	}

	//	Attribute : AccelDecel - Check if not concrete in inherited class
	Tango::Attr *AccelDecelAttr = get_attr_object_by_name(att_list, "AccelDecel");
	if (AccelDecelAttr == NULL)
	{
	}

	//	Attribute : TempBearng - Check if not concrete in inherited class
	Tango::Attr *TempBearngAttr = get_attr_object_by_name(att_list, "TempBearng");
	if (TempBearngAttr == NULL)
	{
	}

	//	Attribute : TempMotor - Check if not concrete in inherited class
	Tango::Attr *TempMotorAttr = get_attr_object_by_name(att_list, "TempMotor");
	if (TempMotorAttr == NULL)
	{
	}

	//	Attribute : ElecName - Check if not concrete in inherited class
	Tango::Attr *ElecNameAttr = get_attr_object_by_name(att_list, "ElecName");
	if (ElecNameAttr == NULL)
	{
	}

	//	Attribute : HwVersion - Check if not concrete in inherited class
	Tango::Attr *HwVersionAttr = get_attr_object_by_name(att_list, "HwVersion");
	if (HwVersionAttr == NULL)
	{
	}

	//	Attribute : SetRotSpdRpm - Check if not concrete in inherited class
	Tango::Attr *SetRotSpdRpmAttr = get_attr_object_by_name(att_list, "SetRotSpdRpm");
	if (SetRotSpdRpmAttr == NULL)
	{
	}

	//	Attribute : ActualSpdRpm - Check if not concrete in inherited class
	Tango::Attr *ActualSpdRpmAttr = get_attr_object_by_name(att_list, "ActualSpdRpm");
	if (ActualSpdRpmAttr == NULL)
	{
	}

	//	Attribute : NominalSpdRpm - Check if not concrete in inherited class
	Tango::Attr *NominalSpdRpmAttr = get_attr_object_by_name(att_list, "NominalSpdRpm");
	if (NominalSpdRpmAttr == NULL)
	{
	}

	//	Attribute : RUTimeSVal - Check if not concrete in inherited class
	Tango::Attr *RUTimeSValAttr = get_attr_object_by_name(att_list, "RUTimeSVal");
	if (RUTimeSValAttr == NULL)
	{
	}

	//	Attribute : SpdSwPt1 - Check if not concrete in inherited class
	Tango::Attr *SpdSwPt1Attr = get_attr_object_by_name(att_list, "SpdSwPt1");
	if (SpdSwPt1Attr == NULL)
	{
	}

	//	Attribute : SpdSVal - Check if not concrete in inherited class
	Tango::Attr *SpdSValAttr = get_attr_object_by_name(att_list, "SpdSVal");
	if (SpdSValAttr == NULL)
	{
	}

	//	Attribute : PwrSVal - Check if not concrete in inherited class
	Tango::Attr *PwrSValAttr = get_attr_object_by_name(att_list, "PwrSVal");
	if (PwrSValAttr == NULL)
	{
	}

	//	Attribute : SwoffBKP - Check if not concrete in inherited class
	Tango::Attr *SwoffBKPAttr = get_attr_object_by_name(att_list, "SwoffBKP");
	if (SwoffBKPAttr == NULL)
	{
	}

	//	Attribute : SwonBKP - Check if not concrete in inherited class
	Tango::Attr *SwonBKPAttr = get_attr_object_by_name(att_list, "SwonBKP");
	if (SwonBKPAttr == NULL)
	{
	}

	//	Attribute : StdbyVal - Check if not concrete in inherited class
	Tango::Attr *StdbyValAttr = get_attr_object_by_name(att_list, "StdbyVal");
	if (StdbyValAttr == NULL)
	{
	}

	//	Attribute : SpdSwPt2 - Check if not concrete in inherited class
	Tango::Attr *SpdSwPt2Attr = get_attr_object_by_name(att_list, "SpdSwPt2");
	if (SpdSwPt2Attr == NULL)
	{
	}

	//	Attribute : VentSpd - Check if not concrete in inherited class
	Tango::Attr *VentSpdAttr = get_attr_object_by_name(att_list, "VentSpd");
	if (VentSpdAttr == NULL)
	{
	}

	//	Attribute : VentTime - Check if not concrete in inherited class
	Tango::Attr *VentTimeAttr = get_attr_object_by_name(att_list, "VentTime");
	if (VentTimeAttr == NULL)
	{
	}

	//	Attribute : NomSpdConf - Check if not concrete in inherited class
	Tango::Attr *NomSpdConfAttr = get_attr_object_by_name(att_list, "NomSpdConf");
	if (NomSpdConfAttr == NULL)
	{
	}

	//	Attribute : Heating - Check if not concrete in inherited class
	Tango::Attr *HeatingAttr = get_attr_object_by_name(att_list, "Heating");
	if (HeatingAttr == NULL)
	{
	}

	//	Attribute : Standby - Check if not concrete in inherited class
	Tango::Attr *StandbyAttr = get_attr_object_by_name(att_list, "Standby");
	if (StandbyAttr == NULL)
	{
	}

	//	Attribute : RUTimeCtrl - Check if not concrete in inherited class
	Tango::Attr *RUTimeCtrlAttr = get_attr_object_by_name(att_list, "RUTimeCtrl");
	if (RUTimeCtrlAttr == NULL)
	{
	}

	//	Attribute : ErrorAckn - Check if not concrete in inherited class
	Tango::Attr *ErrorAcknAttr = get_attr_object_by_name(att_list, "ErrorAckn");
	if (ErrorAcknAttr == NULL)
	{
	}

	//	Attribute : PumpgStatn - Check if not concrete in inherited class
	Tango::Attr *PumpgStatnAttr = get_attr_object_by_name(att_list, "PumpgStatn");
	if (PumpgStatnAttr == NULL)
	{
	}

	//	Attribute : EnableVent - Check if not concrete in inherited class
	Tango::Attr *EnableVentAttr = get_attr_object_by_name(att_list, "EnableVent");
	if (EnableVentAttr == NULL)
	{
	}

	//	Attribute : CfgSpdSwPt - Check if not concrete in inherited class
	Tango::Attr *CfgSpdSwPtAttr = get_attr_object_by_name(att_list, "CfgSpdSwPt");
	if (CfgSpdSwPtAttr == NULL)
	{
	}

	//	Attribute : CfgDO1 - Check if not concrete in inherited class
	Tango::Attr *CfgDO1Attr = get_attr_object_by_name(att_list, "CfgDO1");
	if (CfgDO1Attr == NULL)
	{
	}

	//	Attribute : CfgDO2 - Check if not concrete in inherited class
	Tango::Attr *CfgDO2Attr = get_attr_object_by_name(att_list, "CfgDO2");
	if (CfgDO2Attr == NULL)
	{
	}

	//	Attribute : MotorPump - Check if not concrete in inherited class
	Tango::Attr *MotorPumpAttr = get_attr_object_by_name(att_list, "MotorPump");
	if (MotorPumpAttr == NULL)
	{
	}

	//	Attribute : OpModeBKP - Check if not concrete in inherited class
	Tango::Attr *OpModeBKPAttr = get_attr_object_by_name(att_list, "OpModeBKP");
	if (OpModeBKPAttr == NULL)
	{
	}

	//	Attribute : SpdSetMode - Check if not concrete in inherited class
	Tango::Attr *SpdSetModeAttr = get_attr_object_by_name(att_list, "SpdSetMode");
	if (SpdSetModeAttr == NULL)
	{
	}

	//	Attribute : GasMode - Check if not concrete in inherited class
	Tango::Attr *GasModeAttr = get_attr_object_by_name(att_list, "GasMode");
	if (GasModeAttr == NULL)
	{
	}

	//	Attribute : VentMode - Check if not concrete in inherited class
	Tango::Attr *VentModeAttr = get_attr_object_by_name(att_list, "VentMode");
	if (VentModeAttr == NULL)
	{
	}

	//	Attribute : CfgAccA1 - Check if not concrete in inherited class
	Tango::Attr *CfgAccA1Attr = get_attr_object_by_name(att_list, "CfgAccA1");
	if (CfgAccA1Attr == NULL)
	{
	}

	//	Attribute : CfgAccB1 - Check if not concrete in inherited class
	Tango::Attr *CfgAccB1Attr = get_attr_object_by_name(att_list, "CfgAccB1");
	if (CfgAccB1Attr == NULL)
	{
	}

	//	Attribute : CfgAccA2 - Check if not concrete in inherited class
	Tango::Attr *CfgAccA2Attr = get_attr_object_by_name(att_list, "CfgAccA2");
	if (CfgAccA2Attr == NULL)
	{
	}

	//	Attribute : CfgAccB2 - Check if not concrete in inherited class
	Tango::Attr *CfgAccB2Attr = get_attr_object_by_name(att_list, "CfgAccB2");
	if (CfgAccB2Attr == NULL)
	{
	}

	//	Attribute : SealingGas - Check if not concrete in inherited class
	Tango::Attr *SealingGasAttr = get_attr_object_by_name(att_list, "SealingGas");
	if (SealingGasAttr == NULL)
	{
	}

	//	Attribute : CfgAO1 - Check if not concrete in inherited class
	Tango::Attr *CfgAO1Attr = get_attr_object_by_name(att_list, "CfgAO1");
	if (CfgAO1Attr == NULL)
	{
	}

	//	Attribute : CtrlViaInt - Check if not concrete in inherited class
	Tango::Attr *CtrlViaIntAttr = get_attr_object_by_name(att_list, "CtrlViaInt");
	if (CtrlViaIntAttr == NULL)
	{
	}

	//	Attribute : IntSelLckd - Check if not concrete in inherited class
	Tango::Attr *IntSelLckdAttr = get_attr_object_by_name(att_list, "IntSelLckd");
	if (IntSelLckdAttr == NULL)
	{
	}

	//	Attribute : CfgRelR1
	CfgRelR1Attrib	*cfgrelr1 = new CfgRelR1Attrib();
	Tango::UserDefaultAttrProp	cfgrelr1_prop;
	cfgrelr1_prop.set_description("Configurazione rele` R1");
	cfgrelr1_prop.set_label("CfgRelR1 (045)");
	//	unit	not set for CfgRelR1
	//	standard_unit	not set for CfgRelR1
	//	display_unit	not set for CfgRelR1
	//	format	not set for CfgRelR1
	cfgrelr1_prop.set_max_value("17");
	cfgrelr1_prop.set_min_value("0");
	//	max_alarm	not set for CfgRelR1
	//	min_alarm	not set for CfgRelR1
	//	max_warning	not set for CfgRelR1
	//	min_warning	not set for CfgRelR1
	//	delta_t	not set for CfgRelR1
	//	delta_val	not set for CfgRelR1
	
	cfgrelr1->set_default_properties(cfgrelr1_prop);
	//	Not Polled
	cfgrelr1->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(cfgrelr1);

	//	Attribute : CfgRelR2
	CfgRelR2Attrib	*cfgrelr2 = new CfgRelR2Attrib();
	Tango::UserDefaultAttrProp	cfgrelr2_prop;
	cfgrelr2_prop.set_description("Configurazione rele` R2");
	cfgrelr2_prop.set_label("CfgRelR2 (046)");
	//	unit	not set for CfgRelR2
	//	standard_unit	not set for CfgRelR2
	//	display_unit	not set for CfgRelR2
	//	format	not set for CfgRelR2
	cfgrelr2_prop.set_max_value("17");
	cfgrelr2_prop.set_min_value("0");
	//	max_alarm	not set for CfgRelR2
	//	min_alarm	not set for CfgRelR2
	//	max_warning	not set for CfgRelR2
	//	min_warning	not set for CfgRelR2
	//	delta_t	not set for CfgRelR2
	//	delta_val	not set for CfgRelR2
	
	cfgrelr2->set_default_properties(cfgrelr2_prop);
	//	Not Polled
	cfgrelr2->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(cfgrelr2);

	//	Attribute : CfgRelR3
	CfgRelR3Attrib	*cfgrelr3 = new CfgRelR3Attrib();
	Tango::UserDefaultAttrProp	cfgrelr3_prop;
	cfgrelr3_prop.set_description("Configurazione rele` R3");
	cfgrelr3_prop.set_label("CfgRelR3 (047)");
	//	unit	not set for CfgRelR3
	//	standard_unit	not set for CfgRelR3
	//	display_unit	not set for CfgRelR3
	//	format	not set for CfgRelR3
	cfgrelr3_prop.set_max_value("17");
	cfgrelr3_prop.set_min_value("0");
	//	max_alarm	not set for CfgRelR3
	//	min_alarm	not set for CfgRelR3
	//	max_warning	not set for CfgRelR3
	//	min_warning	not set for CfgRelR3
	//	delta_t	not set for CfgRelR3
	//	delta_val	not set for CfgRelR3
	
	cfgrelr3->set_default_properties(cfgrelr3_prop);
	//	Not Polled
	cfgrelr3->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(cfgrelr3);

	//	Attribute : CfgAI1
	CfgAI1Attrib	*cfgai1 = new CfgAI1Attrib();
	Tango::UserDefaultAttrProp	cfgai1_prop;
	cfgai1_prop.set_description("Configurazione ingresso AI1");
	cfgai1_prop.set_label("CfgAI1 (057)");
	//	unit	not set for CfgAI1
	//	standard_unit	not set for CfgAI1
	//	display_unit	not set for CfgAI1
	//	format	not set for CfgAI1
	cfgai1_prop.set_max_value("1");
	cfgai1_prop.set_min_value("0");
	//	max_alarm	not set for CfgAI1
	//	min_alarm	not set for CfgAI1
	//	max_warning	not set for CfgAI1
	//	min_warning	not set for CfgAI1
	//	delta_t	not set for CfgAI1
	//	delta_val	not set for CfgAI1
	
	cfgai1->set_default_properties(cfgai1_prop);
	//	Not Polled
	cfgai1->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(cfgai1);

	//	Attribute : CfgDI3
	CfgDI3Attrib	*cfgdi3 = new CfgDI3Attrib();
	Tango::UserDefaultAttrProp	cfgdi3_prop;
	cfgdi3_prop.set_description("Configurazione ingresso DI3");
	cfgdi3_prop.set_label("CfgDI3 (064)");
	//	unit	not set for CfgDI3
	//	standard_unit	not set for CfgDI3
	//	display_unit	not set for CfgDI3
	//	format	not set for CfgDI3
	cfgdi3_prop.set_max_value("5");
	cfgdi3_prop.set_min_value("0");
	//	max_alarm	not set for CfgDI3
	//	min_alarm	not set for CfgDI3
	//	max_warning	not set for CfgDI3
	//	min_warning	not set for CfgDI3
	//	delta_t	not set for CfgDI3
	//	delta_val	not set for CfgDI3
	
	cfgdi3->set_default_properties(cfgdi3_prop);
	//	Not Polled
	cfgdi3->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(cfgdi3);

	//	Attribute : ErrHist - Check if not concrete in inherited class
	Tango::Attr *ErrHistAttr = get_attr_object_by_name(att_list, "ErrHist");
	if (ErrHistAttr == NULL)
	{
	}


	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(Tc400Class::attribute_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Tc400Class::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : Tc400Class::pipe_factory()
 *	Description : Create the pipe object(s)
 *                and store them in the pipe list
 */
//--------------------------------------------------------
void Tc400Class::pipe_factory()
{
	/*----- PROTECTED REGION ID(Tc400Class::pipe_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Tc400Class::pipe_factory_before
	/*----- PROTECTED REGION ID(Tc400Class::pipe_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Tc400Class::pipe_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : Tc400Class::command_factory()
 *	Description : Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void Tc400Class::command_factory()
{
	/*----- PROTECTED REGION ID(Tc400Class::command_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Tc400Class::command_factory_before
	//	Call command_factory for inherited class
	Tc110_ns::Tc110Class::command_factory();



	/*----- PROTECTED REGION ID(Tc400Class::command_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Tc400Class::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		Tc400Class::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list
 */
//--------------------------------------------------------
void Tc400Class::create_static_attribute_list(vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	cout2 << defaultAttList.size() << " attributes in default list" << endl;

	/*----- PROTECTED REGION ID(Tc400Class::create_static_att_list) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc400Class::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		Tc400Class::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void Tc400Class::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((string)(*devlist_ptr)[i]).c_str());
		Tc400 *dev = static_cast<Tc400 *> (dev_impl);

		vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			vector<string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				cout2 << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(Tc400Class::erase_dynamic_attributes) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc400Class::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : Tc400Class::get_attr_by_name()
 *	Description : returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *Tc400Class::get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname)
{
	vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; ++it)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(Tc400Class::Additional Methods) ENABLED START -----*/

/*----- PROTECTED REGION END -----*/	//	Tc400Class::Additional Methods
} //	namespace
