/*----- PROTECTED REGION ID(Tc400Class.h) ENABLED START -----*/
//=============================================================================
//
// file :        Tc400Class.h
//
// description : Include for the Tc400 root class.
//               This class is the singleton class for
//                the Tc400 device class.
//               It contains all properties and methods which the 
//               Tc400 requires only once e.g. the commands.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.2 $
// $Date: 2014-03-25 14:04:05 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef Tc400Class_H
#define Tc400Class_H

#include <tango.h>
#include <HipaceClass.h>
#include <Tc110Class.h>
#include <Tc400.h>


/*----- PROTECTED REGION END -----*/	//	Tc400Class.h


namespace Tc400_ns
{
/*----- PROTECTED REGION ID(Tc400Class::classes for dynamic creation) ENABLED START -----*/


/*----- PROTECTED REGION END -----*/	//	Tc400Class::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute CfgRelR1 class definition
class CfgRelR1Attrib: public Tango::Attr
{
public:
	CfgRelR1Attrib():Attr("CfgRelR1",
			Tango::DEV_USHORT, Tango::READ_WRITE) {};
	~CfgRelR1Attrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Tc400 *>(dev))->read_CfgRelR1(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Tc400 *>(dev))->write_CfgRelR1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Tc400 *>(dev))->is_CfgRelR1_allowed(ty);}
};

//	Attribute CfgRelR2 class definition
class CfgRelR2Attrib: public Tango::Attr
{
public:
	CfgRelR2Attrib():Attr("CfgRelR2",
			Tango::DEV_USHORT, Tango::READ_WRITE) {};
	~CfgRelR2Attrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Tc400 *>(dev))->read_CfgRelR2(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Tc400 *>(dev))->write_CfgRelR2(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Tc400 *>(dev))->is_CfgRelR2_allowed(ty);}
};

//	Attribute CfgRelR3 class definition
class CfgRelR3Attrib: public Tango::Attr
{
public:
	CfgRelR3Attrib():Attr("CfgRelR3",
			Tango::DEV_USHORT, Tango::READ_WRITE) {};
	~CfgRelR3Attrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Tc400 *>(dev))->read_CfgRelR3(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Tc400 *>(dev))->write_CfgRelR3(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Tc400 *>(dev))->is_CfgRelR3_allowed(ty);}
};

//	Attribute CfgAI1 class definition
class CfgAI1Attrib: public Tango::Attr
{
public:
	CfgAI1Attrib():Attr("CfgAI1",
			Tango::DEV_USHORT, Tango::READ_WRITE) {};
	~CfgAI1Attrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Tc400 *>(dev))->read_CfgAI1(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Tc400 *>(dev))->write_CfgAI1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Tc400 *>(dev))->is_CfgAI1_allowed(ty);}
};

//	Attribute CfgDI3 class definition
class CfgDI3Attrib: public Tango::Attr
{
public:
	CfgDI3Attrib():Attr("CfgDI3",
			Tango::DEV_USHORT, Tango::READ_WRITE) {};
	~CfgDI3Attrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Tc400 *>(dev))->read_CfgDI3(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Tc400 *>(dev))->write_CfgDI3(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Tc400 *>(dev))->is_CfgDI3_allowed(ty);}
};


/**
 *	The Tc400Class singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  Tc400Class : public Tc110_ns::Tc110Class
#else
class Tc400Class : public Tc110_ns::Tc110Class
#endif
{
	/*----- PROTECTED REGION ID(Tc400Class::Additionnal DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Tc400Class::Additionnal DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
	
		//	Method prototypes
		static Tc400Class *init(const char *);
		static Tc400Class *instance();
		~Tc400Class();
		Tango::DbDatum	get_class_property(string &);
		Tango::DbDatum	get_default_device_property(string &);
		Tango::DbDatum	get_default_class_property(string &);
	
	protected:
		Tc400Class(string &);
		static Tc400Class *_instance;
		void command_factory();
		void attribute_factory(vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		string get_cvstag();
		string get_cvsroot();
	
	private:
		void device_factory(const Tango::DevVarStringArray *);
		void create_static_attribute_list(vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
		vector<string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname);
};

}	//	End of namespace

#endif   //	Tc400_H
