/*----- PROTECTED REGION ID(Tc600.cpp) ENABLED START -----*/
static const char *RcsId = "$Id: Tc600.cpp,v 1.4 2014-05-07 14:47:45 alessio Exp $";
//=============================================================================
//
// file :        Tc600.cpp
//
// description : C++ source for the Tc600 class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               Tc600 are implemented in this file.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.4 $
// $Date: 2014-05-07 14:47:45 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <Tc600.h>
#include <Tc600Class.h>

/*----- PROTECTED REGION END -----*/	//	Tc600.cpp

/**
 *  Tc600 class description:
 *    
 */

//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name  |  Method name
//================================================================
//  State         |  Inherited (no method)
//  Status        |  Inherited (no method)
//================================================================

//================================================================
//  Attributes managed are:
//================================================================
//  RemotePrio    |  Tango::DevBoolean	Scalar
//  SpdSwPtAtt    |  Tango::DevBoolean	Scalar
//  ErrorCode     |  Tango::DevString	Scalar
//  OvTempElec    |  Tango::DevBoolean	Scalar
//  OvTempPump    |  Tango::DevBoolean	Scalar
//  SetSpdAtt     |  Tango::DevBoolean	Scalar
//  PumpAccel     |  Tango::DevBoolean	Scalar
//  DrvCurrent    |  Tango::DevFloat	Scalar
//  OpHrsPump     |  Tango::DevULong	Scalar
//  FwVersion     |  Tango::DevString	Scalar
//  DrvVoltage    |  Tango::DevFloat	Scalar
//  OpHrsElec     |  Tango::DevULong	Scalar
//  DrvPower      |  Tango::DevULong	Scalar
//  PumpCycles    |  Tango::DevULong	Scalar
//  ElecName      |  Tango::DevString	Scalar
//  RUTimeSVal    |  Tango::DevULong	Scalar
//  SpdSwPt1      |  Tango::DevULong	Scalar
//  SpdSVal       |  Tango::DevFloat	Scalar
//  PwrSVal       |  Tango::DevUShort	Scalar
//  SwoffBKP      |  Tango::DevULong	Scalar
//  SwonBKP       |  Tango::DevULong	Scalar
//  StdbyVal      |  Tango::DevFloat	Scalar
//  SpdSwPt2      |  Tango::DevULong	Scalar
//  VentSpd       |  Tango::DevUShort	Scalar
//  VentTime      |  Tango::DevULong	Scalar
//  Heating       |  Tango::DevBoolean	Scalar
//  Standby       |  Tango::DevBoolean	Scalar
//  RUTimeCtrl    |  Tango::DevBoolean	Scalar
//  ErrorAckn     |  Tango::DevBoolean	Scalar
//  PumpgStatn    |  Tango::DevBoolean	Scalar
//  EnableVent    |  Tango::DevBoolean	Scalar
//  MotorPump     |  Tango::DevBoolean	Scalar
//  OpModeBKP     |  Tango::DevUShort	Scalar
//  SpdSetMode    |  Tango::DevUShort	Scalar
//  GasMode       |  Tango::DevUShort	Scalar
//  VentMode      |  Tango::DevUShort	Scalar
//  CfgAO1        |  Tango::DevUShort	Scalar
//  BreakEnab     |  Tango::DevBoolean	Scalar
//  OpModeRem     |  Tango::DevUShort	Scalar
//  OilDefic      |  Tango::DevBoolean	Scalar
//  OpModeDrv     |  Tango::DevBoolean	Scalar
//  CfgDO4        |  Tango::DevUShort	Scalar
//  TMSActTmp     |  Tango::DevULong	Scalar
//  TMSsteady     |  Tango::DevBoolean	Scalar
//  TMSmaxTmp     |  Tango::DevULong	Scalar
//  HeatType      |  Tango::DevUShort	Scalar
//  TMSheatset    |  Tango::DevULong	Scalar
//  SetRotSpdHz   |  Tango::DevULong	Scalar
//  ActualSpdHz   |  Tango::DevULong	Scalar
//  NominalSpdHz  |  Tango::DevULong	Scalar
//  ErrHist       |  Tango::DevString	Spectrum  ( max = 10)
//================================================================

namespace Tc600_ns
{
/*----- PROTECTED REGION ID(Tc600::namespace_starting) ENABLED START -----*/

//	static initializations

/*----- PROTECTED REGION END -----*/	//	Tc600::namespace_starting

//--------------------------------------------------------
/**
 *	Method      : Tc600::Tc600()
 *	Description : Constructors for a Tango device
 *                implementing the classTc600
 */
//--------------------------------------------------------
Tc600::Tc600(Tango::DeviceClass *cl, string &s)
 : Hipace(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(Tc600::constructor_1) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Tc600::constructor_1
}
//--------------------------------------------------------
Tc600::Tc600(Tango::DeviceClass *cl, const char *s)
 : Hipace(cl, s)
{
	/*----- PROTECTED REGION ID(Tc600::constructor_2) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Tc600::constructor_2
}
//--------------------------------------------------------
Tc600::Tc600(Tango::DeviceClass *cl, const char *s, const char *d)
 : Hipace(cl, s, d)
{
	/*----- PROTECTED REGION ID(Tc600::constructor_3) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Tc600::constructor_3
}

//--------------------------------------------------------
/**
 *	Method      : Tc600::delete_device()
 *	Description : will be called at device destruction or at init command
 */
//--------------------------------------------------------
void Tc600::delete_device()
{
	DEBUG_STREAM << "Tc600::delete_device() " << device_name << endl;
	/*----- PROTECTED REGION ID(Tc600::delete_device) ENABLED START -----*/
	
	//	Delete device allocated objects
	
	/*----- PROTECTED REGION END -----*/	//	Tc600::delete_device
	delete[] attr_BreakEnab_read;
	delete[] attr_OpModeRem_read;
	delete[] attr_OilDefic_read;
	delete[] attr_OpModeDrv_read;
	delete[] attr_CfgDO4_read;
	delete[] attr_TMSActTmp_read;
	delete[] attr_TMSsteady_read;
	delete[] attr_TMSmaxTmp_read;
	delete[] attr_HeatType_read;
	delete[] attr_TMSheatset_read;

	if (Tango::Util::instance()->is_svr_shutting_down()==false  &&
		Tango::Util::instance()->is_device_restarting(device_name)==false &&
		Tango::Util::instance()->is_svr_starting()==false)
	{
		//	If not shutting down call delete device for inherited object
		Hipace_ns::Hipace::delete_device();
	}
}

//--------------------------------------------------------
/**
 *	Method      : Tc600::init_device()
 *	Description : will be called at device initialization.
 */
//--------------------------------------------------------
void Tc600::init_device()
{
	DEBUG_STREAM << "Tc600::init_device() create device " << device_name << endl;
	/*----- PROTECTED REGION ID(Tc600::init_device_before) ENABLED START -----*/
	
	//	Initialization before get_device_property() call
	mandatoryNotDefined = false;
	
	/*----- PROTECTED REGION END -----*/	//	Tc600::init_device_before
	
	if (Tango::Util::instance()->is_svr_starting() == false  &&
		Tango::Util::instance()->is_device_restarting(device_name)==false)
	{
		//	If not starting up call init device for inherited object
		Hipace_ns::Hipace::init_device();
	}
	//	No device property to be read from database
	
	attr_BreakEnab_read = new Tango::DevBoolean[1];
	attr_OpModeRem_read = new Tango::DevUShort[1];
	attr_OilDefic_read = new Tango::DevBoolean[1];
	attr_OpModeDrv_read = new Tango::DevBoolean[1];
	attr_CfgDO4_read = new Tango::DevUShort[1];
	attr_TMSActTmp_read = new Tango::DevULong[1];
	attr_TMSsteady_read = new Tango::DevBoolean[1];
	attr_TMSmaxTmp_read = new Tango::DevULong[1];
	attr_HeatType_read = new Tango::DevUShort[1];
	attr_TMSheatset_read = new Tango::DevULong[1];
	//	No longer if mandatory property not set. 
	if (mandatoryNotDefined)
		return;

	/*----- PROTECTED REGION ID(Tc600::init_device) ENABLED START -----*/
	
	//	Initialize device
	
	/*----- PROTECTED REGION END -----*/	//	Tc600::init_device
}


//--------------------------------------------------------
/**
 *	Method      : Tc600::always_executed_hook()
 *	Description : method always executed before any command is executed
 */
//--------------------------------------------------------
void Tc600::always_executed_hook()
{
	DEBUG_STREAM << "Tc600::always_executed_hook()  " << device_name << endl;
	if (mandatoryNotDefined)
	{
		string	status(get_status());
		Tango::Except::throw_exception(
					(const char *)"PROPERTY_NOT_SET",
					status.c_str(),
					(const char *)"Tc600::always_executed_hook()");
	}
	/*----- PROTECTED REGION ID(Tc600::always_executed_hook) ENABLED START -----*/
	
	//	code always executed before all requests
	Hipace_ns::Hipace::always_executed_hook();
	
	/*----- PROTECTED REGION END -----*/	//	Tc600::always_executed_hook
}

//--------------------------------------------------------
/**
 *	Method      : Tc600::read_attr_hardware()
 *	Description : Hardware acquisition for attributes
 */
//--------------------------------------------------------
void Tc600::read_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "Tc600::read_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc600::read_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	check_init();
	
	/*----- PROTECTED REGION END -----*/	//	Tc600::read_attr_hardware
}
//--------------------------------------------------------
/**
 *	Method      : Tc600::write_attr_hardware()
 *	Description : Hardware writing for attributes
 */
//--------------------------------------------------------
void Tc600::write_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "Tc600::write_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc600::write_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Tc600::write_attr_hardware
}

//--------------------------------------------------------
/**
 *	Read attribute BreakEnab related method
 *	Description: Pre selection brake ON/OFF
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc600::read_BreakEnab(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tc600::read_BreakEnab(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc600::read_BreakEnab) ENABLED START -----*/
	//	Set the attribute value

 	query("013", attr_BreakEnab_read[0]);
	attr.set_value(attr_BreakEnab_read);

	/*----- PROTECTED REGION END -----*/	//	Tc600::read_BreakEnab
}
//--------------------------------------------------------
/**
 *	Write attribute BreakEnab related method
 *	Description: Pre selection brake ON/OFF
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc600::write_BreakEnab(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Tc600::write_BreakEnab(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevBoolean	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Tc600::write_BreakEnab) ENABLED START -----*/
	check_init();
 	command("013", w_val);

	/*----- PROTECTED REGION END -----*/	//	Tc600::write_BreakEnab
}
//--------------------------------------------------------
/**
 *	Read attribute OpModeRem related method
 *	Description: Remote operations mode 0=standard, 1=Remote priority, 2 Remote error acknowl.
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc600::read_OpModeRem(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tc600::read_OpModeRem(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc600::read_OpModeRem) ENABLED START -----*/
	//	Set the attribute value

 	query("028", attr_OpModeRem_read[0]);
	attr.set_value(attr_OpModeRem_read);

	/*----- PROTECTED REGION END -----*/	//	Tc600::read_OpModeRem
}
//--------------------------------------------------------
/**
 *	Write attribute OpModeRem related method
 *	Description: Remote operations mode 0=standard, 1=Remote priority, 2 Remote error acknowl.
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc600::write_OpModeRem(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Tc600::write_OpModeRem(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevUShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Tc600::write_OpModeRem) ENABLED START -----*/
	check_init();
 	command("028", w_val);

	/*----- PROTECTED REGION END -----*/	//	Tc600::write_OpModeRem
}
//--------------------------------------------------------
/**
 *	Read attribute OilDefic related method
 *	Description: Oil deficiency turbopump
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc600::read_OilDefic(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tc600::read_OilDefic(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc600::read_OilDefic) ENABLED START -----*/
	//	Set the attribute value

 	query("301", attr_OilDefic_read[0]);
	attr.set_value(attr_OilDefic_read);

	/*----- PROTECTED REGION END -----*/	//	Tc600::read_OilDefic
}
//--------------------------------------------------------
/**
 *	Read attribute OpModeDrv related method
 *	Description: Drive unit operations mode OFF=max., ON=reduced power intake
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc600::read_OpModeDrv(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tc600::read_OpModeDrv(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc600::read_OpModeDrv) ENABLED START -----*/
	//	Set the attribute value

 	query("029", attr_OpModeDrv_read[0]);
	attr.set_value(attr_OpModeDrv_read);

	/*----- PROTECTED REGION END -----*/	//	Tc600::read_OpModeDrv
}
//--------------------------------------------------------
/**
 *	Write attribute OpModeDrv related method
 *	Description: Drive unit operations mode OFF=max., ON=reduced power intake
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc600::write_OpModeDrv(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Tc600::write_OpModeDrv(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevBoolean	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Tc600::write_OpModeDrv) ENABLED START -----*/
	check_init();
	command("029", w_val);

	/*----- PROTECTED REGION END -----*/	//	Tc600::write_OpModeDrv
}
//--------------------------------------------------------
/**
 *	Read attribute CfgDO4 related method
 *	Description: Configuration heating output; 0=Heat/TMS operations; 1=sealing gas valve control
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc600::read_CfgDO4(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tc600::read_CfgDO4(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc600::read_CfgDO4) ENABLED START -----*/
	//	Set the attribute value

 	query("032", attr_CfgDO4_read[0]);
	attr.set_value(attr_CfgDO4_read);

	/*----- PROTECTED REGION END -----*/	//	Tc600::read_CfgDO4
}
//--------------------------------------------------------
/**
 *	Write attribute CfgDO4 related method
 *	Description: Configuration heating output; 0=Heat/TMS operations; 1=sealing gas valve control
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc600::write_CfgDO4(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Tc600::write_CfgDO4(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevUShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Tc600::write_CfgDO4) ENABLED START -----*/
	check_init();
	command("032", w_val);

	/*----- PROTECTED REGION END -----*/	//	Tc600::write_CfgDO4
}
//--------------------------------------------------------
/**
 *	Read attribute TMSActTmp related method
 *	Description: Heating TMS
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc600::read_TMSActTmp(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tc600::read_TMSActTmp(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc600::read_TMSActTmp) ENABLED START -----*/
	//	Set the attribute value

 	query("331", attr_TMSActTmp_read[0]);
	attr.set_value(attr_TMSActTmp_read);

	/*----- PROTECTED REGION END -----*/	//	Tc600::read_TMSActTmp
}
//--------------------------------------------------------
/**
 *	Read attribute TMSsteady related method
 *	Description: TMS regulator engaged ON/OFF
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc600::read_TMSsteady(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tc600::read_TMSsteady(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc600::read_TMSsteady) ENABLED START -----*/
	//	Set the attribute value

 	query("333", attr_TMSsteady_read[0]);
	attr.set_value(attr_TMSsteady_read);

	/*----- PROTECTED REGION END -----*/	//	Tc600::read_TMSsteady
}
//--------------------------------------------------------
/**
 *	Read attribute TMSmaxTmp related method
 *	Description: Maximum TMS temperature occured
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc600::read_TMSmaxTmp(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tc600::read_TMSmaxTmp(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc600::read_TMSmaxTmp) ENABLED START -----*/
	//	Set the attribute value

 	query("334", attr_TMSmaxTmp_read[0]);
	attr.set_value(attr_TMSmaxTmp_read);

	/*----- PROTECTED REGION END -----*/	//	Tc600::read_TMSmaxTmp
}
//--------------------------------------------------------
/**
 *	Read attribute HeatType related method
 *	Description: Heating type 0=conventional heating, 1=TMS
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc600::read_HeatType(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tc600::read_HeatType(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc600::read_HeatType) ENABLED START -----*/
	//	Set the attribute value

 	query("335", attr_HeatType_read[0]);
	attr.set_value(attr_HeatType_read);

	/*----- PROTECTED REGION END -----*/	//	Tc600::read_HeatType
}
//--------------------------------------------------------
/**
 *	Read attribute TMSheatset related method
 *	Description: TMS heating temperature set value
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc600::read_TMSheatset(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tc600::read_TMSheatset(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Tc600::read_TMSheatset) ENABLED START -----*/
	//	Set the attribute value

 	query("704", attr_TMSheatset_read[0]);
	attr.set_value(attr_TMSheatset_read);

	/*----- PROTECTED REGION END -----*/	//	Tc600::read_TMSheatset
}
//--------------------------------------------------------
/**
 *	Write attribute TMSheatset related method
 *	Description: TMS heating temperature set value
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tc600::write_TMSheatset(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Tc600::write_TMSheatset(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevULong	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Tc600::write_TMSheatset) ENABLED START -----*/
	check_init();
	command("704", w_val);

	/*----- PROTECTED REGION END -----*/	//	Tc600::write_TMSheatset
}

//--------------------------------------------------------
/**
 *	Method      : Tc600::add_dynamic_attributes()
 *	Description : Create the dynamic attributes if any
 *                for specified device.
 */
//--------------------------------------------------------
void Tc600::add_dynamic_attributes()
{
	/*----- PROTECTED REGION ID(Tc600::add_dynamic_attributes) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic attributes if any
	
	/*----- PROTECTED REGION END -----*/	//	Tc600::add_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : Tc600::add_dynamic_commands()
 *	Description : Create the dynamic commands if any
 *                for specified device.
 */
//--------------------------------------------------------
void Tc600::add_dynamic_commands()
{
	/*----- PROTECTED REGION ID(Tc600::add_dynamic_commands) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic commands if any
	
	/*----- PROTECTED REGION END -----*/	//	Tc600::add_dynamic_commands
}

/*----- PROTECTED REGION ID(Tc600::namespace_ending) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	Tc600::namespace_ending
} //	namespace
