/*----- PROTECTED REGION ID(Tc600.h) ENABLED START -----*/
//=============================================================================
//
// file :        Tc600.h
//
// description : Include file for the Tc600 class
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.2 $
// $Date: 2014-05-05 09:10:06 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef Tc600_H
#define Tc600_H

#include <tango.h>
#include <Hipace.h>


/*----- PROTECTED REGION END -----*/	//	Tc600.h

/**
 *  Tc600 class description:
 *    
 */

namespace Tc600_ns
{
/*----- PROTECTED REGION ID(Tc600::Additional Class Declarations) ENABLED START -----*/

//	Additional Class Declarations

/*----- PROTECTED REGION END -----*/	//	Tc600::Additional Class Declarations

class Tc600 : public Hipace_ns::Hipace
{

/*----- PROTECTED REGION ID(Tc600::Data Members) ENABLED START -----*/

//	Add your own data members

/*----- PROTECTED REGION END -----*/	//	Tc600::Data Members

//	Device property data members
public:

	bool	mandatoryNotDefined;

//	Attribute data members
public:
	Tango::DevBoolean	*attr_BreakEnab_read;
	Tango::DevUShort	*attr_OpModeRem_read;
	Tango::DevBoolean	*attr_OilDefic_read;
	Tango::DevBoolean	*attr_OpModeDrv_read;
	Tango::DevUShort	*attr_CfgDO4_read;
	Tango::DevULong	*attr_TMSActTmp_read;
	Tango::DevBoolean	*attr_TMSsteady_read;
	Tango::DevULong	*attr_TMSmaxTmp_read;
	Tango::DevUShort	*attr_HeatType_read;
	Tango::DevULong	*attr_TMSheatset_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Tc600(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Tc600(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	Tc600(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */
	~Tc600() {delete_device();};


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();

	/*
	 *	Check if mandatory property has been set
	 */
	 void check_mandatory_property(Tango::DbDatum &class_prop, Tango::DbDatum &dev_prop);

//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method      : Tc600::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(vector<long> &attr_list);
	//--------------------------------------------------------
	/*
	 *	Method      : Tc600::write_attr_hardware()
	 *	Description : Hardware writing for attributes.
	 */
	//--------------------------------------------------------
	virtual void write_attr_hardware(vector<long> &attr_list);

/**
 *	Attribute BreakEnab related methods
 *	Description: Pre selection brake ON/OFF
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_BreakEnab(Tango::Attribute &attr);
	virtual void write_BreakEnab(Tango::WAttribute &attr);
	virtual bool is_BreakEnab_allowed(Tango::AttReqType type);
/**
 *	Attribute OpModeRem related methods
 *	Description: Remote operations mode 0=standard, 1=Remote priority, 2 Remote error acknowl.
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
	virtual void read_OpModeRem(Tango::Attribute &attr);
	virtual void write_OpModeRem(Tango::WAttribute &attr);
	virtual bool is_OpModeRem_allowed(Tango::AttReqType type);
/**
 *	Attribute OilDefic related methods
 *	Description: Oil deficiency turbopump
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_OilDefic(Tango::Attribute &attr);
	virtual bool is_OilDefic_allowed(Tango::AttReqType type);
/**
 *	Attribute OpModeDrv related methods
 *	Description: Drive unit operations mode OFF=max., ON=reduced power intake
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_OpModeDrv(Tango::Attribute &attr);
	virtual void write_OpModeDrv(Tango::WAttribute &attr);
	virtual bool is_OpModeDrv_allowed(Tango::AttReqType type);
/**
 *	Attribute CfgDO4 related methods
 *	Description: Configuration heating output; 0=Heat/TMS operations; 1=sealing gas valve control
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
	virtual void read_CfgDO4(Tango::Attribute &attr);
	virtual void write_CfgDO4(Tango::WAttribute &attr);
	virtual bool is_CfgDO4_allowed(Tango::AttReqType type);
/**
 *	Attribute TMSActTmp related methods
 *	Description: Heating TMS
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
	virtual void read_TMSActTmp(Tango::Attribute &attr);
	virtual bool is_TMSActTmp_allowed(Tango::AttReqType type);
/**
 *	Attribute TMSsteady related methods
 *	Description: TMS regulator engaged ON/OFF
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_TMSsteady(Tango::Attribute &attr);
	virtual bool is_TMSsteady_allowed(Tango::AttReqType type);
/**
 *	Attribute TMSmaxTmp related methods
 *	Description: Maximum TMS temperature occured
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
	virtual void read_TMSmaxTmp(Tango::Attribute &attr);
	virtual bool is_TMSmaxTmp_allowed(Tango::AttReqType type);
/**
 *	Attribute HeatType related methods
 *	Description: Heating type 0=conventional heating, 1=TMS
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
	virtual void read_HeatType(Tango::Attribute &attr);
	virtual bool is_HeatType_allowed(Tango::AttReqType type);
/**
 *	Attribute TMSheatset related methods
 *	Description: TMS heating temperature set value
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
	virtual void read_TMSheatset(Tango::Attribute &attr);
	virtual void write_TMSheatset(Tango::WAttribute &attr);
	virtual bool is_TMSheatset_allowed(Tango::AttReqType type);


	//--------------------------------------------------------
	/**
	 *	Method      : Tc600::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();




//	Command related methods
public:


	//--------------------------------------------------------
	/**
	 *	Method      : Tc600::add_dynamic_commands()
	 *	Description : Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(Tc600::Additional Method prototypes) ENABLED START -----*/

//	Additional Method prototypes

/*----- PROTECTED REGION END -----*/	//	Tc600::Additional Method prototypes
};

/*----- PROTECTED REGION ID(Tc600::Additional Classes Definitions) ENABLED START -----*/

//	Additional Classes Definitions

/*----- PROTECTED REGION END -----*/	//	Tc600::Additional Classes Definitions

}	//	End of namespace

#endif   //	Tc600_H
