/*----- PROTECTED REGION ID(Tc600Class.cpp) ENABLED START -----*/
static const char *RcsId      = "$Id: Tc600Class.cpp,v 1.4 2015-08-03 09:26:54 alessio Exp $";
static const char *TagName    = "Tc600 $Name:  $";
static const char *CvsPath    = "$Source: /home/cvsadm/cvsroot/fermi/servers/hipace/src/Tc600Class.cpp,v $";
static const char *SvnPath    = "$HeadURL:  $";
static const char *HttpServer = "http://www.esrf.eu/computing/cs/tango/tango_doc/ds_doc/";
//=============================================================================
//
// file :        Tc600Class.cpp
//
// description : C++ source for the Tc600Class.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the Tc600 once per process.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.4 $
// $Date: 2015-08-03 09:26:54 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <Tc600Class.h>

/*----- PROTECTED REGION END -----*/	//	Tc600Class.cpp

//-------------------------------------------------------------------
/**
 *	Create Tc600Class singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_Tc600_class(const char *name) {
		return Tc600_ns::Tc600Class::init(name);
	}
}

namespace Tc600_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
Tc600Class *Tc600Class::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		Tc600Class::Tc600Class(string &s)
 * description : 	constructor for the Tc600Class
 *
 * @param s	The class name
 */
//--------------------------------------------------------
Tc600Class::Tc600Class(string &s):Hipace_ns::HipaceClass(s)
{
	cout2 << "Entering Tc600Class constructor" << endl;
	set_default_property();
	write_class_property();

	/*----- PROTECTED REGION ID(Tc600Class::constructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc600Class::constructor

	cout2 << "Leaving Tc600Class constructor" << endl;
}

//--------------------------------------------------------
/**
 * method : 		Tc600Class::~Tc600Class()
 * description : 	destructor for the Tc600Class
 */
//--------------------------------------------------------
Tc600Class::~Tc600Class()
{
	/*----- PROTECTED REGION ID(Tc600Class::destructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc600Class::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		Tc600Class::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
Tc600Class *Tc600Class::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new Tc600Class(s);
		}
		catch (bad_alloc &)
		{
			throw;
		}
	}
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		Tc600Class::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
Tc600Class *Tc600Class::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================

//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method      : Tc600Class::get_class_property()
 *	Description : Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum Tc600Class::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : Tc600Class::get_default_device_property()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum Tc600Class::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : Tc600Class::get_default_class_property()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum Tc600Class::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : Tc600Class::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void Tc600Class::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;
	vector<string>	vect_data;

	//	Set Default Class Properties

	//	Set Default device Properties
}

//--------------------------------------------------------
/**
 *	Method      : Tc600Class::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void Tc600Class::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("");
	description << str_desc;
	data.push_back(description);

	//	put cvs or svn location
	string	filename("Tc600");
	filename += "Class.cpp";

	// check for cvs information
	string	src_path(CvsPath);
	start = src_path.find("/");
	if (start!=string::npos)
	{
		end   = src_path.find(filename);
		if (end>start)
		{
			string	strloc = src_path.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}

	// check for svn information
	else
	{
		string	src_path(SvnPath);
		start = src_path.find("://");
		if (start!=string::npos)
		{
			end = src_path.find(filename);
			if (end>start)
			{
				header = "$HeadURL: ";
				start = header.length();
				string	strloc = src_path.substr(start, (end-start));
				
				Tango::DbDatum	svn_loc("svn_location");
				svn_loc << strloc;
				data.push_back(svn_loc);
			}
		}
	}

	//	Get CVS or SVN revision tag
	
	// CVS tag
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}
	
	// SVN tag
	string	svnpath(SvnPath);
	header = "$HeadURL: ";
	start = header.length();
	
	end   = svnpath.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strloc = svnpath.substr(start, end-start);
		
		string tagstr ("/tags/");
		start = strloc.find(tagstr);
		if ( start!=string::npos )
		{
			start = start + tagstr.length();
			end   = strloc.find(filename);
			string	strtag = strloc.substr(start, end-start-1);
			
			Tango::DbDatum	svn_tag("svn_tag");
			svn_tag << strtag;
			data.push_back(svn_tag);
		}
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method      : Tc600Class::device_factory()
 *	Description : Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void Tc600Class::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(Tc600Class::device_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Tc600Class::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new Tc600(this, (*devlist_ptr)[i]));
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		Tc600 *dev = static_cast<Tc600 *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(Tc600Class::device_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Tc600Class::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : Tc600Class::attribute_factory()
 *	Description : Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void Tc600Class::attribute_factory(vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(Tc600Class::attribute_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Tc600Class::attribute_factory_before
	//	Call atribute_factory for inherited class
	Hipace_ns::HipaceClass::attribute_factory(att_list);

	//	Attribute : RemotePrio - Check if not concrete in inherited class
	Tango::Attr *RemotePrioAttr = get_attr_object_by_name(att_list, "RemotePrio");
	if (RemotePrioAttr == NULL)
	{
	}

	//	Attribute : SpdSwPtAtt - Check if not concrete in inherited class
	Tango::Attr *SpdSwPtAttAttr = get_attr_object_by_name(att_list, "SpdSwPtAtt");
	if (SpdSwPtAttAttr == NULL)
	{
	}

	//	Attribute : ErrorCode - Check if not concrete in inherited class
	Tango::Attr *ErrorCodeAttr = get_attr_object_by_name(att_list, "ErrorCode");
	if (ErrorCodeAttr == NULL)
	{
	}

	//	Attribute : OvTempElec - Check if not concrete in inherited class
	Tango::Attr *OvTempElecAttr = get_attr_object_by_name(att_list, "OvTempElec");
	if (OvTempElecAttr == NULL)
	{
	}

	//	Attribute : OvTempPump - Check if not concrete in inherited class
	Tango::Attr *OvTempPumpAttr = get_attr_object_by_name(att_list, "OvTempPump");
	if (OvTempPumpAttr == NULL)
	{
	}

	//	Attribute : SetSpdAtt - Check if not concrete in inherited class
	Tango::Attr *SetSpdAttAttr = get_attr_object_by_name(att_list, "SetSpdAtt");
	if (SetSpdAttAttr == NULL)
	{
	}

	//	Attribute : PumpAccel - Check if not concrete in inherited class
	Tango::Attr *PumpAccelAttr = get_attr_object_by_name(att_list, "PumpAccel");
	if (PumpAccelAttr == NULL)
	{
	}

	//	Attribute : DrvCurrent - Check if not concrete in inherited class
	Tango::Attr *DrvCurrentAttr = get_attr_object_by_name(att_list, "DrvCurrent");
	if (DrvCurrentAttr == NULL)
	{
	}

	//	Attribute : OpHrsPump - Check if not concrete in inherited class
	Tango::Attr *OpHrsPumpAttr = get_attr_object_by_name(att_list, "OpHrsPump");
	if (OpHrsPumpAttr == NULL)
	{
	}

	//	Attribute : FwVersion - Check if not concrete in inherited class
	Tango::Attr *FwVersionAttr = get_attr_object_by_name(att_list, "FwVersion");
	if (FwVersionAttr == NULL)
	{
	}

	//	Attribute : DrvVoltage - Check if not concrete in inherited class
	Tango::Attr *DrvVoltageAttr = get_attr_object_by_name(att_list, "DrvVoltage");
	if (DrvVoltageAttr == NULL)
	{
	}

	//	Attribute : OpHrsElec - Check if not concrete in inherited class
	Tango::Attr *OpHrsElecAttr = get_attr_object_by_name(att_list, "OpHrsElec");
	if (OpHrsElecAttr == NULL)
	{
	}

	//	Attribute : DrvPower - Check if not concrete in inherited class
	Tango::Attr *DrvPowerAttr = get_attr_object_by_name(att_list, "DrvPower");
	if (DrvPowerAttr == NULL)
	{
	}

	//	Attribute : PumpCycles - Check if not concrete in inherited class
	Tango::Attr *PumpCyclesAttr = get_attr_object_by_name(att_list, "PumpCycles");
	if (PumpCyclesAttr == NULL)
	{
	}

	//	Attribute : ElecName - Check if not concrete in inherited class
	Tango::Attr *ElecNameAttr = get_attr_object_by_name(att_list, "ElecName");
	if (ElecNameAttr == NULL)
	{
	}

	//	Attribute : RUTimeSVal - Check if not concrete in inherited class
	Tango::Attr *RUTimeSValAttr = get_attr_object_by_name(att_list, "RUTimeSVal");
	if (RUTimeSValAttr == NULL)
	{
	}

	//	Attribute : SpdSwPt1 - Check if not concrete in inherited class
	Tango::Attr *SpdSwPt1Attr = get_attr_object_by_name(att_list, "SpdSwPt1");
	if (SpdSwPt1Attr == NULL)
	{
	}

	//	Attribute : SpdSVal - Check if not concrete in inherited class
	Tango::Attr *SpdSValAttr = get_attr_object_by_name(att_list, "SpdSVal");
	if (SpdSValAttr == NULL)
	{
	}

	//	Attribute : PwrSVal - Check if not concrete in inherited class
	Tango::Attr *PwrSValAttr = get_attr_object_by_name(att_list, "PwrSVal");
	if (PwrSValAttr == NULL)
	{
	}

	//	Attribute : SwoffBKP - Check if not concrete in inherited class
	Tango::Attr *SwoffBKPAttr = get_attr_object_by_name(att_list, "SwoffBKP");
	if (SwoffBKPAttr == NULL)
	{
	}

	//	Attribute : SwonBKP - Check if not concrete in inherited class
	Tango::Attr *SwonBKPAttr = get_attr_object_by_name(att_list, "SwonBKP");
	if (SwonBKPAttr == NULL)
	{
	}

	//	Attribute : StdbyVal - Check if not concrete in inherited class
	Tango::Attr *StdbyValAttr = get_attr_object_by_name(att_list, "StdbyVal");
	if (StdbyValAttr == NULL)
	{
	}

	//	Attribute : SpdSwPt2 - Check if not concrete in inherited class
	Tango::Attr *SpdSwPt2Attr = get_attr_object_by_name(att_list, "SpdSwPt2");
	if (SpdSwPt2Attr == NULL)
	{
	}

	//	Attribute : VentSpd - Check if not concrete in inherited class
	Tango::Attr *VentSpdAttr = get_attr_object_by_name(att_list, "VentSpd");
	if (VentSpdAttr == NULL)
	{
	}

	//	Attribute : VentTime - Check if not concrete in inherited class
	Tango::Attr *VentTimeAttr = get_attr_object_by_name(att_list, "VentTime");
	if (VentTimeAttr == NULL)
	{
	}

	//	Attribute : Heating - Check if not concrete in inherited class
	Tango::Attr *HeatingAttr = get_attr_object_by_name(att_list, "Heating");
	if (HeatingAttr == NULL)
	{
	}

	//	Attribute : Standby - Check if not concrete in inherited class
	Tango::Attr *StandbyAttr = get_attr_object_by_name(att_list, "Standby");
	if (StandbyAttr == NULL)
	{
	}

	//	Attribute : RUTimeCtrl - Check if not concrete in inherited class
	Tango::Attr *RUTimeCtrlAttr = get_attr_object_by_name(att_list, "RUTimeCtrl");
	if (RUTimeCtrlAttr == NULL)
	{
	}

	//	Attribute : ErrorAckn - Check if not concrete in inherited class
	Tango::Attr *ErrorAcknAttr = get_attr_object_by_name(att_list, "ErrorAckn");
	if (ErrorAcknAttr == NULL)
	{
	}

	//	Attribute : PumpgStatn - Check if not concrete in inherited class
	Tango::Attr *PumpgStatnAttr = get_attr_object_by_name(att_list, "PumpgStatn");
	if (PumpgStatnAttr == NULL)
	{
	}

	//	Attribute : EnableVent - Check if not concrete in inherited class
	Tango::Attr *EnableVentAttr = get_attr_object_by_name(att_list, "EnableVent");
	if (EnableVentAttr == NULL)
	{
	}

	//	Attribute : MotorPump - Check if not concrete in inherited class
	Tango::Attr *MotorPumpAttr = get_attr_object_by_name(att_list, "MotorPump");
	if (MotorPumpAttr == NULL)
	{
	}

	//	Attribute : OpModeBKP - Check if not concrete in inherited class
	Tango::Attr *OpModeBKPAttr = get_attr_object_by_name(att_list, "OpModeBKP");
	if (OpModeBKPAttr == NULL)
	{
	}

	//	Attribute : SpdSetMode - Check if not concrete in inherited class
	Tango::Attr *SpdSetModeAttr = get_attr_object_by_name(att_list, "SpdSetMode");
	if (SpdSetModeAttr == NULL)
	{
	}

	//	Attribute : GasMode - Check if not concrete in inherited class
	Tango::Attr *GasModeAttr = get_attr_object_by_name(att_list, "GasMode");
	if (GasModeAttr == NULL)
	{
	}

	//	Attribute : VentMode - Check if not concrete in inherited class
	Tango::Attr *VentModeAttr = get_attr_object_by_name(att_list, "VentMode");
	if (VentModeAttr == NULL)
	{
	}

	//	Attribute : CfgAO1 - Check if not concrete in inherited class
	Tango::Attr *CfgAO1Attr = get_attr_object_by_name(att_list, "CfgAO1");
	if (CfgAO1Attr == NULL)
	{
	}

	//	Attribute : BreakEnab
	BreakEnabAttrib	*breakenab = new BreakEnabAttrib();
	Tango::UserDefaultAttrProp	breakenab_prop;
	breakenab_prop.set_description("Pre selection brake ON/OFF");
	breakenab_prop.set_label("BreakEnab (013)");
	//	unit	not set for BreakEnab
	//	standard_unit	not set for BreakEnab
	//	display_unit	not set for BreakEnab
	//	format	not set for BreakEnab
	//	max_value	not set for BreakEnab
	//	min_value	not set for BreakEnab
	//	max_alarm	not set for BreakEnab
	//	min_alarm	not set for BreakEnab
	//	max_warning	not set for BreakEnab
	//	min_warning	not set for BreakEnab
	//	delta_t	not set for BreakEnab
	//	delta_val	not set for BreakEnab
	
	breakenab->set_default_properties(breakenab_prop);
	//	Not Polled
	breakenab->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(breakenab);

	//	Attribute : OpModeRem
	OpModeRemAttrib	*opmoderem = new OpModeRemAttrib();
	Tango::UserDefaultAttrProp	opmoderem_prop;
	opmoderem_prop.set_description("Remote operations mode 0=standard, 1=Remote priority, 2 Remote error acknowl.");
	opmoderem_prop.set_label("OpModeRem (028)");
	//	unit	not set for OpModeRem
	//	standard_unit	not set for OpModeRem
	//	display_unit	not set for OpModeRem
	//	format	not set for OpModeRem
	opmoderem_prop.set_max_value("2");
	opmoderem_prop.set_min_value("0");
	//	max_alarm	not set for OpModeRem
	//	min_alarm	not set for OpModeRem
	//	max_warning	not set for OpModeRem
	//	min_warning	not set for OpModeRem
	//	delta_t	not set for OpModeRem
	//	delta_val	not set for OpModeRem
	
	opmoderem->set_default_properties(opmoderem_prop);
	//	Not Polled
	opmoderem->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(opmoderem);

	//	Attribute : OilDefic
	OilDeficAttrib	*oildefic = new OilDeficAttrib();
	Tango::UserDefaultAttrProp	oildefic_prop;
	oildefic_prop.set_description("Oil deficiency turbopump");
	oildefic_prop.set_label("OilDefic (301)");
	//	unit	not set for OilDefic
	//	standard_unit	not set for OilDefic
	//	display_unit	not set for OilDefic
	//	format	not set for OilDefic
	//	max_value	not set for OilDefic
	//	min_value	not set for OilDefic
	//	max_alarm	not set for OilDefic
	//	min_alarm	not set for OilDefic
	//	max_warning	not set for OilDefic
	//	min_warning	not set for OilDefic
	//	delta_t	not set for OilDefic
	//	delta_val	not set for OilDefic
	
	oildefic->set_default_properties(oildefic_prop);
	//	Not Polled
	oildefic->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(oildefic);

	//	Attribute : OpModeDrv
	OpModeDrvAttrib	*opmodedrv = new OpModeDrvAttrib();
	Tango::UserDefaultAttrProp	opmodedrv_prop;
	opmodedrv_prop.set_description("Drive unit operations mode OFF=max., ON=reduced power intake");
	opmodedrv_prop.set_label("OpModeDrv (029)");
	//	unit	not set for OpModeDrv
	//	standard_unit	not set for OpModeDrv
	//	display_unit	not set for OpModeDrv
	//	format	not set for OpModeDrv
	//	max_value	not set for OpModeDrv
	//	min_value	not set for OpModeDrv
	//	max_alarm	not set for OpModeDrv
	//	min_alarm	not set for OpModeDrv
	//	max_warning	not set for OpModeDrv
	//	min_warning	not set for OpModeDrv
	//	delta_t	not set for OpModeDrv
	//	delta_val	not set for OpModeDrv
	
	opmodedrv->set_default_properties(opmodedrv_prop);
	//	Not Polled
	opmodedrv->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(opmodedrv);

	//	Attribute : CfgDO4
	CfgDO4Attrib	*cfgdo4 = new CfgDO4Attrib();
	Tango::UserDefaultAttrProp	cfgdo4_prop;
	cfgdo4_prop.set_description("Configuration heating output; 0=Heat/TMS operations; 1=sealing gas valve control");
	cfgdo4_prop.set_label("CfgDO4 (032)");
	//	unit	not set for CfgDO4
	//	standard_unit	not set for CfgDO4
	//	display_unit	not set for CfgDO4
	//	format	not set for CfgDO4
	cfgdo4_prop.set_max_value("1");
	cfgdo4_prop.set_min_value("0");
	//	max_alarm	not set for CfgDO4
	//	min_alarm	not set for CfgDO4
	//	max_warning	not set for CfgDO4
	//	min_warning	not set for CfgDO4
	//	delta_t	not set for CfgDO4
	//	delta_val	not set for CfgDO4
	
	cfgdo4->set_default_properties(cfgdo4_prop);
	//	Not Polled
	cfgdo4->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(cfgdo4);

	//	Attribute : TMSActTmp
	TMSActTmpAttrib	*tmsacttmp = new TMSActTmpAttrib();
	Tango::UserDefaultAttrProp	tmsacttmp_prop;
	tmsacttmp_prop.set_description("Heating TMS");
	tmsacttmp_prop.set_label("TMSActTmp (331)");
	tmsacttmp_prop.set_unit("C");
	//	standard_unit	not set for TMSActTmp
	//	display_unit	not set for TMSActTmp
	//	format	not set for TMSActTmp
	tmsacttmp_prop.set_max_value("200");
	tmsacttmp_prop.set_min_value("5");
	//	max_alarm	not set for TMSActTmp
	//	min_alarm	not set for TMSActTmp
	//	max_warning	not set for TMSActTmp
	//	min_warning	not set for TMSActTmp
	//	delta_t	not set for TMSActTmp
	//	delta_val	not set for TMSActTmp
	
	tmsacttmp->set_default_properties(tmsacttmp_prop);
	//	Not Polled
	tmsacttmp->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(tmsacttmp);

	//	Attribute : TMSsteady
	TMSsteadyAttrib	*tmssteady = new TMSsteadyAttrib();
	Tango::UserDefaultAttrProp	tmssteady_prop;
	tmssteady_prop.set_description("TMS regulator engaged ON/OFF");
	tmssteady_prop.set_label("TMSsteady (333)");
	//	unit	not set for TMSsteady
	//	standard_unit	not set for TMSsteady
	//	display_unit	not set for TMSsteady
	//	format	not set for TMSsteady
	//	max_value	not set for TMSsteady
	//	min_value	not set for TMSsteady
	//	max_alarm	not set for TMSsteady
	//	min_alarm	not set for TMSsteady
	//	max_warning	not set for TMSsteady
	//	min_warning	not set for TMSsteady
	//	delta_t	not set for TMSsteady
	//	delta_val	not set for TMSsteady
	
	tmssteady->set_default_properties(tmssteady_prop);
	//	Not Polled
	tmssteady->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(tmssteady);

	//	Attribute : TMSmaxTmp
	TMSmaxTmpAttrib	*tmsmaxtmp = new TMSmaxTmpAttrib();
	Tango::UserDefaultAttrProp	tmsmaxtmp_prop;
	tmsmaxtmp_prop.set_description("Maximum TMS temperature occured");
	tmsmaxtmp_prop.set_label("TMSmaxTmp (334)");
	tmsmaxtmp_prop.set_unit("C");
	//	standard_unit	not set for TMSmaxTmp
	//	display_unit	not set for TMSmaxTmp
	//	format	not set for TMSmaxTmp
	tmsmaxtmp_prop.set_max_value("200");
	tmsmaxtmp_prop.set_min_value("5");
	//	max_alarm	not set for TMSmaxTmp
	//	min_alarm	not set for TMSmaxTmp
	//	max_warning	not set for TMSmaxTmp
	//	min_warning	not set for TMSmaxTmp
	//	delta_t	not set for TMSmaxTmp
	//	delta_val	not set for TMSmaxTmp
	
	tmsmaxtmp->set_default_properties(tmsmaxtmp_prop);
	//	Not Polled
	tmsmaxtmp->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(tmsmaxtmp);

	//	Attribute : HeatType
	HeatTypeAttrib	*heattype = new HeatTypeAttrib();
	Tango::UserDefaultAttrProp	heattype_prop;
	heattype_prop.set_description("Heating type 0=conventional heating, 1=TMS");
	heattype_prop.set_label("HeatType (335)");
	//	unit	not set for HeatType
	//	standard_unit	not set for HeatType
	//	display_unit	not set for HeatType
	//	format	not set for HeatType
	heattype_prop.set_max_value("1");
	heattype_prop.set_min_value("0");
	//	max_alarm	not set for HeatType
	//	min_alarm	not set for HeatType
	//	max_warning	not set for HeatType
	//	min_warning	not set for HeatType
	//	delta_t	not set for HeatType
	//	delta_val	not set for HeatType
	
	heattype->set_default_properties(heattype_prop);
	//	Not Polled
	heattype->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(heattype);

	//	Attribute : TMSheatset
	TMSheatsetAttrib	*tmsheatset = new TMSheatsetAttrib();
	Tango::UserDefaultAttrProp	tmsheatset_prop;
	tmsheatset_prop.set_description("TMS heating temperature set value");
	tmsheatset_prop.set_label("TMSheatset (704)");
	tmsheatset_prop.set_unit("C");
	//	standard_unit	not set for TMSheatset
	//	display_unit	not set for TMSheatset
	//	format	not set for TMSheatset
	tmsheatset_prop.set_max_value("90");
	tmsheatset_prop.set_min_value("30");
	//	max_alarm	not set for TMSheatset
	//	min_alarm	not set for TMSheatset
	//	max_warning	not set for TMSheatset
	//	min_warning	not set for TMSheatset
	//	delta_t	not set for TMSheatset
	//	delta_val	not set for TMSheatset
	
	tmsheatset->set_default_properties(tmsheatset_prop);
	//	Not Polled
	tmsheatset->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(tmsheatset);

	//	Attribute : SetRotSpdHz - Check if not concrete in inherited class
	Tango::Attr *SetRotSpdHzAttr = get_attr_object_by_name(att_list, "SetRotSpdHz");
	if (SetRotSpdHzAttr == NULL)
	{
	}

	//	Attribute : ActualSpdHz - Check if not concrete in inherited class
	Tango::Attr *ActualSpdHzAttr = get_attr_object_by_name(att_list, "ActualSpdHz");
	if (ActualSpdHzAttr == NULL)
	{
	}

	//	Attribute : NominalSpdHz - Check if not concrete in inherited class
	Tango::Attr *NominalSpdHzAttr = get_attr_object_by_name(att_list, "NominalSpdHz");
	if (NominalSpdHzAttr == NULL)
	{
	}

	//	Attribute : ErrHist - Check if not concrete in inherited class
	Tango::Attr *ErrHistAttr = get_attr_object_by_name(att_list, "ErrHist");
	if (ErrHistAttr == NULL)
	{
	}


	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(Tc600Class::attribute_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Tc600Class::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : Tc600Class::pipe_factory()
 *	Description : Create the pipe object(s)
 *                and store them in the pipe list
 */
//--------------------------------------------------------
void Tc600Class::pipe_factory()
{
	/*----- PROTECTED REGION ID(Tc600Class::pipe_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Tc600Class::pipe_factory_before
	/*----- PROTECTED REGION ID(Tc600Class::pipe_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Tc600Class::pipe_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : Tc600Class::command_factory()
 *	Description : Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void Tc600Class::command_factory()
{
	/*----- PROTECTED REGION ID(Tc600Class::command_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Tc600Class::command_factory_before
	//	Call command_factory for inherited class
	Hipace_ns::HipaceClass::command_factory();



	/*----- PROTECTED REGION ID(Tc600Class::command_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Tc600Class::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		Tc600Class::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list
 */
//--------------------------------------------------------
void Tc600Class::create_static_attribute_list(vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	cout2 << defaultAttList.size() << " attributes in default list" << endl;

	/*----- PROTECTED REGION ID(Tc600Class::create_static_att_list) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc600Class::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		Tc600Class::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void Tc600Class::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((string)(*devlist_ptr)[i]).c_str());
		Tc600 *dev = static_cast<Tc600 *> (dev_impl);

		vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			vector<string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				cout2 << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(Tc600Class::erase_dynamic_attributes) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc600Class::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : Tc600Class::get_attr_by_name()
 *	Description : returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *Tc600Class::get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname)
{
	vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; ++it)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(Tc600Class::Additional Methods) ENABLED START -----*/

/*----- PROTECTED REGION END -----*/	//	Tc600Class::Additional Methods
} //	namespace
