/*----- PROTECTED REGION ID(Tc600Class.h) ENABLED START -----*/
//=============================================================================
//
// file :        Tc600Class.h
//
// description : Include for the Tc600 root class.
//               This class is the singleton class for
//                the Tc600 device class.
//               It contains all properties and methods which the 
//               Tc600 requires only once e.g. the commands.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.1 $
// $Date: 2014-03-25 14:04:05 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef Tc600Class_H
#define Tc600Class_H

#include <tango.h>
#include <HipaceClass.h>
#include <Tc600.h>


/*----- PROTECTED REGION END -----*/	//	Tc600Class.h


namespace Tc600_ns
{
/*----- PROTECTED REGION ID(Tc600Class::classes for dynamic creation) ENABLED START -----*/


/*----- PROTECTED REGION END -----*/	//	Tc600Class::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute BreakEnab class definition
class BreakEnabAttrib: public Tango::Attr
{
public:
	BreakEnabAttrib():Attr("BreakEnab",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~BreakEnabAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Tc600 *>(dev))->read_BreakEnab(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Tc600 *>(dev))->write_BreakEnab(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Tc600 *>(dev))->is_BreakEnab_allowed(ty);}
};

//	Attribute OpModeRem class definition
class OpModeRemAttrib: public Tango::Attr
{
public:
	OpModeRemAttrib():Attr("OpModeRem",
			Tango::DEV_USHORT, Tango::READ_WRITE) {};
	~OpModeRemAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Tc600 *>(dev))->read_OpModeRem(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Tc600 *>(dev))->write_OpModeRem(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Tc600 *>(dev))->is_OpModeRem_allowed(ty);}
};

//	Attribute OilDefic class definition
class OilDeficAttrib: public Tango::Attr
{
public:
	OilDeficAttrib():Attr("OilDefic",
			Tango::DEV_BOOLEAN, Tango::READ) {};
	~OilDeficAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Tc600 *>(dev))->read_OilDefic(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Tc600 *>(dev))->is_OilDefic_allowed(ty);}
};

//	Attribute OpModeDrv class definition
class OpModeDrvAttrib: public Tango::Attr
{
public:
	OpModeDrvAttrib():Attr("OpModeDrv",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~OpModeDrvAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Tc600 *>(dev))->read_OpModeDrv(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Tc600 *>(dev))->write_OpModeDrv(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Tc600 *>(dev))->is_OpModeDrv_allowed(ty);}
};

//	Attribute CfgDO4 class definition
class CfgDO4Attrib: public Tango::Attr
{
public:
	CfgDO4Attrib():Attr("CfgDO4",
			Tango::DEV_USHORT, Tango::READ_WRITE) {};
	~CfgDO4Attrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Tc600 *>(dev))->read_CfgDO4(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Tc600 *>(dev))->write_CfgDO4(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Tc600 *>(dev))->is_CfgDO4_allowed(ty);}
};

//	Attribute TMSActTmp class definition
class TMSActTmpAttrib: public Tango::Attr
{
public:
	TMSActTmpAttrib():Attr("TMSActTmp",
			Tango::DEV_ULONG, Tango::READ) {};
	~TMSActTmpAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Tc600 *>(dev))->read_TMSActTmp(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Tc600 *>(dev))->is_TMSActTmp_allowed(ty);}
};

//	Attribute TMSsteady class definition
class TMSsteadyAttrib: public Tango::Attr
{
public:
	TMSsteadyAttrib():Attr("TMSsteady",
			Tango::DEV_BOOLEAN, Tango::READ) {};
	~TMSsteadyAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Tc600 *>(dev))->read_TMSsteady(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Tc600 *>(dev))->is_TMSsteady_allowed(ty);}
};

//	Attribute TMSmaxTmp class definition
class TMSmaxTmpAttrib: public Tango::Attr
{
public:
	TMSmaxTmpAttrib():Attr("TMSmaxTmp",
			Tango::DEV_ULONG, Tango::READ) {};
	~TMSmaxTmpAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Tc600 *>(dev))->read_TMSmaxTmp(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Tc600 *>(dev))->is_TMSmaxTmp_allowed(ty);}
};

//	Attribute HeatType class definition
class HeatTypeAttrib: public Tango::Attr
{
public:
	HeatTypeAttrib():Attr("HeatType",
			Tango::DEV_USHORT, Tango::READ) {};
	~HeatTypeAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Tc600 *>(dev))->read_HeatType(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Tc600 *>(dev))->is_HeatType_allowed(ty);}
};

//	Attribute TMSheatset class definition
class TMSheatsetAttrib: public Tango::Attr
{
public:
	TMSheatsetAttrib():Attr("TMSheatset",
			Tango::DEV_ULONG, Tango::READ_WRITE) {};
	~TMSheatsetAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Tc600 *>(dev))->read_TMSheatset(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Tc600 *>(dev))->write_TMSheatset(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Tc600 *>(dev))->is_TMSheatset_allowed(ty);}
};


/**
 *	The Tc600Class singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  Tc600Class : public Hipace_ns::HipaceClass
#else
class Tc600Class : public Hipace_ns::HipaceClass
#endif
{
	/*----- PROTECTED REGION ID(Tc600Class::Additionnal DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Tc600Class::Additionnal DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
	
		//	Method prototypes
		static Tc600Class *init(const char *);
		static Tc600Class *instance();
		~Tc600Class();
		Tango::DbDatum	get_class_property(string &);
		Tango::DbDatum	get_default_device_property(string &);
		Tango::DbDatum	get_default_class_property(string &);
	
	protected:
		Tc600Class(string &);
		static Tc600Class *_instance;
		void command_factory();
		void attribute_factory(vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		string get_cvstag();
		string get_cvsroot();
	
	private:
		void device_factory(const Tango::DevVarStringArray *);
		void create_static_attribute_list(vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
		vector<string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname);
};

}	//	End of namespace

#endif   //	Tc600_H
