/*----- PROTECTED REGION ID(Tc600StateMachine.cpp) ENABLED START -----*/
static const char *RcsId = "$Id: Tc600StateMachine.cpp,v 1.1 2014-03-25 14:04:05 alessio Exp $";
//=============================================================================
//
// file :        Tc600StateMachine.cpp
//
// description : State machine file for the Tc600 class
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.1 $
// $Date: 2014-03-25 14:04:05 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include <Tc600.h>

/*----- PROTECTED REGION END -----*/	//	Tc600::Tc600StateMachine.cpp

//================================================================
//  States   |  Description
//================================================================
//  ON       |  
//  FAULT    |  
//  ALARM    |  
//  UNKNOWN  |  


namespace Tc600_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : Tc600::is_BreakEnab_allowed()
 *	Description : Execution allowed for BreakEnab attribute
 */
//--------------------------------------------------------
bool Tc600::is_BreakEnab_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for BreakEnab attribute in Write access.
	/*----- PROTECTED REGION ID(Tc600::BreakEnabStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc600::BreakEnabStateAllowed_WRITE

	//	Not any excluded states for BreakEnab attribute in read access.
	/*----- PROTECTED REGION ID(Tc600::BreakEnabStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc600::BreakEnabStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Tc600::is_OpModeRem_allowed()
 *	Description : Execution allowed for OpModeRem attribute
 */
//--------------------------------------------------------
bool Tc600::is_OpModeRem_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for OpModeRem attribute in Write access.
	/*----- PROTECTED REGION ID(Tc600::OpModeRemStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc600::OpModeRemStateAllowed_WRITE

	//	Not any excluded states for OpModeRem attribute in read access.
	/*----- PROTECTED REGION ID(Tc600::OpModeRemStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc600::OpModeRemStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Tc600::is_OilDefic_allowed()
 *	Description : Execution allowed for OilDefic attribute
 */
//--------------------------------------------------------
bool Tc600::is_OilDefic_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for OilDefic attribute in read access.
	/*----- PROTECTED REGION ID(Tc600::OilDeficStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc600::OilDeficStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Tc600::is_OpModeDrv_allowed()
 *	Description : Execution allowed for OpModeDrv attribute
 */
//--------------------------------------------------------
bool Tc600::is_OpModeDrv_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for OpModeDrv attribute in Write access.
	/*----- PROTECTED REGION ID(Tc600::OpModeDrvStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc600::OpModeDrvStateAllowed_WRITE

	//	Not any excluded states for OpModeDrv attribute in read access.
	/*----- PROTECTED REGION ID(Tc600::OpModeDrvStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc600::OpModeDrvStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Tc600::is_CfgDO4_allowed()
 *	Description : Execution allowed for CfgDO4 attribute
 */
//--------------------------------------------------------
bool Tc600::is_CfgDO4_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for CfgDO4 attribute in Write access.
	/*----- PROTECTED REGION ID(Tc600::CfgDO4StateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc600::CfgDO4StateAllowed_WRITE

	//	Not any excluded states for CfgDO4 attribute in read access.
	/*----- PROTECTED REGION ID(Tc600::CfgDO4StateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc600::CfgDO4StateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Tc600::is_TMSActTmp_allowed()
 *	Description : Execution allowed for TMSActTmp attribute
 */
//--------------------------------------------------------
bool Tc600::is_TMSActTmp_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for TMSActTmp attribute in read access.
	/*----- PROTECTED REGION ID(Tc600::TMSActTmpStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc600::TMSActTmpStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Tc600::is_TMSsteady_allowed()
 *	Description : Execution allowed for TMSsteady attribute
 */
//--------------------------------------------------------
bool Tc600::is_TMSsteady_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for TMSsteady attribute in read access.
	/*----- PROTECTED REGION ID(Tc600::TMSsteadyStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc600::TMSsteadyStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Tc600::is_TMSmaxTmp_allowed()
 *	Description : Execution allowed for TMSmaxTmp attribute
 */
//--------------------------------------------------------
bool Tc600::is_TMSmaxTmp_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for TMSmaxTmp attribute in read access.
	/*----- PROTECTED REGION ID(Tc600::TMSmaxTmpStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc600::TMSmaxTmpStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Tc600::is_HeatType_allowed()
 *	Description : Execution allowed for HeatType attribute
 */
//--------------------------------------------------------
bool Tc600::is_HeatType_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for HeatType attribute in read access.
	/*----- PROTECTED REGION ID(Tc600::HeatTypeStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc600::HeatTypeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Tc600::is_TMSheatset_allowed()
 *	Description : Execution allowed for TMSheatset attribute
 */
//--------------------------------------------------------
bool Tc600::is_TMSheatset_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for TMSheatset attribute in Write access.
	/*----- PROTECTED REGION ID(Tc600::TMSheatsetStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc600::TMSheatsetStateAllowed_WRITE

	//	Not any excluded states for TMSheatset attribute in read access.
	/*----- PROTECTED REGION ID(Tc600::TMSheatsetStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Tc600::TMSheatsetStateAllowed_READ
	return true;
}


//=================================================
//		Commands Allowed Methods
//=================================================


/*----- PROTECTED REGION ID(Tc600::Tc600StateAllowed.AdditionalMethods) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	Tc600::Tc600StateAllowed.AdditionalMethods

}	//	End of namespace
